* SUBROUTINE EFGU08             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR PROGRAMMING.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FF  VALUE OF THE OBJECTIVE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFGU08(N,X,GF,NEXT)
      INTEGER N,NEXT
      INTEGER I
      REAL*8 X(N),GF(N)
      REAL*8 Y(20)
      COMMON /EMPR08/ Y
      REAL*8 X1,X2,X3
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     * 180,190,200,210,220,230,240,250,260,270,280,290,300,310),NEXT
   10 GF(1)=X(2)**2
      GF(2)=2.0D 0*X(1)*X(2)
      RETURN
   20 GF(1)=-1.0D 0+2.0D 1*X(1)
      GF(2)= 2.0D 1*X(2)
      RETURN
   30 GF(1)=-400.0D 0*(X(2)-X(1)**2)*X(1)-2.0D 0*(1.0D 0-X(1))
      GF(2)= 200.0D 0*(X(2)-X(1)**2)
      RETURN
   40 GF(1)=-2.0D 0*(1.0D 0-X(1))
      GF(2)= 0.0D 0
      RETURN
   50 GF(1)=2.0D 0*X(1)/(1.0D 0+X(1)**2)
      GF(2)=-1.0D 0
      RETURN
   60 GF(1)=-1.0D 0
      GF(2)= 0.0D 0
      RETURN
   70 GF(1)= 2.0D 0*(X(1)-X(2))
      GF(2)=-2.0D 0*(X(1)-X(2))+4.0D 0*(X(2)-X(3))**3
      GF(3)=-4.0D 0*(X(2)-X(3))**3
      RETURN
   80 GF(1)=2.0D-2*(X(1)-1.0D 0)-4.0D 0*(X(2)-X(1)**2)*X(1)
      GF(2)=2.0D 0*(X(2)-X(1)**2)
      GF(3)=0.0D 0
      RETURN
   90 GF(1)= 2.0D 0*(X(1)-1.0D 0)+2.0D 0*(X(1)-X(2))
      GF(2)=-2.0D 0*(X(1)-X(2))+4.0D 0*(X(2)-X(3))**3
      GF(3)=-4.0D 0*(X(2)-X(3))**3
      RETURN
  100 GF(1)= 1.0D 0
      GF(2)=-1.0D 0+3.0D 0*X(2)**2
      GF(3)= 0.0D 0
      RETURN
  110 GF(1)=8.0D 0*X(1)-33.0D 0
      GF(2)=4.0D 0*X(2)+16.0D 0
      GF(3)=4.0D 0*X(3)-24.0D 0
      RETURN
  120 GF(1)=-2.0D 0*X(1)-X(2)-X(3)
      GF(2)=-4.0D 0*X(2)-X(1)
      GF(3)=-2.0D 0*X(3)-X(1)
      RETURN
  130 GF(1)=1.0D-3
      GF(2)=1.0D 0
      GF(3)=0.0D 0
      RETURN
  140 GF(1)=-1.0D 0
      GF(2)= 0.0D 0
      GF(3)= 0.0D 0
      GF(4)= 0.0D 0
      RETURN
  150 GF(1)=2.0D 0*(X(1)-1.0D 0)
      GF(2)=2.0D 0*(X(2)-2.0D 0)
      GF(3)=2.0D 0*(X(3)-3.0D 0)
      GF(4)=2.0D 0*(X(4)-4.0D 0)
      RETURN
  160 X1=EXP(X(1))
      X2=X1-1.0D 0+X(4)
      X3=X1-1.0D 0-X(3)
      GF(1)=-(0.0024D 0-X(4)*X3/X2)/X(1)**2-
     * X(4)*(X(3)+X(4))*X1/(X(1)*X2**2)
      GF(2)=0.0D 0
      GF(3)=X(4)/(X(1)*X2)
      GF(4)=-X3*(X1-1.0D 0)/(X(1)*X2**2)
      RETURN
  170 GF(1)=0.0D 0
      GF(2)=0.0D 0
      GF(3)=0.0D 0
      GF(4)=0.0D 0
      GF(5)=2.0D 0*X(5)
      RETURN
  180 GF(1)=2.0D 0*X(1)
      GF(2)=2.0D 0*X(2)
      GF(3)=2.0D 0*X(3)
      GF(4)=0.0D 0
      GF(5)=0.0D 0
      RETURN
  190 GF(1)= 2.0D 0*(X(1)-X(2))
      GF(2)=-2.0D 0*(X(1)-X(2))
      GF(3)= 2.0D 0*(X(3)-1.0D 0)
      GF(4)= 4.0D 0*(X(4)-1.0D 0)**3
      GF(5)= 6.0D 0*(X(5)-1.0D 0)**5
      RETURN
  200 GF(1)= 2.0D 0*(X(1)-1.0D 0)+2.0D 0*(X(1)-X(2))
      GF(2)=-2.0D 0*(X(1)-X(2))
      GF(3)= 2.0D 0*(X(3)-1.0D 0)
      GF(4)= 4.0D 0*(X(4)-1.0D 0)**3
      GF(5)= 6.0D 0*(X(5)-1.0D 0)**5
      RETURN
  210 GF(1)= 4.0D 0*(X(1)-X(2))**3
      GF(2)=-4.0D 0*(X(1)-X(2))**3+2.0D 0*(X(2)+X(3)-2.0D 0)
      GF(3)= 2.0D 0*(X(2)+X(3)-2.0D 0)
      GF(4)= 2.0D 0*(X(4)-1.0D 0)
      GF(5)= 2.0D 0*(X(5)-1.0D 0)
      RETURN
  220 GF(1)=-400.0D 0*(X(2)-X(1)**2)*X(1)-2.0D 0*(1.0D 0-X(1))
      GF(2)= 200.0D 0*(X(2)-X(1)**2)
      GF(3)= 0.0D 0
      GF(4)= 0.0D 0
      GF(5)= 0.0D 0
      RETURN
  230 GF(1)=2.0D-2*X(1)
      GF(2)=2.0D 0*X(2)
      GF(3)= 0.0D 0
      GF(4)= 0.0D 0
      GF(5)= 0.0D 0
      RETURN
  240 GF(1)= 2.0D 0*(X(1)-X(2))
      GF(2)=-2.0D 0*(X(1)-X(2))+2.0D 0*(X(2)-X(3))
      GF(3)=-2.0D 0*(X(2)-X(3))+4.0D 0*(X(3)-X(4))**3
      GF(4)=-4.0D 0*(X(3)-X(4))**3+4.0D 0*(X(4)-X(5))**3
      GF(5)=-4.0D 0*(X(4)-X(5))**3
      RETURN
  250 X1=X(1)*X(2)*X(3)*X(4)*X(5)
      GF(1)=X1/X(1)
      GF(2)=X1/X(2)
      GF(3)=X1/X(3)
      GF(4)=X1/X(4)
      GF(5)=X1/X(5)
      RETURN
  260 GF(1)= 2.0D 0*(X(1)-1.0D 0)+2.0D 0*(X(1)-X(2))
      GF(2)=-2.0D 0*(X(1)-X(2))+2.0D 0*(X(2)-X(3))
      GF(3)=-2.0D 0*(X(2)-X(3))+4.0D 0*(X(3)-X(4))**3
      GF(4)=-4.0D 0*(X(3)-X(4))**3+4.0D 0*(X(4)-X(5))**3
      GF(5)=-4.0D 0*(X(4)-X(5))**3
      RETURN
  270 X1=X(1)*X(2)*X(3)*X(4)*X(5)
      X1=X1*EXP(X1)
      GF(1)=X1/X(1)
      GF(2)=X1/X(2)
      GF(3)=X1/X(3)
      GF(4)=X1/X(4)
      GF(5)=X1/X(5)
      RETURN
  280 X1=X(1)*X(2)*X(3)*X(4)*X(5)
      X1=X1*EXP(X1)
      X2=X(1)**3+X(2)**3+1.0D 0
      GF(1)=X1/X(1)-3.0D 0*X2*X(1)**2
      GF(2)=X1/X(2)-3.0D 0*X2*X(2)**2
      GF(3)=X1/X(3)
      GF(4)=X1/X(4)
      GF(5)=X1/X(5)
      RETURN
  290 IF (X(1).LT.300.0D 0) THEN
      GF(1)=30.0D 0
      ELSE
      GF(1)=31.0D 0
      ENDIF
      IF (X(2).LT.100.0D 0) THEN
      GF(2)=28.0D 0
      ELSE IF (X(2).LT.200.0D 0) THEN
      GF(2)=29.0D 0
      ELSE
      GF(2)=30.0D 0
      ENDIF
      GF(3)=0.0D 0
      GF(4)=0.0D 0
      GF(5)=0.0D 0
      GF(6)=0.0D 0
      RETURN
  300 X1=1250.0D 0*(COS(X(1))+COS(X(2)))+3750.0D 0*(COS(X(3))+
     * COS(X(4))+COS(X(5)))+9000.0D 0*(COS(X(6))+COS(X(7)))
      GF(1)=X1*2500.0D 0*SIN(X(1))
      GF(2)=X1*2500.0D 0*SIN(X(2))
      GF(3)=X1*7500.0D 0*SIN(X(3))
      GF(4)=X1*7500.0D 0*SIN(X(4))
      GF(5)=X1*7500.0D 0*SIN(X(5))
      GF(6)=X1*1800.0D 1*SIN(X(6))
      GF(7)=X1*1800.0D 1*SIN(X(7))
      RETURN
  310 X1=0.0D 0
      DO 311 I=1,10
      Y(I+10)=EXP(X(I))
      X1=X1+Y(I+10)
  311 CONTINUE
      X1=LOG(X1)
      DO 312 I=1,10
      GF(I)=Y(I+10)*(Y(I)+X(I)-X1)
  312 CONTINUE
      RETURN
      END
