* SUBROUTINE EFGU23                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFGU23(N,NA,X,G,NEXT)
      INTEGER N,NA,NEXT
      REAL*8 X(N),G(N)
      REAL*8 FA,GA(2000)
      INTEGER KA
      IF (NEXT.LE.22) THEN
      CALL EFGU14(N,X,G,NEXT)
      ELSE IF (NEXT.LE.44) THEN
      CALL UXVSET(N,0.0D 0,G)
      DO 2 KA=1,NA
      CALL UXVSET(N,0.0D 0,GA)
      CALL EAFU15(N,KA,X,FA,NEXT-22)
      CALL EAGU15(N,KA,X,GA,NEXT-22)
      CALL UXVDIR(N,FA,GA,G,G)
    2 CONTINUE
      ELSE IF (NEXT.LE.74) THEN
      CALL UXVSET(N,0.0D 0,G)
      DO 3 KA=1,NA
      CALL UXVSET(N,0.0D 0,GA)
      CALL EAFU18(N,KA,X,FA,NEXT-44)
      CALL EAGU18(N,KA,X,GA,NEXT-44)
      CALL UXVDIR(N,FA,GA,G,G)
    3 CONTINUE
      ENDIF
      RETURN
      END
