* SUBROUTINE EYGU30             ALL SYSTEMS                 93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR PARAMETER ESTIMATION OF DYNAMICAL
*  SYSTEMS. UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RO  GE(N)  GRADIENT OF THE INITIAL VALUE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EYGU30(N,KE,GE,NEXT)
      INTEGER I,N,KE,NEXT
      REAL*8 GE(N)
      DO 1 I=1,N
      GE(I)=0.0D 0
    1 CONTINUE
      GOTO (10,10,30,40),NEXT
   10 GOTO (11,12,13,14),KE
   11 GE(1)=1.0D 0
      RETURN
   12 CONTINUE
      RETURN
   13 GE(2)=1.0D 0
      RETURN
   14 CONTINUE
      RETURN
   30 GOTO (31,32,33,34,35),KE
   31 CONTINUE
      RETURN
   32 CONTINUE
      RETURN
   33 GE(1)=1.0D 0
      RETURN
   34 CONTINUE
      RETURN
   35 GE(2)=1.0D 0
      RETURN
   40 GOTO (41,42,43,44,45),KE
   41 CONTINUE
      RETURN
   42 GE(1)=1.0D 0
      RETURN
   43 CONTINUE
      RETURN
   44 GE(2)=1.0D 0
      RETURN
   45 CONTINUE
      RETURN
      END
