* SUBROUTINE UCNOR1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE SCALING FACTORS.
*
* PARAMETERS :
*  II  NC NUMBER OF APPROXIMATED FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RO  CW(NC)  VECTOR OF SCALING FACTORS.
*  II  NORMC  SCALING SPECIFICATION. NORMC=0-NO SCALING IS PERFORMED.
*         NORMC=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMC=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UCNOR1(NC,IC,CW,NORMC)
      INTEGER NC,IC(NC),NORMC
      REAL*8 CW(NC)
      INTEGER KC
      DO 1 KC=1,NC
      IF (NORMC.LE.0) RETURN
      IF (NORMC.EQ.1) THEN
      IF (IC(KC).EQ.0) THEN
      CW(KC)=1.0D 0
      ELSE
      CW(KC)=1.0D 0
      ENDIF
      ENDIF
      IF (CW(KC).LE.0.0D 0) CW(KC)=1.0D 0
    1 CONTINUE
      RETURN
      END
