* SUBROUTINE UOJRF3                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRAPHICAL OUTPUT - PATH.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XPA(NPA,2)  VALUES OF SELECTED VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UOJRF3(NF,X,XPA,FL,F,FO,ETA9)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM(4),LLC(28)
      COMMON /UMGRFI/ IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM,LLC
      REAL*8 XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,RGCOM(2)
      COMMON /UMGRFR/ XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,
     & RGCOM
      INTEGER NF
      REAL*4 FL(NGR,NGR),XPA(NPA,2)
      REAL*8 X(NF),F,FO,ETA9
      REAL*8 STIGR,STJGR
      REAL*8 CON1,CON2
      PARAMETER(CON1=1.0D-60,CON2=1.0D 60)
      INTEGER IVAR,JVAR,I,IPAC,NPAC
      SAVE IVAR,JVAR,IPAC,NPAC,STIGR,STJGR
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,4) ISP(NS)
    1 CONTINUE
      IPA=MIN(NPA,NIT)
C
C     COMPUTATION OF BOUNDS
C
      NPAC=MIN(NPA,NIT)
      IPAC=MAX(NPAC-IPA+1,1)
      XLIGR=X(IGR)
      XUIGR=X(IGR)
      XLJGR=X(JGR)
      XUJGR=X(JGR)
      DO 13 I=IPAC,NPAC
      XLIGR=MIN(XLIGR,DBLE(XPA(I,1)))
      XUIGR=MAX(XUIGR,DBLE(XPA(I,1)))
      XLJGR=MIN(XLJGR,DBLE(XPA(I,2)))
      XUJGR=MAX(XUJGR,DBLE(XPA(I,2)))
   13 CONTINUE
      STIGR=MAX((XUIGR-XLIGR)/TEN,(XUIGR+XLIGR)*1D-6,1.0D-16)
      STJGR=MAX((XUJGR-XLJGR)/TEN,(XUJGR+XLJGR)*1D-6,1.0D-16)
      XLIGR=XLIGR-STIGR
      XUIGR=XUIGR+STIGR
      XLJGR=XLJGR-STJGR
      XUJGR=XUJGR+STJGR
      FO=F
      XIGR=X(IGR)
      XJGR=X(JGR)
      STIGR=(XUIGR-XLIGR)/(NGR-1)
      STJGR=(XUJGR-XLJGR)/(NGR-1)
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    2 IVAR=IVAR+1
      X(IGR)=XLIGR+(IVAR-1)*STIGR
      JVAR=0
    3 JVAR=JVAR+1
      X(JGR)=XLJGR+(JVAR-1)*STJGR
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) THEN
      VALMIN=FL(IVAR,JVAR)
      IMIN=IVAR
      JMIN=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 3
      IF (IVAR.LT.NGR) GO TO 2
      X(IGR)=XIGR
      X(JGR)=XJGR
      F=FO
      WRITE(15,'(I5,I5,4D20.12)') 1,NGR,FO,VALMIN,VALMAX
      WRITE(15,'(I5,I5,3D20.12)') IGR,IMIN,XIGR,XLIGR,XUIGR
      WRITE(15,'(I5,I5,3D20.12)') JGR,JMIN,XJGR,XLJGR,XUJGR
      WRITE(15,'(4D20.12)')((FL(IVAR,JVAR),IVAR=1,NGR),JVAR=1,NGR)
      CALL UYEPI1(0)
      RETURN
      END
