* SUBROUTINE UOTES4                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION FOR SIMULTANEOUS TESTS.
*
* COMMON DATA :
*  II  NIT  NUMBER OF ITERATIONS.
*  II  NFV  NUMBER OF FUNCTION VALUE EVALUATIONS.
*  II  NFG  NUMBER OF FUNCTION GRADIENT EVALUATIONS.
*  II  NDC  NUMBER OF MATRIX DECOMPOSITIONS
*
      SUBROUTINE UOTES4
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NFD,NAD,NCD,NED,NITT,NFVT,NFGT,NFHT,NDCT,NCGT,
     & NLST,NSCT,NUPT,NMXT,NRST,NADT,NRMT,NSUC,NTOT,NTIM,ITIM
      COMMON /UMTEST/ NFD,NAD,NCD,NED,NITT,NFVT,NFGT,NFHT,NDCT,NCGT,
     & NLST,NSCT,NUPT,NMXT,NRST,NADT,NRMT,NSUC,NTOT,NTIM,ITIM
      WRITE(ITR,55) NITT,NFVT,NFGT,NDCT,NSUC,NCGT,NLST,NSCT,NUPT,NRST,
     & NMXT,NADT,NRMT
      IF (KOUT.EQ.0.AND.LOUT.GT.0) THEN
      WRITE(IWR,55) NITT,NFVT,NFGT,NDCT,NSUC,NCGT,NLST,NSCT,NUPT,NRST,
     & NMXT,NADT,NRMT
      ENDIF
   55 FORMAT(' TOTAL',3X,'NIT=',I8,3X,'NFV=',I8,3X,'NFG=',I8,3X,'NDC=',
     & I8,' * ',I5/9X,'NCG=',I8,3X,'NLS=',I8,3X,'NSC=',I8,3X,'NUP=',
     & I8/9X,'NRS=',I8,3X,'NMX=',I8,3X,'NAD=',I8,3X,'NRM=',I8)
      CALL UYTIM2(ITIM)
      NITT=0
      NFVT=0
      NFGT=0
      NFHT=0
      NDCT=0
      NCGT=0
      NLST=0
      NSCT=0
      NUPT=0
      NRST=0
      NMXT=0
      NADT=0
      NRMT=0
      NSUC=0
      NTOT=0
      RETURN
      END
