* SUBROUTINE UP0BA1             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AS(NA)  VECTOR OF SLACK VARIABLES.
*  RI  RPF3  BARRIER COEFFICIENT.
*  RO  F  VALUE OF THE BARRIERY FUNCTION.
*
      SUBROUTINE UP0BA1(NA,AS,RPF3,F)
      INTEGER NA
      REAL*8 AS(NA),RPF3,F
      INTEGER KA
      F=-DBLE(NA)*RPF3*LOG(2.0D 0*RPF3)
      DO 1 KA=1,NA
      F=F+AS(KA)-RPF3*LOG(AS(KA))
    1 CONTINUE
      RETURN
      END
