* LOGICAL FUNCTION UQSTRC          ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  COMPARISON OF TWO SUBSTRINGS
*
* PARAMETERS :
*  TI  STRAR1(MLEN1) - A STRING ARRAY
*  II  MLEN1 - MAX. LENGTH OF STRAR1
*  II  IPOS11 - POSITION OF THE FIRST CHARACTER OF A SUBSTRING IN STRAR1
*  II  IPOS12 - POSITION OF THE LAST CHARACTER OF A SUBSTRING IN STRAR1
*  TI  STRAR2(MLEN2) - A STRING ARRAY
*  II  MLEN2 - MAX. LENGTH OF STRAR2
*  II  IPOS21 - POSITION OF THE FIRST CHARACTER OF A SUBSTRING IN STRAR2
*  II  IPOS22 - POSITION OF THE LAST CHARACTER OF A SUBSTRING IN STRAR2
*
* SUBPROGRAMS USED :
*  LF  UQCHEQ   COMPARISON OF TWO CHARACTERS
*
      LOGICAL FUNCTION UQSTRC(STRAR1,MLEN1,IPOS11,IPOS12,
     *                        STRAR2,MLEN2,IPOS21,IPOS22)
      INTEGER MLEN1,IPOS11,IPOS12,MLEN2,IPOS21,IPOS22
      CHARACTER*1 STRAR1(MLEN1),STRAR2(MLEN2)
      INTEGER I
      LOGICAL UQCHEQ
      UQSTRC=.FALSE.
      IF(IPOS12-IPOS11.EQ.IPOS22-IPOS21) THEN
        DO 1 I=0,IPOS12-IPOS11
          IF(.NOT.UQCHEQ(STRAR1(IPOS11+I),STRAR2(IPOS21+I))) RETURN
    1   CONTINUE
        UQSTRC=.TRUE.
      ENDIF
      RETURN
      END
