* SUBROUTINE UXDRDM                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR X IS PREMULTIPLIED BY THE DIAGONAL OF THE MATRIX R IN THE
* FACTORIZATION A=TRANS(R)*R..
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  FACTORIZATION A=TRANS(R)*R.
*  RU  X(N)  ELEMENTS OF THE VECTOR X.
*
      SUBROUTINE UXDRDM(N,A,X)
      INTEGER N
      REAL*8  A(N*(N+1)/2), X(N)
      INTEGER I,J
      J = 0
      DO  1  I = 1, N
      J = J + I
      X(I)=X(I)*A(J)
    1 CONTINUE
      RETURN
      END
