* SUBROUTINE UXIIGR                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDS AND UXSGDF FROM UMFPACK.
*
      SUBROUTINE UXIIGR(II,MMEM,PERM2,AFLP,FLEFTC,AN,ERROR,GARBAG)
      INTEGER AN,II(*),MMEM(7,2),FLEFTC(AN),PERM2(AN,2),AFP,
     & WHAT,PA,PT,AFPNXT,SIZE,PFILL,AFLP(AN,2),RC,I,
     & K,ECOL,P,PF,MARK(2,2),ERROR,GARBAG(2,2),NIL,R,C
      PARAMETER (NIL = 0, R = 1, C = 2)
C
C     COMPRESS AFLIST AT TAIL
C
      PFILL = GARBAG (2,1) - 1
      AFP = PFILL
10    IF (AFP .LT. MMEM (2,1)) GOTO 20
      AFPNXT = II(AFP-2) - 1
      WHAT = II(AFP)
      IF (WHAT .NE. NIL) THEN
C
C     THIS IS NOT DEALLOCATED
C
      IF (WHAT .GT. 0) THEN
      RC = R
      I = WHAT
      ELSE
      RC = C
      I = -WHAT
      ENDIF
      IF (PERM2 (I,RC) .GE. 0) THEN
C
C     THIS IS NOT A PIVOT ROW OR COLUMN, AND IT HAS A
C     NON-NULL AFLIST. COMPRESS LOCALLY AND MOVE IT
C
C
C     COMPRESS THE AFLIST(I,RC) - SCAN TUPLES
C
      PA = II(AFP-1)
      PT = (AFP-2)
      P = PA
514   IF (P .GE. PT) GOTO 513
      ECOL = II(P)
      IF (FLEFTC (ECOL) .EQ. 0) THEN
C
C     DELETE TUPLE IN STATE A
C
      II(P) = II(PA)
      II(P+1) = II(PA+1)
      PA = PA + 2
      P = P + 2
      ENDIF
      P = P + 2
      GOTO 514
513   CONTINUE
      IF (PA .EQ. PT) THEN
C
C     THIS HAS BEEN COMPRESSED TO NOTHING - DELETE IT
C
      AFLP (I,RC) = NIL
      ELSE
      SIZE = AFP - PA + 1
      PF = PFILL - SIZE + 1
      IF (PFILL .NE. AFP) THEN
      IF (PF .GT. AFP) THEN
      DO 30 K = 1, SIZE
      II (PF-1+K) = II (PA-1+K)
30    CONTINUE
      ELSE
      DO 40 K = 1, SIZE
      II (PFILL+1-K) = II (AFP+1-K)
40    CONTINUE
      ENDIF
      AFLP (I,RC) = PFILL
      ENDIF
      II(PFILL-2) = PF
      II(PFILL-1) = PF
      PFILL = PF - 1
      ENDIF
      ELSE
C
C     DELETE THIS AFLIST - AFLP(I,RC) WILL ALREADY BE NIL
C     IF I IS IN ACTIVE, OR, AFLP(I,RC) WILL BE USED BY
C     THE OVERLAPPING ARRAY PERM2(I,RC) (DO NOT MODIFY)
C
      ENDIF
      ENDIF
      AFP = AFPNXT
      GOTO 10
20    CONTINUE
      MARK (1,1) = MMEM (1,1)
      MARK (2,1) = PFILL+1
      CALL UXIRST(MMEM,ERROR,MARK,1)
      IF (ERROR .NE. 0) THEN
      ERROR = 64
      CALL UOERR1('UXIIGR',ERROR)
      ELSE
      ERROR = 0
      ENDIF
      RETURN
      END
