* SUBROUTINE UXSRO0                 ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* THIS SUBROUTINE GIVES THE CONTRIBUTION TO THE DEGREE OF NODE OF THE
* EDGE (NODE,L)
*
*  PARAMETERS :
*  II  NN NUMBER OF COLUMNS.
*  II  NODE FIRST NODE.
*  II  L SECOND NODE.
*  II  BJA1(NN) BEGINNINGS OF THE VECTORS FOR THE VERTICES.
*  II  BJA2(NN) ENDINGS OF THE VECTORS FOR THE VERTICES.
*  IO  LEN  DEGREE CONTRIBUTION.
*
      SUBROUTINE UXSRO0(NN,NODE,L,BJA1,BJA2,LEN)
C
      INTEGER NN,NODE,L,BJA1(NN),BJA2(NN),LEN
      INTEGER KSTRT,KSTOP
C
C COMPUTE INTERSECTION
C
      IF(BJA2(NODE).LT.BJA1(L).OR.BJA1(NODE).GT.BJA2(L)) THEN
        LEN=0
        RETURN
      END IF
      KSTRT=MAX(BJA1(NODE),BJA1(L))
      KSTOP=MIN(BJA2(NODE),BJA2(L))
C
C REDUCED LENGTH OF THE ADDITIONAL PART OF VECTOR FOR NODE
C OVER THE VECTOR OF L
C
      LEN=MAX(0,KSTRT-BJA1(NODE))+MAX(0,BJA2(NODE)-KSTOP)
      RETURN
      END
