* FUNCTION UXVDEL                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  SQUARED NORM OF A SHIFTED VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RR  UXVDEL SQUARED NORM OF Y+A*X.
*
      FUNCTION UXVDEL(N,A,X,Y)
      INTEGER N
      REAL*8  A, X(N), Y(N), UXVDEL
      INTEGER I
      REAL*8 ZERO
      PARAMETER(ZERO=0.0D 0)
      DOUBLE PRECISION TEMP
      TEMP=ZERO
      DO 1 I=1,N
      TEMP=TEMP+(Y(I)+A*X(I))**2
    1 CONTINUE
      UXVDEL=TEMP
      RETURN
      END
