* SUBROUTINE UXVELT               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ELEMENTARY TRANSFORMATION APPLIED TO TWO VECTORS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  FIRST  VECTOR.
*  RO  Y(N)  SECOND VECTOR.
*  II  K  INCREMENT.
*  RI  TAU  ELIMINATION PARAMETER.
*
      SUBROUTINE UXVELT(N,X,Y,K,TAU)
      INTEGER N,K
      REAL*8 X(*),Y(*),TAU
      INTEGER I,J
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      IF (N.LE.ZERO) RETURN
      IF (K.EQ.1) THEN
      DO 1 I=1,N
      Y(I)=Y(I)+TAU*X(I)
    1 CONTINUE
      ELSE
      I=1
      DO 2 J=1,N
      Y(I)=Y(I)+TAU*X(I)
      I=I+K
    2 CONTINUE
      ENDIF
      RETURN
      END
