* SUBROUTINE UXVINA             ALL SYSTEMS                   90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ELEMENTS OF THE INTEGER VECTOR ARE REPLACED BY THEIR ABSOLUTE VALUES.
*
* PARAMETERS :
*  II  N DIMENSION OF THE INTEGER VECTOR.
*  IU  IX(N)  INTEGER VECTOR WHICH IS UPDATED SO THAT IX(I):=ABS(IX(I))
*         FOR ALL I.
*
      SUBROUTINE UXVINA(N,IX)
      INTEGER N,IX(N)
      INTEGER I
      DO 1 I=1,N
      IX(I)=ABS(IX(I))
      IF (IX(I).GT.10) IX(I)=IX(I)-10
    1 CONTINUE
      RETURN
      END
