* SUBROUTINE UXVSAV                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DIFFERENCE OF TWO VECTORS RETURNED IN THE SUBSTRACTED ONE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RU  Y(N)  UPDATE VECTOR WHERE Y:= X - Y.
*
      SUBROUTINE UXVSAV(N,X,Y)
      INTEGER N
      REAL*8  X(N), Y(N)
      REAL*8  TEMP
      INTEGER I
      DO 1 I=1,N
      TEMP = Y(I)
      Y(I) = X(I) - Y(I)
      X(I) = TEMP
    1 CONTINUE
      RETURN
      END
