* FUNCTION UXVVDQ                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXVVDQ=TRANS(X)*D*Y WHERE D IS A
* DIAGONAL MATRIX STORED AS A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  D(N)  DIAGONAL MATRIX STORED AS A VECTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RR  UXVVDQ  COMPUTED NUMBER UXVVDQ=TRANS(X)*D*Y.
*
      FUNCTION UXVVDQ(N,D,X,Y)
      INTEGER N
      REAL*8  D(N), X(N), Y(N), UXVVDQ
      REAL*8  TEMP
      INTEGER  I
      REAL*8 ZERO
      PARAMETER (ZERO = 0.0D 0)
      TEMP = ZERO
      DO  1  I = 1, N
      TEMP = TEMP + X(I)*Y(I)*D(I)
    1 CONTINUE
      UXVVDQ = TEMP
      RETURN
      END
