* SUBROUTINE UYCMAX             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE MAXIMUM CONSTRAINT VIOLATION.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RO  CMAX  MAXIMUM CONSTRAINT VIOLATION.
*
      SUBROUTINE UYCMAX(NC,CF,IC,CL,CU,CMAX)
      INTEGER NC,IC(NC)
      REAL*8 CF(NC),CL(NC),CU(NC),CMAX
      REAL*8 POM,TEMP
      INTEGER KC
      CMAX=0.0D 0
      DO 1 KC=1,NC
      IF (IC(KC).GT.0) THEN
      POM=0.0D 0
      TEMP=CF(KC)
      IF (IC(KC).EQ.1.OR.IC(KC).GE.3) POM=MIN(POM,TEMP-CL(KC))
      IF (IC(KC).EQ.2.OR.IC(KC).GE.3) POM=MIN(POM,CU(KC)-TEMP)
      IF (POM.LT.0.0D 0) THEN
      CMAX=MAX(CMAX,-POM)
      ENDIF
      ENDIF
    1 CONTINUE
      RETURN
      END
