* PROGRAM PROSCI                ALL SYSTEMS                 14/12/01
C PORTABILITY : ALL SYSTEMS
C 14/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  GENERATION OF SCILAB FIGURE FOR PERFORMANCE PROFILES.
*
      PROGRAM PROSCI
      $OPTION(CHEOL='^')
      REAL*8 Y(100)
      INTEGER*2 I,J,K,L,N,S
      INTEGER LEN,M
      CHARACTER*4 PROFILE
      CHARACTER*10 CBOUND
      CHARACTER*14 NAME(4)
      CHARACTER*1 CHAR
      CHARACTER*80 RET
      REAL*8 BOUND
      CALL GET_COMMAND_ARGUMENT(1,PROFILE,LEN,M)
      IF (M.LT.0) PROFILE='NFV'
      CALL GET_COMMAND_ARGUMENT(2,CBOUND,LEN,M)
      IF (M.LT.0) CBOUND='2.0D0'
      READ(CBOUND,'(D10.3)') BOUND
      OPEN(7,FILE='P.PER',STATUS='UNKNOWN')
      OPEN(8,FILE='P.PRO',STATUS='UNKNOWN')
      OPEN(9,FILE='P.sci',STATUS='UNKNOWN')
      CALL UOTES7(PROFILE,BOUND)
      CLOSE(8)
      OPEN(8,FILE='P.PRO',STATUS='UNKNOWN')
      N=21
      M=20
C      WRITE(9,'(A4,21F8.5,A2)') 
C     & ' X=[',(DBLE(I-1)*BOUND/DBLE(M),I=1,N),'];'
      WRITE(9,'(A4,F8.5,A1,F8.5,A1)') 'x=0:',BOUND/DBLE(M),':',BOUND,';'
      READ(8,'(77X,I3)') L
      READ(8,'(A1)') CHAR
      DO 10 K=1,L
      READ(8,'(15X,A14)',END=5) NAME(K)
      READ(8,'(A1)') CHAR
      READ(8,'(8F10.4)')(Y(I),I=1,N)
      READ(8,'(A1)') CHAR
      IF (K.EQ.1) THEN
      WRITE(9,'(A)') 'y1=[ ...'
      S=10
      DO 1 J=0,N/10
      IF (J.EQ.N/10) S=MOD(INT(N),10)
      WRITE(RET,'(10F8.5)') (Y(10*J+I),I=1,S)
      IF (S.GT.0) WRITE(9,'(A,A)') RET(1:LEN_TRIM(RET)),' ...'
    1 CONTINUE
      WRITE(9,'(A)') '];'
      ENDIF
      IF (K.EQ.2) THEN
      WRITE(9,'(A)') 'y2=[ ...'
      S=10
      DO 2 J=0,N/10
      IF (J.EQ.N/10) S=MOD(INT(N),10)
      WRITE(RET,'(10F8.5)') (Y(10*J+I),I=1,S)
      IF (S.GT.0) WRITE(9,'(A,A)') RET(1:LEN_TRIM(RET)),' ...'
    2 CONTINUE
      WRITE(9,'(A)') '];'
      ENDIF
      IF (K.EQ.3) THEN
      WRITE(9,'(A)') 'y3=[ ...'
      S=10
      DO 3 J=0,N/10
      IF (J.EQ.N/10) S=MOD(INT(N),10)
      WRITE(RET,'(10F8.5)') (Y(10*J+I),I=1,S)
      IF (S.GT.0) WRITE(9,'(A,A)') RET(1:LEN_TRIM(RET)),' ...'
    3 CONTINUE
      WRITE(9,'(A)') '];'
      ENDIF
      IF (K.EQ.4) THEN
      WRITE(9,'(A)') 'y4=[ ...'
      S=10
      DO 4 J=0,N/10
      IF (J.EQ.N/10) S=MOD(INT(N),10)
      WRITE(RET,'(10F8.5)') (Y(10*J+I),I=1,S)
      IF (S.GT.0) WRITE(9,'(A,A)') RET(1:LEN_TRIM(RET)),' ...'
    4 CONTINUE
      WRITE(9,'(A)') '];'
      ENDIF
   10 CONTINUE
      IF (L.EQ.2) THEN
      WRITE(9,'(A)') 'plot(x,y1,x,y2);'
      ELSEIF (L.EQ.3) THEN
      WRITE(9,'(A)') 'plot(x,y1,x,y2,x,y3);'
      ELSEIF (L.EQ.4) THEN
      WRITE(9,'(A)') 'plot(x,y1,x,y2,x,y3,x,y4);'
      ENDIF
      WRITE(9,'(A)') 'a=gca();'
      WRITE(9,'(A)') 'a.font_size=3;'
      WRITE(9,'(A)') 'e=gce();'
C
      WRITE(9,'(A)') 'e.children(1).polyline_style=1;'
      WRITE(9,'(A)') 'e.children(1).line_style=1;'
      WRITE(9,'(A)') 'e.children(1).thickness=2.5;'
      WRITE(9,'(A)') 'e.children(1).foreground=4;'
      IF (L.GE.2) THEN
      WRITE(9,'(A)') 'e.children(2).polyline_style=1;'
      WRITE(9,'(A)') 'e.children(2).line_style=8;'
      WRITE(9,'(A)') 'e.children(2).thickness=4;'
      WRITE(9,'(A)') 'e.children(2).foreground=13;'
      ENDIF
      IF (L.GE.3) THEN
      WRITE(9,'(A)') 'e.children(3).polyline_style=1;'
      WRITE(9,'(A)') 'e.children(3).line_style=3;'
      WRITE(9,'(A)') 'e.children(3).thickness=4;'
      WRITE(9,'(A)') 'e.children(3).foreground=5;'
      ENDIF
      IF (L.GE.4) THEN
      WRITE(9,'(A)') 'e.children(4).polyline_style=1;'
      WRITE(9,'(A)') 'e.children(4).line_style=1;'
      WRITE(9,'(A)') 'e.children(4).thickness=5;'
      WRITE(9,'(A)') 'e.children(4).foreground=2;'
      ENDIF
C
      IF (L.EQ.2) THEN
      WRITE(9,'(5A)')
     & 'leg=legend([''',NAME(1),''';''',NAME(2),'''],4);'
      ELSEIF (L.EQ.3) THEN
      WRITE(9,'(7A)') 'leg=legend([''',NAME(1),''';''',
     & NAME(2),''';''',NAME(3),'''],4);'
      ELSEIF (L.EQ.4) THEN
      WRITE(9,'(9A)') 'leg=legend([''',NAME(1),''';''',
     & NAME(2),''';''',NAME(3),''';''',NAME(4),'''],4);'
      ENDIF
      WRITE(9,'(A)') 'leg.font_size=4.5;'
      WRITE(9,'(3A)') 'title(''Performance profiles for ',
     & PROFILE,''',''fontsize'',5);'
      WRITE(9,'(A)') 'xlabel(''$$\tau$$'',''fontsize'',5);'
      WRITE(9,'(A)') 'ylabel(''$$\rho(\tau)$$'',''fontsize'',5);'
      WRITE(9,'(A)') 'xs2eps(0,''P'');'
    5 CONTINUE
      CLOSE(7)
      CLOSE(8)
      CLOSE(9)
      $OPTION(CHEOL=';')
      END
