$INTERFACE U1FDU5                                             99/12/01
$REM VL

  $AX='AX'
  $AY='AY'
  $AZ='AZ'
  $N='N'
  $HERF='D'
  $ADD(REAL,'\ALFN\ALFV\GAM\RHO\DF\POM')
  $ADD(REAL,'\UXVDOT\UXVSAB\UXVNOR')
  $HELP
    TYPE OF PROBLEM:
      0 - CONVEX PROBLEM
      1 - NONCONVEX PROBLEM
  $CHECK(MEX,1,'0\1',3)
  $IF(MEX=0)
    $ADD(INTEGER,'\JC\JE\JL\JR\JU\NNC\NNK\NNV\IRT')
  $ELSE
    $ADD(INTEGER,'\JC\JE\JR\JS\JU\NNC\NNK\NNV\IRT')
  $ENDIF
  $ADD(INTEGER,'\IMD')
  $HELP
    NUMBER OF BUNDLE POINTS:
  $CHECK(MB,0,INT,2,NO)
  $IF(MB<=0)  $MB='$NF+3'
  $ADD(INIT)
    MB=$MB
  $ENDADD
  $TYPE='L'
  $DECOMP='I'
  $NUMBER=1
  $KDS=1
  $IF(TYPE='L')
    $LCS=0
    $IF(MEX=0)
      $STEP=7
      $CON1='2.0$P 0'
      $CON2='1.0$P 0'
    $ELSE
      $STEP=8
      $CON1='1.0$P 2'
      $CON2='1.0$P-1'
    $ENDIF
    $MES3=0
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $UPDATE='V'
  $IF(MEX=0)
    $HELP
      INITIAL CORRECTION PARAMETER
    $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ETA5='0.0$P 0'
  $ELSE
    $HELP
      CORRECTION PARAMETER
    $CHECK(ETA2,'1.0$P-12',REAL,4)
    $HELP
      LOCALITY MEASURE EXPONENT (SEE MANUAL UFO)
        1 - EXPONENT ONE
        2 - EXPONENT TWO
    $CHECK(MOS3,2,'1\2',3)
    $HELP
      MEASURE OF NONCONVEXITY
    $CHECK(ETA5,'0.25$P 0',REAL,3)
  $ENDIF
  $IRES1=111
  $IRES2=999
  $ADD(INIT)
    ISNA=$ISNA
  $ENDADD
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
$REM  N=NF
  $IF(NAL>0)
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
    $IF(NORMF>0) $SUBST('UATRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR<>'U') $SUBST('UYFP$(CONSTR)1')
  $DEC='G'
*
*     -----------------------------
*     BUNDLE VARIABLE METRIC METHOD
*     TEMPLATE : U1FDU5
*     -----------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  NB=0
  MB=$MB
  IF (MB.GT.NF) MB=NF+3
  JR=0
  $IF(MEX=1)
    JC=0
    JE=0
    JS=0
    JU=0
    NNC=0
  $ENDIF
  NNK=0
  NNV=0
  GAM=ONE
  RHO=ETA2
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $SUBST('UZMODN')
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  DF=ABS(F)+ONE
  $SUBST('UYBUN1')
$L=$ 30 ; $LABEL
  ITES=-1
  IF (ITERS.GT.0) THEN
  $IF(MEX=0)
    JC=0
    JU=0
    NNC=0
  $ENDIF
  ALFN=ZERO
  ALFV=ZERO
  CALL UXVCOP(NF,$G,$GP)
  ENDIF
  $GH=G
  $G=GP
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT5')
  IF (ITERM.NE.0) GO TO $90
  $IF(CONSTR<>'U')
$REM    IF (ITERS.NE.0) THEN
    $IF(MLC=1)
      $SUBST('UYRM$(CONSTR)0')
    $ELSE
      $SUBST('UYRM$(CONSTR)1')
    $ENDIF
$REM    ENDIF
  $ENDIF
  $G=GH
$L=$ 40 ; $LABEL
  $SUBST('UUDSD1')
  IF (ITERM.NE.0) GO TO $90
  $IF(MEX=1)
    IF (JE.GT.0) GO TO $50
  $ENDIF
  $MAT='G'
  $DEC='I'
  $DECOMG='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$NUMBER
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$NUMBER')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(TYPE='L')
    $SUBST('UD1TL1')
    IF (SNORM.LE.ZERO) IREST=0
  $ENDIF
  IF (ITERM.NE.0) GO TO $90
  IF (IREST.NE.0) GO TO $40
  XNORM=-P+TWO*ALFV
  POM=RHO*GNORM**2
  IF (XNORM.LT.POM.OR.(JC.EQ.1.AND.JU.EQ.1)) THEN
  NNC=NNC+1
  IF (NNC.GE.1) JC=1
  CALL UXVDIR(N,-RHO,$GN,$SN,$SN)
  CALL UXDSDA(N,$H,RHO)
  XNORM=XNORM+POM
  ENDIF
$L=$ 50 ; $LABEL
  $SUBST('UYFUT6')
  IF (ITERM.NE.0) GO TO $90
  $IF(MEX=0)
    POM=1.0$P-4*XNORM
  $ENDIF
  $IF(TYPE='L')
    IF (SNORM.GT.ZERO) RMAX=XMAX/SNORM
    RMIN=1.0$P-10
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  IF (RMAX.LE.RMIN) THEN
  R=ZERO
  GO TO $85
  ENDIF
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GO TO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GO TO $10
$L=$ 64 ; $LABEL
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  $LMF=$90
  $SUBST('UYFUT7')
  $SUBST('UYBUN1')
  IF (RP.LT.SQRT($ETA9)) GAM=(MAX($CON2,MIN(1.0$P 2,RP))+TWO*GAM)/THREE
  IRT=0
  IF (ITERS.EQ.0) THEN
  NNK=NNK+1
  $IF(MEX=0)
    ALFN=ABS((FO-F)/R+P)
  $ELSE
    ALFN=MAX(ABS(FO-F+P*R),ETA5*(SNORM*R)**MOS3)
  $ENDIF
  IF (NNK.EQ.1) THEN
  $SUBST('UYAG$(CONSTR)2')
  ELSE
  $SUBST('UYAG$(CONSTR)1')
  ENDIF
  F=FO
  ELSE
  NNK=0
  $IF(MEX=0)
    RHO=ETA2/NFV
    IF (GNORM.GT.ZERO) RHO=RHO*MIN(ONE/MIN(GNORM**2,1.0$P 3),GNORM**2)
  $ENDIF
  IF (GAM.GT.ONE) JR=JR+1
  IF (GAM.GT.TEN.AND.NNV.GT.3.AND.JR.GT.1) THEN
*
*     MATRIX SCALING
*
  NNV=0
  JR=0
  CALL UXDSMS(N,$H,GAM)
  GAM=SQRT(GAM)
  IRT=1
  ENDIF
  ENDIF
  POM=P
  $SUBST('UYTR$(CONSTR)D')
  P=POM
  POM=UXVSAB(N,$GO)
  IF (IRT.GT.0) THEN
  IF (POM.NE.ZERO) JE=0
  GO TO $85
  ENDIF
  $IF(MEX=0)
    JU=0
    $KHLP='1.0D-5*SNORM**2'
    $JOB=0
  $ELSE
    IF (POM.EQ.ZERO.AND.ITERS.GT.0) THEN
    JE=JE+1
    IF (JE.GT.7) JE=99
    GO TO $85
    ELSE
    JE=0
    ENDIF
    $KHLP='RHO'
    $JOB=1
  $ENDIF
  TUXX='SKIP UP.'
  POM=UXVDOT(N,$XO,$GO)
  IF (POM.GT.R*$KHLP.AND.ABS(POM).GT.1.0$P-6*UXVNOR(N,XO)*UXVNOR(N,GO))&
THEN
  $SUBST('UUD$(UPDATE)I2')
  ENDIF
$L=$ 85 ; $LABEL
  $KHLP=4
  $IF(MLC=1) $KHLP=0
  $IF(CONSTR<>'U')
    IF (ITERS.NE.0.OR.RMAX.LE.RMIN.AND.INEW.NE.0) THEN
    $SUBST('UYAD$(CONSTR)$(KHLP)')
    ENDIF
  $ENDIF
  GO TO $30
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  GMAX=XNORM
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UATRL1')
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FDU5'
  $ENDADD
  $EXIT
