$INTERFACE U1MDN1                                             06/12/01
$REM LU

  $OPTION(LPERFD=.TRUE.)
  $GF='GF'
  $ADD(INTEGER,'\NFO\NCO\IMS')
  $ADD(REAL,'\$GA($NF)')
*
*     -----------------------------
*     TRANSORMATION OF MINIMAX TO A
*     NONLINEAR PROGRAMMING PROBLEM
*     TEMPLATE : U1MDN1
*     -----------------------------
*
  $IF(NC=0)
    $MC=0
    $KDC=KDA
    $KBC=1
    $CU=CL
    $FMODC='X'
    $GMODC='X'
    $IF($DEF(FMODELA))
      $SET(FMODELC)
*       NEW FMODELC
      $ENDSET
      $FMODC='F'
    $ENDIF
    $IF($DEF(GMODELA))
      $SET(GMODELC)
*       NEW GMODELC
      $ENDSET
      $GMODC='G'
    $ENDIF
    $IF($DEF(FGMODELA))
      $SET(FGMODELC)
*       NEW FGMODELC
      $ENDSET
      $FMODC='FG'
    $ENDIF
    $CRED='NO'
    $MODELC='YES'
    $LDC=-1
$REM    $SUBST('UZMODC')
  $ENDIF
  KBC=$KBC
  $NFO=NF
  $NXO=NX
  $NCO=NC
  $NAOLD='NA'
  $ADD(SINID)
    IF (NC.EQ.0) MC=0
    NFO=NF
    NCO=NC
    NF=NF+1
    $X(NF)=0.0$P 0
    CALL UXVINS(NA,2,$IC(NC+1))
    CALL UXVSET(NA,ZERO,$CU(NC+1))
    NC=NC+NA
    $IF('$IEXT'=0)
      CALL UXVINS(NA,1,$IC(NC+1))
      CALL UXVSET(NA,ZERO,$CL(NC+1))
      NC=NC+NA
    $ENDIF
  $ENDADD
  $SET(FMODELF)
    FF=$X(NF)
  $ENDSET
  $SET(GMODELF)
    CALL UXVSET(NF-1,ZERO,$GF)
    $GF(NF)= ONE
  $ENDSET
  $KDF=1
  $SUBST('UCMAX1')
  $NF='($NF+1)'
  $NX=NF
  $IF(IEXT=0)
    $NC='($NC+2*$NA)'
  $ELSE
    $NC='($NC+$NA)'
  $ENDIF
  $MODEL='FF'
  $MODELF='YES'
  $FMODF='F'
  $GMODF='G'
  $MCOLS=NF
  $OPTION(LPERFD=.FALSE.)
  $SUBST('U1FDN1')
  $NF=NFO
  $NX=NXO
  $NC=NCO
  NF=NF-1
  NC=NCO
  $ADD(INIT)
    NXFU='U1MDN1'
  $ENDADD
  $EXIT
