$INTERFACE UA2F02                                             97/12/01

      $HELP
        MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
      $CHECK(MAH,'25*$NA',INT,1)
 $00  CALL UA2F02
      GOTO ($80,$10,$20,$40) ISB+1
 $10  CONTINUE
      $MTYPE=FMODA
      $SUBST('UZAMOD')
      $IF(KBA>0)
        CALL UXVDIF(NA,$AF,$AM,$AF)
      $ENDIF
      $GO TO $00
 $20  CONTINUE
      IDECA=0
      $IF(GMODA='G')
        $MTYPE='G'
        $SUBST('UZAMOD')
      $IF(KBA>0)
        CALL UXVDIF(NA,$AF,$AM,$AF)
      $ENDIF
        GOTO $00
      $ELSEIF(FMODA='F')
        $IF(JACA='S')
          $SUBST('UA0G$(CON)4')
        $ELSE
          $SUBST('UA0G$(CON)2')
        $ENDIF
        GOTO ($00,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODA
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        GO TO $20
      $ELSE
        IF (LDA.LT.0) GOTO $00
        $MTYPE=FMODA
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        GO TO $00
      $ENDIF
  $40 CONTINUE
      $IF(HMODA='H')
        $MTYPE='H'
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        GOTO $00
      $ELSEIF(GMODA='G')
        $IF(JACA='S')
          $SUBST('UA1H$(CON)4')
        $ELSE
          $SUBST('UA1H$(CON)2')
        $ENDIF
        GOTO ($00,$50) ISB+1
  $50 CONTINUE
        $MTYPE=GMODA
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        GO TO $40
      $ELSEIF(FMODA='F')
        $IF(JACA='S')
          $SUBST('UA0H$(CON)4')
        $ELSE
          $SUBST('UA0H$(CON)2')
        $ENDIF
        GO TO ($00,$60) ISB+1
  $60 CONTINUE
        $MTYPE=FMODA
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        GO TO $40
      $ELSEIF(FMODA='FG')
        $IF(JACA='S')
          $SUBST('UA1H$(CON)4')
        $ELSE
          $SUBST('UA1H$(CON)2')
        $ENDIF
        GO TO ($00,$70) ISB+1
  $70 CONTINUE
        $MTYPE=FMODA
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        GO TO $40
      $ELSE
        IF (LDA.LT.0) GOTO $00
        $MTYPE=FMODA
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        GO TO $00
      $ENDIF
 $80  CONTINUE
      $ADD(INIT)
        NAXX='UA2F02'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA2F02               ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SIMULTANEOUS COMPUTATION OF THE APPROXIMATED FUNCTION VALUES AND
* GRADIENTS.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LDA  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UA2F02
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,2,4,6) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 5
      IF (LDA.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      LDA=0
    3 IF (KD.LT.1) GO TO 7
      IF (LDA.GE.1) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      LDA=1
    5 IF (KD.LT.2) GO TO 7
      IF (LDA.GE.2) GO TO 7
      CALL UYSET0(3,4)
      RETURN
    6 CONTINUE
      LDA=2
    7 CALL UYEPI1(-1)
      RETURN
      END
