$INTERFACE UA2MX2                                             97/12/01

  $SUBST('UZASET')
  $IF(KDA<2)
    $IF(SAVA<2) $HA=H
  $ENDIF
  $HELP
    TYPE OF EXTREMUM:
       0 - CHEBYSHEV APPROXIMATION
      -1 - MINIMAX
       1 - MAXIMIN
  $CHECK(IEXT,0,'-1\0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $ADD(REAL,'\$AG($NF*$NA)\$G($NF)\$HA($NF*($NF+1)/2)\$H($NF*($NF+1)/2)&
  \$AZ($NF+1)')
$REM  $ADD(REAL,'\FA\F')
  $ADD(INTEGER,'\$IAA($NF+1)')
$REM  $ADD(INTEGER,'\NF\NA\NAL\NCL\N\KA\KAP')
 $00  CALL UA2MX2(NF,NA,NAL,NCL,N,KA,KAP,$AG,$G,$HA,$H,$AZ,$IAA,FA,F)
      GO TO ($90,$10,$20,$50) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF1')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<$NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF1')
          $ENDIF
          $IF(FMODA<>'F')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG1')
            $ENDIF
          $ENDIF
          $IF(FMODA='FGH')
            $IF(NORMA>0) $SUBST('UANRH1')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $IF(SAVA>0)
        IF(LDA.GE.1) THEN
        $SUBST('UALNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<1)
        $IF(NAL<$NA)
          $IF(GMODA='G')
            $MTYPE='G'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG1')
            $ENDIF
            GO TO $00
          $ELSEIF(FMODA='F')
            $IF(ISNA>0)
              IF (LD.GE.0) FA=$AF(KA)
            $ENDIF
 $25  CONTINUE
            $SUBST('UA0G$(CON)1')
            GO TO ($40,$30) ISB+1
 $30  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $25
 $40  CONTINUE
            $IF(ISNA>1)
              $SUBST('UASVG1')
            $ENDIF
            GO TO $00
          $ELSE
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG1')
            $ENDIF
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(SAVA>1)
        IF(LDA.GE.2) THEN
        $SUBST('UASTH1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNH1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<2)
        $IF(NAL<$NA)
          $IF(HMODA='H')
            $MTYPE='H'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRH1')
            GO TO $00
          $ELSEIF(GMODA='G')
            $SUBST('UALNG1')
 $55  CONTINUE
            $SUBST('UA1H$(CON)1')
            GO TO ($00,$60) ISB+1
 $60  CONTINUE
            $MTYPE=GMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $55
          $ELSEIF(FMODA='F')
            $IF(ISNA>0)
              IF (LD.GE.0) FA=$AF(KA)
            $ENDIF
 $65  CONTINUE
            $SUBST('UA0H$(CON)1')
            GO TO ($00,$70) ISB+1
 $70  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $65
          $ELSEIF(FMODA='FG')
            $SUBST('UALNG1')
 $75  CONTINUE
            $SUBST('UA1H$(CON)1')
            GO TO ($00,$80) ISB+1
 $80  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $75
          $ELSE
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(NORMA>0) $SUBST('UANRH1')
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $90  CONTINUE
      $ADD(INIT)
        NAXX='UA2MX2'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA2MX2             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  NCL  NUMBER OF CONSTRAINTS.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  II  KAP  OPTIMUM INDEX OF THE APPROXIMATED FUNCTION.
*  RI  AG(NF*NA)  DENSE HESSIAN MATRIX.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  HA(NF*(NF+1)/2)  HESSIAN MATRIX OF THE APPROXIMATED FUNCTION.
*  RO  H(NF*(NF+1)/2)  HESSIAN MATRIX OF THE OBJECTIVE FUNCTION.
*  RI  AZ(NF+1) VECTOR OF LAGRANGE MULTIPLIERS.
*  II  IAA(NF+1)  VECTOR CONTAINING INDICES OF ACTIVE FUNCTIONS.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  IO  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  IU  NAV  NUMBER OF APPROXIMATED FUNCTION VALUES COMPUTED.
*  IU  NAG  NUMBER OF APPROXIMATED FUNCTION GRADIENTS COMPUTED.
*  IU  NAH  NUMBER OF APPROXIMATED FUNCTION HESSIAN MATRICES COMPUTED.
*  IU  NFV  NUMBER OF OBJECTIVE FUNCTION VALUES COMPUTED.
*  IU  NFG  NUMBER OF OBJECTIVE FUNCTION GRADIENTS COMPUTED.
*  IU  NFH  NUMBER OF OBJECTIVE FUNCTION HESSIAN MATRICES COMPUTED.
*  II  IEXT  TYPE OF EXTREMUM. IEXT<0-MINIMAX. IEXT=0-CHEBYSHEV
*         APPROXIMATION, IEXT>0-MAXIMIN.
*  IU  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*
      SUBROUTINE UA2MX2(NF,NA,NAL,NCL,N,KA,KAP,AG,G,HA,H,AZ,IAA,FA,F)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,NAL,NCL,N,KA,KAP,IAA(NF+1)
      $FLOAT AG(NF*NA),G(NF),HA(NF*(NF+1)/2),H(NF*(NF+1)/2),AZ(NF+1),
     & FA,F
      $FLOAT FTEMP,FVAL
      INTEGER K,L
      SAVE FVAL
      SAVE L
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,3,5,9) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 11
      KA=1
    2 IF (KA.GT.NA) GO TO 7
      IF (KD.LT.0) GO TO 6
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      IF (LD.GE.0) GO TO 4
      IF (IEXT.EQ.0.AND.FA.GE.ZERO.OR.IEXT.LT.0) THEN
      FTEMP= FA
      K= 1
      ELSE
      FTEMP=-FA
      K=-1
      ENDIF
      IF (KA.EQ.1) THEN
      FVAL=FTEMP
      KAP=KA
      L=K
      ELSE IF (FVAL.LT.FTEMP) THEN
      FVAL=FTEMP
      KAP=KA
      L=K
      ENDIF
    4 IF (KD.LT.1) GO TO 6
      CALL UYSET0(2,3)
      RETURN
    5 CONTINUE
    6 KA=KA+1
      GO TO 2
    7 IF (KD.GE.0.AND.LD.LT.0) F=FVAL
      IF (KD.GE.1.AND.LD.LT.1) THEN
      IF (L.GE.0) THEN
      CALL UXVCOP(NF,AG((KAP-1)*NF+1),G)
      ELSE
      CALL UXVNEG(NF,AG((KAP-1)*NF+1),G)
      ENDIF
      ENDIF
      IF (KD.LT.2) GO TO 10
      IF (LD.GE.2) GO TO 10
      CALL UXVSET(NF*(NF+1)/2,ZERO,H)
      IDECF=0
      L=1
    8 IF (L.GT.NF-N) GO TO 10
      KA=IAA(L)-NCL
      IF (KA.LE.0) THEN
      L=L+1
      GO TO 8
      ENDIF
      IF (KA.GT.NA) KA=KA-NA
      CALL UYSET0(3,4)
      RETURN
    9 CALL UXVDIR(NF*(NF+1)/2,-AZ(L),HA,H,H)
      L=L+1
      GO TO 8
   10 NFV=NAV/(NA-NAL)
      NFG=NAG/(NA-NAL)
      NFH=NAH/(NA-NAL)
      LD=KD
   11 CALL UYEPI1(-1)
      RETURN
      END
