$INTERFACE UARED2                                             07/12/01

  CALL UARED2(NF,NA,MA,KA,$IAG,$JAG,$GA,LA)
  $ADD(REAL,'\$GA($NF)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\LA')
$REM  $ADD(INTEGER,'\NF\NA\MA\KA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UARED2             ALL SYSTEMS                   07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE JACOBIAN MATRIX FROM INDIVIDUAL GRADIENTS
* OF THE APPROXIMATED FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RU  GA(NF)  GRADIENT VECTORS (ORIGINAL AND REDUCED).
*  IO  L  DIMENSION OF THE VECTOR GAR.
*
      SUBROUTINE UARED2(NF,NA,MA,KA,IAG,JAG,GA,L)
      INTEGER NF,NA,MA,KA,IAG(NA+1),JAG(MA),L
      $FLOAT GA(NF)
      INTEGER J,JP,K
      K=IAG(KA+1)
      L=K-IAG(KA)
      DO 2 J=L,1,-1
      K=K-1
      JP=ABS(JAG(K))
      GA(JP)=GA(J)
    2 CONTINUE
      RETURN
      END
