$INTERFACE UASET4                                             97/12/01

  CALL UASET4(NF,MAL,$AFD,$IA,$AG,$S)
  $ADD(REAL,'\$AFD($NA)\$AG($NF*$NA)\$S($NF)')
  $ADD(INTEGER,'\$IA($NA)')
$REM  $ADD(INTEGER,'\NF\MAL')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UASET4              ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  COMPUTATION OF DIRECTION DERIVATIVES.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  RO  AFD(NA)  VECTOR CONTAINING INCREMENTS OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IA(NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RI  AG(NF*NA)  MATRIX WHOSE COLUMNS ARE GRADIENTS OF THE LINEAR
*          APPROXIMATED FUNCTIONS.
*  RI  S(NF)  DIRECTION VECTOR.
*
* SUBPROGRAMS USED.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UASET4(NF,NA,AFD,IA,AG,S)
      INTEGER NF,NA,IA(NA)
      $FLOAT AFD(NA),AG(NF*NA),S(NF)
      $FLOAT UXVDOT
      INTEGER JAG,KA
      JAG=1
      DO 1 KA=1,NA
      IF (IA(KA).GT.0) THEN
      ELSE IF (IA(KA).LT.0) THEN
      AFD(KA)=UXVDOT(NF,AG(JAG),S)
      ENDIF
      JAG=JAG+NF
    1 CONTINUE
      RETURN
      END
