$INTERFACE UASVF2                                             04/12/01

  CALL UASVF2(NA,KA,$AF,FA,ISNA,LDA)
  $ADD(REAL,'\$AF($NA)')
$REM  $ADD(REAL,'\FA')
$REM  $ADD(INTEGER,'\NA\KA\KAP\ISNA\LDA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UASVF2             ALL SYSTEMS                   04/12/01
C PORTABILITY : ALL SYSTEMS
C 04/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE LINEAR APPROXIMATED FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF FUNCTIONS.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RO  AF(NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE STORED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         STORED.
*  IU  LDA  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* COMMON DATA :
*
      SUBROUTINE UASVF2(NA,KA,AF,FA,ISNA,LDA)
      INTEGER NA,KA,ISNA,LDA
      $FLOAT AF(NA),FA
      IF (ISNA.GT.0) THEN
      IF (FA.GE.0.0$P 0) THEN
      AF(KA)= FA
      ELSE
      AF(KA)=-FA
      ENDIF
      IF (KA.EQ.NA) LDA=MAX(LDA,0)
      ENDIF
      RETURN
      END
