$INTERFACE UCCST2                                             08/12/01

  $IXE='IXE'
  $ICE='ICE'
  CALL UCCST2(NX,$IXE,NC,NCC,$ICE,$ICC)
  $ADD(INTEGER,'\$IXE($NX)\$ICE($NC)\$ICC(2*$NCC)')
$REM  $ADD(INTEGER,'\NX\NC\NCC')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UCCST2             ALL SYSTEMS                   08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VECTORS CONTAINING INDICES OF COUPLED CONSTRAINTS.
*
* PARAMETERS :
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  IXE(NX)  VECTOR CONTAINING INDICES OF COUPLED BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCC  NUMBER OF COMPLEMENTARITY CONSTRAINTS.
*  II  ICE(NC)  VECTOR CONTAINING INDICES OF COUPLED GENERAL 
*         CONSTRAINTS.
*  II  ICC(2*NCC)  VECTOR CONTAINING INDICES OF COMPLEMENTRIRY
*         CONSTRAINTS.
*
*  COMMON DATA :
*  IO  ITERM  TERMINATION INDICATOR.
*
      SUBROUTINE UCCST2(NX,IXE,NC,NCC,ICE,ICC)
      $INCLUDE('UMCOMM')
      INTEGER NX,IXE(NX),NC,NCC,ICE(NC),ICC(2*NCC)
      INTEGER I,K,KK,L,LL
      CALL UXVINS(NX,0,IXE)
      CALL UXVINS(NC,0,ICE)
      DO 3 I=1,NCC
      K=ICC(I)
      KK=ABS(K)
      L=ICC(NCC+I)
      LL=ABS(L)
      IF (K.EQ.0) THEN
      ITERM=-114
      TXFU='NO COMPL'
      CALL UOERR1('UCCST2',114)
      ELSE IF (K.LE.0) THEN
      IXE(KK)=L
      ELSE IF (K.GE.0) THEN
      ICE(KK)=L
      ENDIF
      IF (L.EQ.0) THEN
      ITERM=-114
      TXFU='NO COMPL'
      CALL UOERR1('UCCST2',114)
      ELSE IF (L.LE.0) THEN
      IXE(LL)=K
      ELSE IF (L.GE.0) THEN
      ICE(LL)=K
      ENDIF
    3 CONTINUE
      RETURN
      END

