$INTERFACE UDDSQ1                                             97/12/01
$REM LU

  $HELP
    TYPE OF QP SUBPROBLEM
      1 - COMPLETE QP SUBPROBLEM
      2 - PARTIAL QP SUBPROBLEM WITH CHECK OF ACTIVITY
      3 - PARTIAL QP SUBPROBLEM
  $CHECK(MOS,1,'1\2\3',3)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $HELP
    INITIAL TRUST REGION BOUND
  $CHECK(XDEL,XMAX,REAL,3)
  $HELP
    TOLERANCE FOR NEAR ACTIVITY
  $CHECK(ETA4,'2.0$P-1',REAL,4)
  $ADD(REAL,'\$CF($NC)\$CL($NC)\$CU($NC)\$CG($NF*$MCL)&
  \$CR($NF*($NF+1)/2)\$H($M)\$S($NF)\$G($NF)')
  $ADD(INTEGER,'\$IXA($NF)\$IC($NC)')
  $IF(MOS>1)
    $ADD(REAL,'\POM\TEMP')
    $ADD(INTEGER,'\$ICS($NC)')
    $IF(MOS=2) $ADD(INTEGER,'\JCG')
  $ENDIF
  $ADD(REAL,'\UXVDOT\UXVMAX\UXDPGQ')
  $ADD(INTEGER,'\IPOM\I')
  CALL UOD1D1
  IF (IDECF.LT.0) IDECF=1
  IF (IDECF.EQ.0) THEN
  ELSE IF (IDECF.EQ.1) THEN
  ELSE IF (IDECF.EQ.2) THEN
  CALL UXDPRT(N,$H)
  IDECF=1
  ELSE IF (IDECF.EQ.9) THEN
  ELSE
  ITERD=-1
  TDXX='BAD DEC1'
  CALL UOERR1('UDDSQ1',1)
  GO TO $70
  ENDIF
  MFP=2
  $IF(MOS>1)
    DO $20 KC=1,NC
    IF ($IC(KC).GT.0) THEN
    POM=ZERO
    TEMP=$CF(KC)
    IF ($IC(KC).EQ.1.OR.$IC(KC).GE.3) POM=MIN(POM,TEMP-$CL(KC))
    IF ($IC(KC).EQ.2.OR.$IC(KC).GE.3) POM=MIN(POM,$CU(KC)-TEMP)
    IF (POM.LT.ETA4) THEN
    $ICS(KC)=0
    ELSE
    $ICS(KC)=$IC(KC)
    $IC(KC)=0
    ENDIF
    ENDIF
$20 CONTINUE
  $ENDIF
  MODE=1
  IPOM=0
$30 CONTINUE
  $JOB=1
  $IF(NUMBER=1)
    $SUBST('ULQDB1')
  $ELSE
    $SUBST('ULQPB2')
  $ENDIF
  IF (ITERQ.LT.0) THEN
  IF (IPOM.LT.10) THEN
  IPOM=IPOM+1
  CALL ULREDL(MCL,$CF,$IC,$CL,$CU,KBC)
  GO TO $30
  ENDIF
  ITERD=ITERQ-10
  TDXX='NON FEAS'
  GO TO $70
  ENDIF
  IPOM=0
  $IF(MOS>1)
    IPOM=1
    $IF(MOS=2)
      JCG=0
      DO $50 KC=1,NC
      IF ($ICS(KC).NE.0) THEN
      POM=ZERO
      TEMP=$CF(KC)+UXVDOT(NF,$CG(JCG+1),$S)
      IF ($ICS(KC).EQ.1.OR.$ICS(KC).GE.3) POM=MIN(POM,TEMP-$CL(KC))
      IF ($ICS(KC).EQ.2.OR.$ICS(KC).GE.3) POM=MIN(POM,$CU(KC)-TEMP)
      IF (POM.LT.ZERO) THEN
      IPOM=2
      $IC(KC)=$ICS(KC)
      $ICS(KC)=0
      ENDIF
      ENDIF
      JCG=JCG+NF
$50   CONTINUE
    $ENDIF
    IF (IPOM.EQ.2) THEN
    MFP=3
    MODE=2
    GO TO $30
    ELSE IF (IPOM.EQ.1) THEN
    DO $60 KC=1,NC
    IF ($ICS(KC).NE.0) THEN
    $IC(KC)=$ICS(KC)
    $ICS(KC)=0
    ENDIF
$60 CONTINUE
    ENDIF
  $ENDIF
  ITERD=1
  TDXX='QD STEP '
  GMAX=UXVMAX(NF,$G)
  IF (LCS.GT.0) THEN
  GNORM=GMAX
  SNORM=UXVMAX(NF,$S)
  ELSE
  GNORM=SQRT(UXVDOT(NF,$G,$G))
  SNORM=SQRT(UXVDOT(NF,$S,$S))
  ENDIF
$70 IF (LCS.GT.0) THEN
  DO $80 I=1,NF
  IF ($IXA(I).GE.0) ITERD=3
$80 CONTINUE
  CALL UXVCOP(N,$S,$CR)
  CALL UXDPGM(N,$H,$CR,1)
  PP=UXDPGQ(N,$H,$CR,$CR)*HALF
  ENDIF
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDDSQ1'
  $ENDADD
  $EXIT

