$INTERFACE UDSLZI                                             03/12/01
$REM LU

  IF (IDECF.LT.0) IDECF=0
  IF (IDECC.LT.0) IDECC=0
  $IF(NOS2=1)
    $ADD(REAL,'\$B($MMAX)')
    $ADD(INTEGER,'\$IB($NC+1)\$JB($MMAX)')
    $ADD(INTEGER,'\$PSR($NC+1)\$PERC($NC)')
    $ADD(INTEGER,'\MS')
    $D=GC
    L=$IB($NN+1)-1
    IF (L.GE.$MMAX) THEN
    CALL UOERR2('UD$(HERF)LZ$(NUMBER)',49,L,$MMAX)
    ITERM=-49
    TDXX='LACK SPC'
    GO TO $LZI
    ENDIF
    $IF(MOS2>0)
      DO $20 I=1,$N
      ALF=ABS($H($IH(I)))
      IF (ABS(ALF).LE.$CON5) ALF=$CON5
      IF (ABS(ALF).GE.$CON6) ALF=$CON6
      $GC(I)=ONE/ALF
$20   CONTINUE
    $ELSE
      CALL UXVSET($N,ONE,$GC)
    $ENDIF
    $IDECC=1
    $SUBST('UCENS1')
    RHO=ETA0
    CALL UXSPCT($NN,L,MS,MMAX,$B,$JB,$PSR,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $LZI
    ENDIF
*
*     GILL-MURRAY DECOMPOSITION
*
    CALL UXSPCF($NN,MMAX-L,$B(L+1),$PSR,$JB(L+1),$WN11,$WN12,$XS,INF&
,RHO,ALF)
    $IF(MD>0)
      IF (ND.GT.0) THEN
      CALL UXSPCX($NN,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD&
,$BD,$S,$S($N+1))
      ENDIF
    $ENDIF
  $ELSEIF(NOS2=2)
    $ADD(REAL,'\$B($MMAX)\$SO($NF+$NC)\$XP($NF)')
    $ADD(INTEGER,'\$IB($NF+$NC+1)\$JB($NF+$MC+$NC)\$KB($NF+$MC+$NC)&
    \$IW($MMAX)\$IW1(2*($NF+$NC))\$IW2(3*($NF+$NC))\$KCG($MC)')
    $IF(MOS2>0)
      DO $20 I=1,$N
      ALF=ABS($H($IH(I)))
      IF (ABS(ALF).LE.$CON5) ALF=$CON5
      IF (ABS(ALF).GE.$CON6) ALF=$CON6
      $GC(I)=ALF
$20   CONTINUE
    $ELSE
      CALL UXVSET($N,ONE,$GC)
    $ENDIF
    CALL UXVINP($N+1,$IW1)
    CALL UXSKIN($N,$N,$GC,$IW1,$NN,MC,$CG,$JCG,$KCG,$B,$IB)
*
*     BUNCH-PARLETT DECOMPOSITION
*
    CALL UXSIBF($N+$NN,$N+$NN+MC,$KB,$JB,$B,MMAX,$IW,MMAX,$IW1,$IW2,NAU&
,NUP,INF)
    IF (INF.LT.0) THEN
    TDXX='LACK SPC'
    ITERM=INF
    GO TO $LZI
    ENDIF
  $ENDIF
  NDECC=NDECC+1
  $EXIT
