$INTERFACE UDVLC1                                             97/12/01
$REM LU

  $CON1='1.0$P-14'
  $CON2='0.5$P 0'
  $CON4='1.0$P-2'
  $CON5='1.0$P-5'
  $CON6='1.0$P-8'
  $CON7='1.669$P 0'
  $XOS=XO
  $GOS=GO
  $IF(CONSTR='C')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $ADD(INTEGER,'\$IX($NF)')
  $ELSE
    $POM1='V'
    $POM2=')'
  $ENDIF
  $HELP
    CHOICE OF THE CG METHOD
             0 - STEEPEST DESCENT
      -1 OR  1 - HESTENES AND STIEFEL
      -2 OR  2 - POLAK AND RIBIERE
      -3 OR  3 - LIU AND STOREY
      -4 OR  4 - DAI AND YUAN
      -5 OR  5 - FLETCHER AND REEVES
      -6 OR  6 - CONJUGATE DESCENT
      -7 OR  7 - PERRY VERSION OF HESTENES AND STIEFEL
      -8 OR  8 - PERRY VERSION OF POLAK AND RIBIERE
      -9 OR  9 - PERRY VERSION OF LIU AND STOREY
     -10 OR 10 - KOU A DAI
     -11 OR 11 - DONG, LU, HE AND XU
       MET < 0 - PREVIOUS DIRECTION VECTOR IS USED
       MET > 0 - VECTOR OF VARIABLES DIFFERENCE IS USED
  $CHECK(MET,1,&
'-11\-10\-9\-8\-7\-6\-5\-4\-3\-2\-1\0\1\2\3\4\5\6\7\8\9\10\11',3)
  $NET=MET
  $IF(MET=-1) $NET=1
  $IF(MET=-2) $NET=2
  $IF(MET=-3) $NET=3
  $IF(MET=-4) $NET=4
  $IF(MET=-5) $NET=5
  $IF(MET=-6) $NET=6
  $IF(MET=-7) $NET=7
  $IF(MET=-8) $NET=8
  $IF(MET=-9) $NET=9
  $IF(MET=-10) $NET=10
  $IF(MET=-11) $NET=11
  $IF(NET=0)
    $MET1=1
    $NET1=1
  $ELSEIF(NET<4)
    $DEFAULT=4
    $HELP
      MODIFICATION OF THE CG METHOD
        -1 OR  1 - BASIC OR COMBINED CG METHOD
        -2 OR  2 - BASIC OR COMBINED TWO STEP DESCENT CG METHOD
        -3 OR  3 - IMPROVED CG METHOD WITH SCALED GRADIENT
        -4 OR  4 - THREE TERM DESCENT CG METHOD
        -5 OR  5 - MODIFIED DESCENT CG METHOD
        -6 OR  6 - MODIFIED DESCENT CG METHOD WITH SCALED GRADIENT
        -7 OR  7 - MODIFIED DESCENT THREE TERM CG METHOD
        -8 OR  8 - DAI AND LIAO CG METHOD
        -9 OR  9 - MODIFIED CG METHOD (WYL)
       -10 OR 10 - MODIFIED CG METHOD (WYZ)
        MET1 > 0 - STANDARD CG METHOD
        MET1 < 0 - POSITIVE CG METHOD
    $CHECK(MET1,DEFAULT,&
    '-10\-9\-8\-7\-6\-5\-4\-3\-2\-1\1\2\3\4\5\6\7\8\9\10',4)
    $NET1=MET1
    $IF(MET1= -1) $NET1= 1
    $IF(MET1= -2) $NET1= 2
    $IF(MET1= -3) $NET1= 3
    $IF(MET1= -4) $NET1= 4
    $IF(MET1= -5) $NET1= 5
    $IF(MET1= -6) $NET1= 6
    $IF(MET1= -7) $NET1= 7
    $IF(MET1= -8) $NET1= 8
    $IF(MET1= -9) $NET1= 9
    $IF(MET1=-10) $NET1=10
    $IF(NET1<3)
      $HELP
        COMBINATION OF CG METHODS
          -1 OR 1 - BASIC CG METHOD
          -2 OR 2 - COMBINED CG METHOD
         MET2 > 0 - STANDARD  PARAMETER
         MET2 < 0 - POSITIVE  PARAMETER
      $CHECK(MET2,-1,'-2\-1\1\2',4)
      $NET2=MET2
      $IF(MET2=-1) $NET2=1
      $IF(MET2=-2) $NET2=2
    $ELSEIF(NET1=3)
    $ELSEIF(NET1=4)
      $HELP
        MODIFICATION OF THE DESCENT CG METHOD
           1 - STANDARD THREE TERM METHOD
           2 - MODIFIED THREE TERM METHOD
      $CHECK(MET2,1,'1\2',4)
      $NET2=MET2
    $ELSEIF(NET1<8)
      $HELP
        MODIFICATION OF THE DESCENT CG METHOD
           1 - STANDARD FIRST TERM
          -1 - POSITIVE FIRST TERM
      $CHECK(MET2,1,'-1\1',4)
      $NET2=MET2
      $IF(MET2=-1) $NET2=1
      $HELP
        PARAMETER FOR DESCENT CG METHOD
      $CHECK(ETA3,'0.5$P 0',REAL,4)
    $ELSEIF(NET1=8)
      $HELP
        MODIFICATION OF THE DL METHOD
          -1 OR 1 - BASIC DAI LIAO METHOD
          -2 OR 2 - MODIFIED DAI LIAO METHOD
         MET2 > 0 - STANDARD  FIRST TERM
         MET2 < 0 - POSITIVE  FIRST TERM
      $CHECK(MET2,-1,'-2\-1\1\2',4)
      $NET2=MET2
      $IF(MET2=-1) $NET2=1
      $IF(MET2=-2) $NET2=2
      $HELP
        SELECTION OF THE LINE SEARCH MODEL:
          -1 OR  1 - QUADRATIC MODEL
          -2 OR  2 - BACKWARD TAYLOR EXPANSION (3 TERMS)
          -3 OR  3 - BACKWARD TAYLOR EXPANSION (4 TERMS)
          -4 OR  4 - HOMOGENEOUS MODEL
          -5 OR  5 - MODIFIED QUASI-NEWTON CONDITION (3 TERMS)
          -6 OR  6 - MODIFIED QUASI-NEWTON CONDITION (4 TERMS)
          MET5 > 0 - NO CORRECTION
          MET5 < 0 - CORRECTION FOR GLOBAL CONVERGENCE
      $CHECK(MET5,4,'-6\-5\-4\-3\-2\-1\1\2\3\4\5\6',4)
      $NET5=MET5
      $IF(MET5= -1) $NET5= 1
      $IF(MET5= -2) $NET5= 2
      $IF(MET5= -3) $NET5= 3
      $IF(MET5= -4) $NET5= 4
      $IF(MET5= -5) $NET5= 5
      $IF(MET5= -6) $NET5= 6
      $IF(NET2=1)
$REM        $DEFAULT='1.0$P-1'
        $DEFAULT='1.0$P 0'
        $IF(NET5>1) $DEFAULT='1.0$P 0'
        $HELP
          PARAMETER FOR DESCENT CG METHOD
        $CHECK(ETA3,DEFAULT,REAL,4)
        $PAR='ETA3*P'
      $ELSE
        $DEFAULT='1.0$P-2'
        $IF(NET5>1) $DEFAULT='1.0$P-1'
        $HELP
          PARAMETER FOR DESCENT CG METHOD
        $CHECK(ETA3,DEFAULT,REAL,4)
        $PAR='ETA3*PO'
      $ENDIF
    $ELSEIF(NET1=9)
      $HELP
        MODIFICATION OF THE WYL METHOD
          -1 OR 1 - BASIC WYL METHOD
          -2 OR 2 - MODIFIED WYL METHOD WITH MAXIMUM
          -3 OR 3 - MODIFIED WYL METHOD WITH ABSOLUTE VALUE
         MET2 > 0 - METHOD WITH AFFINE COMBINATION
         MET2 < 0 - METHOD WITH CONVEX COMBINATION
      $CHECK(MET2,2,'-3\-2\-1\1\2\3',4)
      $NET2=MET2
      $IF(MET2=-1) $NET2=1
      $IF(MET2=-2) $NET2=2
      $IF(MET2=-3) $NET2=3
      $IF(NET2>1)
        $HELP
          PARAMETER FOR THE MODIFIED WYL METHOD
        $CHECK(ETA3,'2.5$P 0',REAL,4)
      $ENDIF
    $ELSEIF(NET1=10)
      $HELP
        MODIFICATION OF THE WYZ METHOD
           2 - MODIFIED WYZ METHOD WITH MAXIMUM
           3 - MODIFIED WYZ METHOD WITH ABSOLUTE VALUE
      $CHECK(MET2,2,'2\3',4)
      $NET2=MET2
      $HELP
        PARAMETER FOR DESCENT CG METHOD
      $CHECK(ETA3,'0.5$P 0',REAL,4)
    $ENDIF
  $ELSEIF(NET<10)
    $DEFAULT=3
    $HELP
      MODIFICATION OF THE CG METHOD
        -1 OR 1 - BASIC AND COMBINED CG METHOD
        -2 OR 2 - BASIC OR COMBINED TWO STEP DESCENT CG METHOD
        -3 OR 3 - IMPROVED CG METHOD WITH SCALED GRADIENT
        -4 OR 4 - THREE TERM DESCENT CG METHOD
        -5 OR 5 - MODIFIED DESCENT CG METHOD
        -6 OR 6 - MODIFIED DESCENT CG METHOD WITH SCALED GRADIENT
       MET1 > 0 - STANDARD CG METHOD
       MET1 < 0 - POSITIVE CG METHOD
    $CHECK(MET1,DEFAULT,'-6\-5\-4\-3\-2\-1\1\2\3\4\5\6',4)
    $NET1=MET1
    $IF(MET1=-1) $NET1=1
    $IF(MET1=-2) $NET1=2
    $IF(MET1=-3) $NET1=3
    $IF(MET1=-4) $NET1=4
    $IF(MET1=-5) $NET1=5
    $IF(MET1=-6) $NET1=6
    $IF(NET1<3)
      $MET2=1
      $NET2=MET2
    $ELSEIF(NET1=3)
    $ELSEIF(NET1=4)
      $MET2=1
      $NET2=MET2
    $ELSEIF(NET1<7)
      $IF(NET<7)
        $MET2=1
        $NET2=MET2
      $ELSE
        $HELP
          MODIFICATION OF THE DESCENT METHOD
            -1 OR 1 - BASIC DESCENT METHOD
            -2 OR 2 - MODIFIED DESCENT METHOD
           MET2 > 0 - METHOD WITH AFFINE COMBINATION
           MET2 < 0 - METHOD WITH CONVEX COMBINATION
        $CHECK(MET2,1,'-2\-1\1\2',4)
        $NET2=MET2
        $IF(MET2=-1) $NET2=1
        $IF(MET2=-2) $NET2=2
      $ENDIF
      $DEFAULT='1.0$P 0'
      $IF (NET<7) $DEFAULT='0.5$P 0'
      $HELP
        PARAMETER FOR DESCENT CG METHOD
      $CHECK(ETA3,DEFAULT,REAL,4)
    $ENDIF
  $ELSE
    $HELP
      MODIFICATION OF THE CG METHOD
         1 - STANDARD CG METHOD
        -1 - POSITIVE CG METHOD
    $CHECK(MET1,1,'-1\1',4)
    $NET1=MET1
    $IF(MET1=-1) $NET1=1
    $IF(NET=10) 
      $HELP
        MODIFICATION OF THE DLHX METHOD
           1 - BFGS INVERSE SCALING
           2 - DFP INVERSE SCALING
           3 - HOSHINO INVERSE SCALING 
      $CHECK(MET2,1,'1\2\3',4)
      $NET2=MET2
      $HELP
        PARAMETER FOR DESCENT CG METHOD
      $CHECK(ETA3,'1.0$P 0',REAL,4)
      $HELP
        PARAMETER FOR KOU-DAI METHOD
      $CHECK(ETA6,'0.5$P 0',REAL,4)
      $HELP
        PARAMETER FOR KOU-DAI METHOD
      $CHECK(ETA7,'0.1$P 0',REAL,4)
    $ENDIF  
    $IF(NET=11)
      $HELP
        MODIFICATION OF THE DLHX METHOD
           1 - RESTART FOR XO AND GO APPROXIMATELY ORTHOGONAL
          -1 - RESTART SUPPRESSED
      $CHECK(MET2,1,'-1\1',4)
      $NET2=MET2
      $IF(MET2=-1) $NET2=1
    $ENDIF
  $ENDIF
  $DEFAULT=1
  $IF(NET= 4) $DEFAULT=2
  $IF(NET= 5) $DEFAULT=2
  $IF(NET= 6) $DEFAULT=2
  $IF(NET=10) $DEFAULT=2
  $HELP
    TEST ON CONJUGACY OR ORTHOGONALITY
      1 - BASIC CG METHOD
      2 - CG METHOD WITH THE TEST ON CONJUGACY
      3 - CG METHOD WITH THE TEST ON ORTHOGONALITY
  $CHECK(MET3,DEFAULT,'1\2\3',4)
  $HELP
    SCALING OF THE CG METHOD
      1 - NO SCALING
      2 - BFGS SCALING IN EVERY ITERATION
      3 - DFP SCALING IN EVERY ITERATION
      4 - HOSHINO SCALING IN EVERY ITERATION
  $CHECK(MET4,1,'1\2\3\4',4)
  $IF(NET<4)
    $IF(NET1<8)
      $HELP
        SELECTION OF THE LINE SEARCH MODEL:
          -1 OR  1 - QUADRATIC MODEL
          -5 OR  5 - MODIFIED QUASI-NEWTON CONDITION (3 TERMS)
          -6 OR  6 - MODIFIED QUASI-NEWTON CONDITION (4 TERMS)
          MET5 > 0 - NO CORRECTION
          MET5 < 0 - CORRECTION FOR GLOBAL CONVERGENCE
      $CHECK(MET5,4,'-6\-5\-1\1\5\6',4)
      $NET5=MET5
      $IF(MET5= -1) $NET5= 1
      $IF(MET5= -5) $NET5= 5
      $IF(MET5= -6) $NET5= 6
    $ELSEIF(NET1=8)
    $ELSE
      $HELP
        CHOICE OF CORRECTIONL:
          MET5 = -1 - NO CORRECTION
          MET5 =  1 - CORRECTION FOR GLOBAL CONVERGENCE
      $CHECK(MET5,4,'-1\1',4)
      $NET5=1
    $ENDIF
  $ELSE
    $HELP
      CHOICE OF CORRECTIONL:
        MET5 = -1 - NO CORRECTION
        MET5 =  1 - CORRECTION FOR GLOBAL CONVERGENCE
    $CHECK(MET5,4,'-1\1',4)
    $NET5=1
  $ENDIF
  $HELP
    THE USE OF PERIODIC RESTARTS
      1 - PERIODIC RESTARTS AFTER    N ITERATIONS
      2 - PERIODIC RESTARTS AFTER  2*N ITERATIONS
      3 - PERIODIC RESTARTS AFTER 12*N ITERATIONS
  $CHECK(MOS1,3,'1\2\3',4)
  $IF($DEF(KDS))
  $ELSE
    $DEFAULT=0
    $IF(KDF>0) $DEFAULT=1
    $IF(KDA>0) $DEFAULT=1
    $IF(KDE>0) $DEFAULT=1
    $IF(KDY>0) $DEFAULT=1
    $IF(DEFAULT=1)
      $HELP
        DEGREE OF DIRECTIONAL DERIVATIVES IN LINE SEARCH:
          0 - NO DIRECTIONAL DERIVATIVES
          1 - FIRST DIRECTIONAL DERIVATIVES
      $CHECK(KDS,$DEFAULT,'0\1',4,NO)
    $ELSE
      $KDS=0
    $ENDIF
  $ENDIF
  $IF(SEARCH='H')
    $DEFAULT=3
    $IF(KDS=0) $DEFAULT=2
    $HELP
      TERMINATION CRITERION:
        1-PERFECT LINE SEARCH
        2-GOLDSTEIN STEPSIZE
        3-WEAK WOLFE STEPSIZE
        4-STRONG WOLFE STEPSIZE
        5-ARMIJO STEPSIZE
    $CHECK(KTERS,DEFAULT,'1\2\3\4\5',4)
    $HELP
      TERMINATION TOLERANCE FOR LINE SEARCH
      (IN TEST ON THE CHANGE OF THE FUNCTION VALUE)
    $CHECK(EPS1,'1.0$P-1',REAL,4)
    $DEFAULT='1.0$P-1'
    $IF(KTERS=2) $DEFAULT='9.0$P-1'
    $IF(KTERS=3) $DEFAULT='9.0$P-1'
    $HELP
      TERMINATION TOLERANCE FOR LINE SEARCH
      (IN TEST ON THE CHANGE OF THE DIRECTIONAL DERIVATES)
    $CHECK(EPS2,DEFAULT,REAL,4)
  $ELSE
    $DEFAULT=4
    $IF(KDS=0) $DEFAULT=2
    $HELP
      TERMINATION CRITERION:
        1-PERFECT LINE SEARCH
        2-GOLDSTEIN STEPSIZE
        3-WEAK WOLFE STEPSIZE
        4-STRONG WOLFE STEPSIZE
        5-ARMIJO STEPSIZE
    $CHECK(KTERS,DEFAULT,'1\2\3\4\5',4)
    $DEFAULT='1.0$P-4'
    $IF(KDS=0) $DEFAULT='1.0$P-1'
    $HELP
      TERMINATION TOLERANCE FOR LINE SEARCH
      (IN TEST ON THE CHANGE OF THE FUNCTION VALUE)
    $CHECK(EPS1,DEFAULT,REAL,4)
    $DEFAULT='1.0$P-1'
    $IF(KTERS=2) $DEFAULT='9.0$P-1'
    $IF(KTERS=3) $DEFAULT='9.0$P-1'
    $HELP
      TERMINATION TOLERANCE FOR LINE SEARCH
      (IN TEST ON THE CHANGE OF THE DIRECTIONAL DERIVATES)
    $CHECK(EPS2,DEFAULT,REAL,4)
  $ENDIF
  $IF(MET3=2)
    $DEFAULT='5.0$P-2'
$REM    $IF(KTERS=3) $DEFAULT='2.0$P-1'
    $HELP
      TOLERANCE FOR TEST ON CONJUGACY
    $CHECK(ETA5,DEFAULT,REAL,4)
  $ELSEIF(MET3=3)
    $DEFAULT='6.0$P-1'
$REM    $IF(KTERS=3) $DEFAULT='1.0$P 0'
    $IF(NET<4) $DEFAULT='1.0$P 0'
    $HELP
      TOLERANCE FOR TEST ON ORTHOGONALITY
    $CHECK(ETA5,DEFAULT,REAL,4)
  $ENDIF
  $DEFAULT=1
  $IF(MOS1=2) $DEFAULT= 2
  $IF(MOS1=3) $DEFAULT=12
  $IF(MET=0) $DEFAULT=999
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES1,DEFAULT,INT,4)
  $DEFAULT=0
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES2,DEFAULT,INT,4)
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)')
  $ADD(REAL,'\UX$(POM1)DOT')
  $ADD(REAL,'\RGMG\RGTG\RGMD\RGTD\RDTD\BET\GAM\GNORMO\RHO\TAU')
  $ADD(REAL,'\RNUM\RDEN\RDES')
  $OPTION(LFORTO=.FALSE.)
  $$DINIT
  $OPTION(LFORTO=.TRUE.)
  CALL UOD0D1(R,GNORM)
  GNORMO=GNORM
  RGMG=GNORM*GNORM
  RGTG=UX$(POM1)DOT($N,$GN,$GN$POM2
  GNORM=SQRT(RGTG)
  RGMD=PO
  RGTD=P
  RDTD=SNORM*SNORM
  INITD=MAX(ABS(INITD),1)
  IF (IREST.NE.0) THEN
  TUXX='INITIAL '
  E=ONE
  GO TO $10
  ENDIF
  $IF(NET<7)
  $ELSEIF(NET<10)
    $ADD(REAL,'\$GP($NF)')
    CALL UX$(POM1)DIF($N,$GO,$XO,$GP)
    $SUBST('UXZGPY')
  $ENDIF
  $IF(MET<0)
    $XO=SN
    RGMD=RGMD/R
    RGTD=RGTD/R
  $ELSE
    RGMG=RGMG*R
    SNORM=SNORM*R
  $ENDIF
*
*     DETERMINATION OF THE SCALING FACTOR
*
  $IF(MET4>1)
    RGMG=RGMG*E
    $IF(MET4=2)
      $SUBST('UXZYTY')
      $SUBST('UXZDTY')
      IF (RYTY.GT.ZERO) THEN
      E=RDTY/RYTY
    $ELSEIF(MET4=3)
      $SUBST('UXZDTY')
      IF (RDTY.GT.ZERO) THEN
      E=RDTD/RDTY
    $ELSE
      $SUBST('UXZYTY')
      IF (RYTY.GT.ZERO) THEN
      E=SQRT(RDTD/RYTY)
    $ENDIF
    $IF(MET<0)
      E=R*E
    $ENDIF
    E=MIN(E,6.0$P 0)
    E=MAX(E,1.0$P 0)
    ELSE
    E=ONE
    ENDIF
  $ENDIF
*
*     NONQUADRATIC CORRECTION
*
  $IF(NET5=1)
    RHO=ONE
  $ELSEIF(NET5<5)
    $IF(NET5=2)
      POM1=(F-FO)/PO
      POM2=P/PO
      IF (POM1.EQ.POM2.OR.POM2.EQ.ONE) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(POM2-POM1)
      ENDIF
    $ELSEIF(NET5=3)
      POM1=(F-FO)/PO
      POM2=P/PO
      IF (TWO*(POM2-ONE)-THREE*(POM1-ONE).EQ.ZERO) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(TWO*(POM2-ONE)-THREE*(POM1-ONE))
      ENDIF
    $ELSEIF(NET5=4)
      POM1=(F-FO)/PO
      POM2=P/PO
      IF (POM1.EQ.ONE.OR.POM2.EQ.POM1) THEN
      RHO=ONE
      ELSE
      RHO=(POM1-ONE)/(POM2-POM1)
      ENDIF
    $ENDIF
    IF(RHO.LE.$CON4) RHO=ONE
    IF(RHO*$CON4.GE.ONE) RHO=ONE
    IF (RHO.NE.ONE) CALL UXVSCL($N,ONE/RHO,$GO,$GO)
  $ELSEIF(NET5<7)
    $IF(NET5=5)
      RHO=(P+PO-TWO*(F-FO))/SNORM**2
    $ELSEIF(NET5=6)
      RHO=THREE*(P+PO-TWO*(F-FO))/SNORM**2
    $ENDIF
    $IF(MET<0)
      RHO=RHO/R
    $ENDIF
    IF (RHO.GT.ZERO) CALL UXVDIR($N,RHO,$XO,$GO,$GO)
    RHO=ONE
  $ENDIF
  $IF(MET5<0)
    IF (GNORM.GE.ONE) THEN
    TAU=1.0D-4*GNORM
    ELSE
    TAU=1.0D-4*GNORM**3
    ENDIF
    CALL UXVDIR($N,TAU,$XO,$GO,$GO)
  $ENDIF
*
*     DEFINITION OF PARAMETERS FOR CG FORMULAS
*
  $IF(NET<4)
    $SUBST('UXZGTY')
    RNUM=RGTY
    $IF(NET1<4)
    $ELSEIF(NET1<8)
      $SUBST('UXZYTY')
      RDES=RYTY
    $ENDIF
    $IF(NET=1)
      $SUBST('UXZDTY')
      RDEN=RDTY
      TUXX='HS      '
    $ELSEIF(NET=2)
      RDEN=RGMG
      TUXX='PR      '
    $ELSEIF(NET=3)
      RDEN=-RGMD
      TUXX='LS      '
    $ENDIF
  $ELSEIF(NET<7)
    RNUM=RGTG
    $IF(NET1<4)
    $ELSEIF(NET1<8)
      RDES=RGTG
    $ENDIF
    $IF(NET=4)
      $SUBST('UXZDTY')
      RDEN=RDTY
      TUXX='DY      '
    $ELSEIF(NET=5)
      RDEN=RGMG
      TUXX='FR      '
    $ELSEIF(NET=6)
      RDEN=-RGMD
      TUXX='CD      '
    $ENDIF
  $ELSEIF(NET<10)
    $SUBST('UXZGPY')
    RNUM=RGPY
    $IF(NET1<4)
    $ELSEIF(NET1<8)
      $IF(NET2=1)
        $SUBST('UXZYPY')
        RDES=RYPY
      $ELSE
        $SUBST('UXZYTY')
        RDES=RYTY
      $ENDIF
    $ENDIF
    $IF(NET=7)
      $SUBST('UXZDTY')
      RDEN=RDTY
      TUXX='HSP     '
    $ELSEIF(NET=8)
      RDEN=RGMG
      TUXX='PRP     '
    $ELSEIF(NET=9)
      RDEN=-RGMD
      TUXX='LSP     '
    $ENDIF
  $ENDIF
*
*     CONJUGATE GRADIENT DIRECTION
*
  $IF(NET=0)
    TUXX='ST.DESC.'
  $ELSEIF(NET<10)
    IF (RDEN.LE.ZERO) GO TO $10
    BET=RNUM/RDEN
    $IF(NET1=1)
      $IF(NET2=2)
        GAM=RGTG/RDEN
        BET=MAX(-(ONE-EPS2)/(ONE+EPS2)*GAM,MIN(BET,GAM))
        TUXX(4:8)='COM  '
      $ENDIF
      $IF(MET2<0)
        BET=MAX(BET,ZERO)
      $ENDIF
    $ELSEIF(NET1=2)
      $IF(NET2=1)
        GAM=RGTD/RGTG
        TUXX(4:8)='    S'
      $ELSEIF(NET2=2)
        GAM=RGTG/RDEN
        BET=MAX(-(ONE-EPS2)/(ONE+EPS2)*GAM,MIN(BET,GAM))
        GAM=RGTD/RGTG
        TUXX(4:8)='COM S'
      $ENDIF
      $IF(MET2<0)
        BET=MAX(BET,ZERO)
      $ENDIF
    $ELSEIF(NET1=3)
      $SUBST('UXZDTY')
      GAM=RDTY/RDEN
      TUXX(4:8)='IMP S'
    $ELSEIF(NET1=4)
      $IF(NET<4)
        $IF(MET2=1)
          GAM=RGTD/RDEN
          TUXX(4:8)='EXT 1'
        $ELSE
          PAR=UXVDOT($N,$SN,$GO)+SNORM*SQRT(UXVDOT($N,$GO,$GO))
          IF (PAR.EQ.ZERO) THEN
          PAR=ONE
          ELSE
          PAR=ONE-0.1$P 0*GNORMO**2/PAR
          IF (PAR.LT.ZERO) PAR=ONE
          ENDIF
          GAM=PAR*RGTD/RDEN
          TUXX(4:8)='EXT 2'
        $ENDIF
      $ELSEIF(NET<7)
        $SUBST('UXZGTY')
        IF (ABS(RGTY).GE.$CON1*ABS(RGTD)) THEN
        GAM=BET*RGTD/RGTY
        TUXX(4:8)='EXT 1'
        ELSE
        GAM=ZERO
        ENDIF
      $ELSEIF(NET<10)
        $GO='GP'
        GAM=RGTD/RDEN
        TUXX(4:8)='EXT 1'
      $ENDIF
    $ELSEIF(NET1=5)
      GAM=(RGTD/RDEN)*(RDES/RDEN)
      $IF(MET2>0)
        BET=BET-ETA3*GAM
      $ELSEIF(MET2=-1)
        BET=MAX(ZERO,BET)-ETA3*GAM
      $ENDIF
      TUXX(4:8)='DES  '
    $ELSEIF(NET1=6)
      $SUBST('UXZDTY')
      IF (RDTY.LE.ZERO) RDTY=RDEN
      GAM=(RGTD/RDTY)*(RDES/RDEN)
      $IF(MET2>0)
        BET=BET-ETA3*GAM
      $ELSEIF(MET2=-1)
        BET=MAX(ZERO,BET)-ETA3*GAM
      $ENDIF
      TUXX(4:8)='DES  '
      GAM=RDTY/RDEN
      TUXX(8:8)='S'
    $ELSEIF(NET1=7)
      GAM=(RGTD/RDEN)*(RDES/RDEN)
      $IF(MET2>0)
        BET=BET-ETA3*GAM
      $ELSEIF(MET2=-1)
        BET=MAX(ZERO,BET)-ETA3*GAM
      $ENDIF
      TUXX(4:8)='DES  '
      GAM=RGTD/RDEN
      TUXX(8:8)='E'
    $ELSEIF(NET1=8)
      $IF(MET2>0)
        BET=BET-$PAR*RHO/RDEN
      $ELSE
        BET=MAX(ZERO,BET)-$PAR*RHO/RDEN
      $ENDIF
      TUXX(4:8)='DL   '
    $ELSEIF(NET1=9)
      GAM=RGTG-RGTY
      $IF(NET2=2)
        RDEN=RDEN+ETA3*MAX(ZERO,RGTD)
      $ELSEIF(NET2=3)
        RDEN=RDEN+ETA3*ABS(RGTD)  
      $ENDIF  
      $IF(MET2>0)
        BET=(RGTG-(GNORM/GNORMO)*GAM)/RDEN
      $ELSE
        BET=(RGTG-MIN(ONE,GNORM/GNORMO)*GAM)/RDEN
      $ENDIF
      TUXX(4:8)='WYL  '
    $ELSEIF(NET1=10)
      GAM=RGTG-RGTY
      $IF(NET2=2)
        RDEN=RDEN+ETA3*MAX(ZERO,RGTD)
      $ELSEIF(NET2=3)
        RDEN=RDEN+ETA3*ABS(RGTD)  
      $ENDIF  
      BET=(RGTG-ABS(GAM))/RDEN
      TUXX(4:8)='MOD  '
    $ENDIF
  $ELSEIF(NET=10)
    $SUBST('UXZGTY')
    $SUBST('UXZDTY')
    $SUBST('UXZYTY')
    $SUBST('UXZDTD')
    IF (RDTY.LE.ZERO) GO TO $10
    $IF(NET2=1) 
      RHO=ETA3*RYTY/RDTY
    $ELSEIF(NET2=2) 
      RHO=ETA3*RDTY/RDTD 
    $ELSEIF(NET2=3) 
      RHO=ETA3*SQRT(RYTY/RDTD)
    $ENDIF   
    BET=RGTY/RDTY-(RHO+RYTY/RDTY)*(RGTD/RDTY)
    GAM=MAX(BET,ETA7*RGTD/RDTD)
    IF (GAM.EQ.BET) THEN
    GAM=ETA6*RGTD/RDTD
    ELSE
    BET=GAM
    GAM=ZERO
    ENDIF
    TUXX='KD      '
  $ELSEIF(NET=11)
    $SUBST('UXZGTY')
    $IF(MET2>0)
      $SUBST('UXZDTY')
      $SUBST('UXZYTY')
      IF (ABS(RDTY).LE.$CON5*SNORM*SQRT(RYTY)) THEN
      BET=ZERO
      ELSE
    $ENDIF
      RDEN=$CON7*ABS(RGTD)-RGMD
      RNUM=$CON6*GNORM/SNORM
      BET=(RGTG-(GNORM/GNORMO)*(RGTG-RGTY)-RNUM*RGTD)/RDEN
      GAM=(GNORM/GNORMO)*RGTD/RDEN
    $IF(MET2>0)
      ENDIF
    $ENDIF
  $ENDIF
  $IF(NET=0)
  $ELSE
    $IF(MET1<0)
      BET=MAX(ZERO,BET)
      TUXX(4:4)='+'
    $ENDIF
    IF (BET.EQ.ZERO) THEN
    CALL UYRES1('NEG. BET')
    GO TO $10
    ENDIF
    $IF(NET=10)
      CALL UX$(POM1)DIR($N,-BET,$XO,$GN,$SN$POM2
      CALL UX$(POM1)DIR($N,-GAM,$GO,$SN,$SN$POM2
      CALL UX$(POM1)NEG($N,$SN,$SN$POM2
    $ELSEIF(NET=11)
      CALL UX$(POM1)DIF($N,$GN,$GO,$GO$POM2
      CALL UX$(POM1)DIR($N,-BET,$XO,$GN,$SN$POM2
      CALL UX$(POM1)DIR($N,-GAM,$GO,$SN,$SN$POM2
      CALL UX$(POM1)NEG($N,$SN,$SN$POM2
    $ELSEIF(NET1=1)
      CALL UX$(POM1)DIR($N,-BET,$XO,$GN,$SN$POM2
      CALL UX$(POM1)NEG($N,$SN,$SN$POM2
    $ELSEIF(NET1=2)
      CALL UX$(POM1)SCL($N,BET,$XO,$SN$POM2
      CALL UX$(POM1)DIR($N,-(ONE+BET*GAM),$GN,$SN,$SN$POM2
    $ELSEIF(NET1=4)
      CALL UX$(POM1)DIR($N,-BET,$XO,$GN,$SN$POM2
      CALL UX$(POM1)DIR($N, GAM,$GO,$SN,$SN$POM2
      CALL UX$(POM1)NEG($N,$SN,$SN$POM2
    $ELSEIF(NET1=3)
      CALL UX$(POM1)SCL($N,BET,$XO,$SN$POM2
      CALL UX$(POM1)DIR($N,-GAM,$GN,$SN,$SN$POM2
    $ELSEIF(NET1=5)
      CALL UX$(POM1)DIR($N,-BET,$XO,$GN,$SN$POM2
      CALL UX$(POM1)NEG($N,$SN,$SN$POM2
    $ELSEIF(NET1=6)
      CALL UX$(POM1)SCL($N,BET,$XO,$SN$POM2
      CALL UX$(POM1)DIR($N,-GAM,$GN,$SN,$SN$POM2
    $ELSEIF(NET1=7)
      CALL UX$(POM1)DIF($N,$XO,$GO,$GO)
      CALL UX$(POM1)DIR($N,-BET,$XO,$GN,$SN$POM2
      CALL UX$(POM1)DIR($N, GAM,$GO,$SN,$SN$POM2
      CALL UX$(POM1)NEG($N,$SN,$SN$POM2
    $ELSE
      CALL UX$(POM1)DIR($N,-BET,$XO,$GN,$SN$POM2
      CALL UX$(POM1)NEG($N,$SN,$SN$POM2
    $ENDIF
*
*     SCALING THE DIRECTION VECTOR
*
    $IF(MET4=1)
    $ELSE
      CALL UXVSCL($N,E,$SN,$SN)
    $ENDIF
    SNORM=DSQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
    $IF(MET3=2)
      TDXX='CONJ  CG'
      $SUBST('UXZYTY')
      IF (ABS(UX$(POM1)DOT($N,$SN,$GO$POM2).GT.ETA5*SQRT(RYTY)*SNORM)&
      THEN
      CALL UYRES1('NONCONJ.')
      GO TO $10
      ENDIF
    $ELSEIF(MET3=3)
      TDXX='ORTH  CG'
      $SUBST('UXZGTY')
      IF (ABS(RGTG-RGTY).GT.ETA5*GNORM*GNORM) THEN
      CALL UYRES1('NONORTH.')
      GO TO $10
      ENDIF
    $ENDIF
    GO TO $20
  $ENDIF
$10 ITERD=0
*
*     STEEPEST DESCENT DIRECTION
*
  CALL UX$(POM1)NEG($N,$GN,$SN$POM2
*
*     SCALING THE DIRECTION VECTOR
*
  $IF(MET4=1)
  SNORM=GNORM
  $ELSE
    CALL UXVSCL($N,E,$SN,$SN)
    SNORM=E*GNORM
  $ENDIF

  CALL UYSET3
$20 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $XO=XOS
  $GO=GOS
  $ADD(INIT)
    NDXX='UDVLC1'
  $ENDADD
  $EXIT

