$INTERFACE UE1F01                                             98/12/01

      $IF(LED<0)
 $00    CALL UE1F01(NE,KE)
        GOTO ($40,$10) ISB+1
 $10    CONTINUE
        $IF(DMODE='D')
          $MTYPE='D'
          $SUBST('UZEMOD')
          $SUBST('UESVD1')
          GOTO $00
        $ELSEIF(FMODE='F')
          $MTYPE=FMODE
          $SUBST('UZEMOD')
 $15    CONTINUE
          $SUBST('UE0D$(CON)1')
          GO TO ($30,$20) ISB+1
 $20    CONTINUE
          $MTYPE=FMODE
          $SUBST('UZEMOD')
          GOTO $15
 $30    CONTINUE
          $SUBST('UESVD1')
          GOTO $00
        $ELSE
          $MTYPE=FMODE
          $SUBST('UZEMOD')
          $SUBST('UESVD1')
          GOTO $10
        $ENDIF
 $40    CONTINUE
        $ADD(INIT)
          NEXX='UE1F01'
        $ENDADD
      $ELSE
        $SUBST('UE1F02')
      $ENDIF
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UE1F01             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE RIHGT HAND SIDE FUNCTION.
*
* PARAMETERS :
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UE1F01(NE,KE)
      $INCLUDE ('UMCOMM')
      INTEGER NE,KE
      IF (TSS(NS).NE.'UEXX') CALL UYPRO1('UEXX',-1)
      GO TO (1,3) ISP(NS)
    1 CONTINUE
      KE=1
    2 IF (KE.GT.NE) GOTO 6
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      KE=KE+1
      GO TO 2
    6 CONTINUE
      CALL UYEPI1(-1)
      RETURN
      END
