* SUBROUTINE UNFUN3                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* THE CUBIC EQUATION FOR THE DETERMINATION OF THE SHIFT PARAMETER.
*
* PARAMETERS :
*  RI  X  CURRENT VALUE OF A VARIABLE.
*
      FUNCTION UNFUN3(X)
      $FLOAT B,AA,AH,CH
      COMMON /UMFUN3/ B,AA,AH,CH
      $FLOAT X,UNFUN3
      $FLOAT Y,D,DD
      $FLOAT ZERO,ONE,TWO,THREE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0,TWO=2.0$P 0,THREE=3.0$P 0)
      D=AH*CH-B*B
      Y=B*X
      DD=ABS(AA*B*D)
      IF (DD.EQ.ZERO) DD=ONE
      UNFUN3=((((B+AA)*Y+TWO*D)*Y+(THREE*AA-B)*D)*Y-TWO*AA*B*D)/DD
      END
