* SUBROUTINE UO3FU2                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF ITERATIONS IN GLOBAL MINIMIZATION
*
* PARAMETERS:
*  II  NITT  TOTAL NUMBER OF ITERATIONS.
*  II  NFVT  TOTAL NUMBER OF OBJECTIVE FUNCTION EVALUATIONS.
*  RI  FVAL  VALUE OF GLOBAL EXTREM.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  ITR  NUMBER OF THE OUTPUT UNIT.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  KOUT3  NUMBER OF ITERATIONS AFTER THAT INFORMATION IS PRINTED.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         MOUT=0 - NO PRINT.
*         MOUT=1 - PRINT OF FINAL RESULTS.
*         MOUT=2 - ADDITIONAL PRINT OF ITERATIONS.
*
      SUBROUTINE UO3FU2(NITT,NFVT,FVAL)
      $INCLUDE ('UMCOMM')
      INTEGER NITT,NFVT
      $FLOAT FVAL
      IF (ABS(MOUT).GT.1) WRITE(ITR,10) NITT,NFVT,FVAL
      IF (ABS(KOUT).GE.1) THEN
      IF (KOUT3.LE.0) WRITE(IWR,10) NITT,NFVT,FVAL
      IF (KOUT3.GT.0) WRITE(IWR,20) NITT,NFVT,FVAL
      ENDIF
   10 FORMAT( 1X,'EXTREM:   NITT =',I5,'   NFVT =',I5,'   F =',$P 18.10)
   20 FORMAT(/1X,'EXTREM:   NITT =',I5,'   NFVT =',I5,'   F =',$P 18.10)
      END

