$INTERFACE UOT1A1                                             98/12/01

  $ADD(REAL,'\$GA($NF)')
  $IF(DDEF=0)
  CALL UOT1A1(NF,NE,$GA,$GA,FA,0)
  $ELSE
  $ADD(REAL,'\$DA($NE)')
  CALL UOT1A1(NF,NE,$GA,$DA,FA,1)
  $ENDIF
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT1A1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NE  DECLARED NUMBER OF DIFERENTIAL EQUATIONS.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  RI  DA(NE)  ADDITIONAL DERIVATIVES OF THE APPROXIMATED FUNCTION.
*  RI  FA  VALUE OF THE APPROXIMATED FUNCTION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES:
* FA,GA(NF)
*
      SUBROUTINE UOT1A1(NF,NE,GA,DA,FA,JOB)
      $INCLUDE('UMCOMM')
      INTEGER NF,NE,JOB
      $FLOAT GA(NF),DA(NE),FA
      INTEGER I
      GOTO(1,4) KD+1
    1 WRITE(IWR,2) 'FA A =',FA
    2 FORMAT(/1X,A6,$P 18.10)
      WRITE(IWR,3) 'GA N =',(GA(I),I=1,NF)
      IF (JOB.GT.0) WRITE(IWR,3) 'DA N =',(DA(I),I=1,NE)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 WRITE(IWR,3) 'GA A =', (GA(I),I=1,NF)
      IF (JOB.GT.0) WRITE(IWR,3) 'DA A =',(DA(I),I=1,NE)
      RETURN
      END
