$INTERFACE UOT2A1                                             98/12/01

  CALL UOT2A1(NF,$GA,$HA,FA)
  $ADD(REAL,'\$GA($NF)\$HA($NF*($NF+1)/2)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT2A1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  RI  HA(NF*(NF+1)/2) HESSIAN MATRIX OF THE APPROXIMATED FUNCTION.
*  RI  FA  VALUE OF THE APPROXIMATED FUNCTION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES:
* FA,GA(NF),HA(NF*(NF+1)/2)
*
      SUBROUTINE UOT2A1(NF,GA,HA,FA)
      $INCLUDE('UMCOMM')
      INTEGER NF
      $FLOAT GA(NF),HA(NF*(NF+1)/2),FA
      INTEGER I
      GOTO(1,4,5) KD+1
    1 WRITE(IWR,2) 'FA A =',FA
    2 FORMAT(/1X,A6,$P 18.10)
      WRITE(IWR,3) 'GA N =',(GA(I),I=1,NF)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 WRITE(IWR,3) 'GA A =', (GA(I),I=1,NF)
      WRITE(IWR,3) 'HA N =', (HA(I),I=1,NF*(NF+1)/2)
      RETURN
    5 WRITE(IWR,3) 'HA A =', (HA(I),I=1,NF*(NF+1)/2)
      RETURN
      END
