$INTERFACE UP1FF7                                             01/12/01

  $SUBST('UZCSET')
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XZL($NX)&
  \$XZU($NX)\$GF($NF)\$CL($NC)\$CU($NC)\$CZL($NC)&
  \$CZU($NC)\$GC($NF)\$G($NF)')
$REM  $ADD(REAL,'\FF\FC\F\CMAX')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICG($NC+1)\$JCG($MC)')
$REM  $ADD(INTEGER,'\NF\NX\NC\MC\KC')
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ---------------------------
*     PENALTY FUNCTION DEFINITION
*     ---------------------------
*
$OPTION(CHDIR=CHPOM)
 $00  CALL UP1FF7(NF,NX,NC,MC,KC,$X,$IX,$XL,$XU,$XZL,$XZU,$GF,$IC&
,$CL,$CU,$CZL,$CZU,$GC,$ICG,$JCG,$XO(NF+1),$GO(NF+1),$G,EPS7,R,FF&
,FC,F,CMAX)
      GO TO ($90,$10,$20,$50,$60) ISB+1
 $10  CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      GO TO $00
 $20  CONTINUE
      $IF(GMODF='G')
        $MTYPE='G'
        $SUBST('UZFMOD')
        GO TO $00
      $ELSEIF(FMODF='F')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GO TO ($40,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $20
 $40  CONTINUE
        GO TO $00
      $ELSEIF(.TRUE.)
        IF (LD.LT.0) GO TO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ELSE
        GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(SAVC>-1)
        IF(LDC.GE.0) THEN
        FC=$CF(KC)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNF3')
        $IF(KBC>0) $SUBST('UCTRF1')
        $IF(ISNC>0)
          $SUBST('UCSVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<0)
        $IF(NCL<>NC)
          $MTYPE=FMODC
          $SUBST('UZCMOD')
          $IF(NORMC>0) $SUBST('UCNRF1')
          $IF(KBC>0) $SUBST('UCTRF1')
          $IF(ISNC>0)
            $SUBST('UCSVF1')
          $ENDIF
          $IF(FMODC<>'F')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $60  CONTINUE
      $IF(SAVC>0)
        IF(LDC.GE.1) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<1)
        $IF(NCL<>NC)
          $IF(GMODC='G')
            $MTYPE='G'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $65  CONTINUE
            $SUBST('UC0G$(CON)3')
            GO TO ($80,$70) ISB+1
 $70  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            GO TO $65
 $80  CONTINUE
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(.TRUE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $90  CONTINUE
      LD=KD
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ----------------------------------
*     END OF PENALTY FUNCTION DEFINITION
*     ----------------------------------
*
$OPTION(CHDIR=CHPOM)
      $ADD(INIT)
        NPXX='UP1FF7'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UP1FF7             ALL SYSTEMS                 01/12/01
C PORTABILITY : ALL SYSTEMS
C 01/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION.
* COMPUTATION OF THE VALUES AND THE GRADIENTS OF THE CONSTRAINT
* FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  IU  KC  INDEX OF THE CONSTRAINT.
*  II  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NX)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NX)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XZL(NX)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NX)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE MODEL FUNCTION.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  RI  GC(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  II  ICG(NC+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  RI  XO(NX+NC)  VECTOR CONTAINING INCREMENTS FOR LOWER INACTIVE
*         MULTIPLIERS.
*  RI  GO(NX+NC)  VECTOR CONTAINING INCREMENTS FOR UPPER INACTIVE
*         MULTIPLIERS.
*  RO  G(NF)  GRADIENT OF THE LAGRANGIAN FUNCTION.
*  RI  EPS7  SMOOTHING PARAMETER.
*  RI  R  STEPSIZE  PARAMETER.
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  CMAX  MAXIMUM CONSTRAINT VIOLATION.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*  RF  UXUDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*
      SUBROUTINE UP1FF7(NF,NX,NC,MC,KC,X,IX,XL,XU,XZL,XZU,GF,IC,CL,CU,
     & CZL,CZU,GC,ICG,JCG,XO,GO,G,EPS7,R,FF,FC,F,CMAX)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,MC,KC,IX(NF),IC(NC),ICG(NC+1),JCG(MC)
      $FLOAT X(NF),XL(NX),XU(NX),XZL(NX),XZU(NX),GF(NF),CL(NC),CU(NC),
     & CZL(NC),CZU(NC),GC(NF),XO(NX+NC),GO(NX+NC),G(NF),EPS7,R,FF,FC,F,
     & CMAX
      LOGICAL L1
      INTEGER I,J,K,KK,L,JP
      $FLOAT TEMP,TEMP1,TEMP2,UXUDOT
      SAVE KK
      SAVE L1
      IF (TSS(NS).NE.'UFXX') CALL UYPRO1('UFXX',-1)
      GO TO (1,2,4,10,12) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 15
      L1=.FALSE.
      IF (R.GT.ZERO) L1=.TRUE.
      IF (LD.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (IEXT.LE.0) THEN
      F= FF
      ELSE
      F=-FF
      ENDIF
      CMAX=ZERO
    3 IF (KD.LT.1) GO TO 5
      IF (LD.GE.1) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      IF (IEXT.LE.0) THEN
      CALL UXVCOP(NF,GF,G)
      ELSE
      CALL UXVNEG(NF,GF,G)
      ENDIF
    5 IF (LD.LT.0) THEN
      FF=F
      F=ZERO
      ENDIF
C      IF (KD.GE.1.AND.LD.LT.1) CALL UXVCOP(NF,G,GF)
      IF (KBF.LE.0) GO TO 8
      IF (LD.LT.0) THEN
      DO 6 I=1,NX
      KK=ABS(IX(I))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      TEMP1=XL(I)-X(I)
      IF (L1) THEN
      TEMP2=XZL(I)+R*XO(I)
      ELSE
      TEMP2=XZL(I)
      ENDIF
      TEMP=SQRT(TEMP1**2+TEMP2**2+EPS7**2)+TEMP1-TEMP2
      F=F+TEMP**2
      CMAX=MAX(CMAX,TEMP1)
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      TEMP1=X(I)-XU(I)
      IF (L1) THEN
      TEMP2=XZU(I)+R*GO(I)
      ELSE
      TEMP2=XZU(I)
      ENDIF
      TEMP=SQRT(TEMP1**2+TEMP2**2+EPS7**2)+TEMP1-TEMP2
      F=F+TEMP**2
      CMAX=MAX(CMAX,TEMP1)
      ENDIF
    6 CONTINUE
      ENDIF
      IF (KD.GE.1.AND.LD.LT.1) THEN
      DO 7 I=1,NX
      KK=ABS(IX(I))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (L1) THEN
      TEMP2=XZL(I)+R*XO(I)
      ELSE
      TEMP2=XZL(I)
      ENDIF
      G(I)=G(I)-TEMP2
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (L1) THEN
      TEMP2=XZU(I)+R*GO(I)
      ELSE
      TEMP2=XZU(I)
      ENDIF
      G(I)=G(I)+TEMP2
      ENDIF
    7 CONTINUE
      ENDIF
    8 IF (KBC.LE.0) GO TO 15
      KC=1
    9 IF (KC.GT.NC) GO TO 15
      KK=ABS(IC(KC))
      IF (KK.EQ.0) GO TO 14
      IF (LD.GE.0) GO TO 11
      CALL UYSET0(3,4)
      RETURN
   10 CONTINUE
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      TEMP1=CL(KC)-FC
      IF (L1) THEN
      TEMP2=CZL(KC)+R*XO(NX+KC)
      ELSE
      TEMP2=CZL(KC)
      ENDIF
      TEMP=SQRT(TEMP1**2+TEMP2**2+EPS7**2)+TEMP1-TEMP2
      F=F+TEMP**2
      CMAX=MAX(CMAX,TEMP1)
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      TEMP1=FC-CU(KC)
      IF (L1) THEN
      TEMP2=CZU(KC)+R*GO(NX+KC)
      ELSE
      TEMP2=CZU(KC)
      ENDIF
      TEMP=SQRT(TEMP1**2+TEMP2**2+EPS7**2)+TEMP1-TEMP2
      F=F+TEMP**2
      CMAX=MAX(CMAX,TEMP1)
      ENDIF
      IF (KK.EQ.5) THEN
      F=F+FC**2
      CMAX=MAX(CMAX,ABS(FC))
      ENDIF
   11 IF (KD.LT.1) GO TO 14
      IF (LD.GE.1) GO TO 14
      CALL UYSET0(4,5)
      RETURN
   12 CONTINUE
      IF (KK.EQ.3.OR.KK.EQ.4) THEN
      IF (L1) THEN
      TEMP= CZU(KC)-CZL(KC)+R*(GO(NX+KC)-XO(NX+KC))
      ELSE
      TEMP= CZU(KC)-CZL(KC)
      ENDIF
      ELSE IF (KK.EQ.1) THEN
      IF (L1) THEN
      TEMP=-CZL(KC)-R*XO(NX+KC)
      ELSE
      TEMP=-CZL(KC)
      ENDIF
      ELSE IF (KK.EQ.2) THEN
      IF (L1) THEN
      TEMP= CZU(KC)+R*GO(NX+KC)
      ELSE
      TEMP= CZU(KC)
      ENDIF
      ELSE IF (KK.EQ.5) THEN
      IF (L1) THEN
      TEMP= CZL(KC)+R*XO(NX+KC)
      ELSE
      TEMP= CZL(KC)
      ENDIF
      ENDIF
      K=ICG(KC)
      L=ICG(KC+1)-K
      DO 13 J=1,L
      JP=ABS(JCG(K))
      G(JP)=G(JP)+TEMP*GC(JP)
      K=K+1
   13 CONTINUE
   14 KC=KC+1
      GO TO 9
   15 CONTINUE
      IF (KD.GE.1.AND.LD.LT.0) THEN
      F=HALF*(F+UXUDOT(NF,G,G,IX,KBF))
      ENDIF
      CALL UYEPI1(-1)
      RETURN
      END
