$INTERFACE UP2FF3                                             98/12/01

  $LHELP=.FALSE.
  $IF(KDF=2) $LHELP=.TRUE.
  $IF(KDC=2) $LHELP=.TRUE.
  $IF(NUMDER=1) $LHELP=.TRUE.
  $IF(LHELP)
  $SUBST('UZCSET')
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $HELP
    MAXIMUM NUMBER OF NONZERO ELEMENTS IN THE
    CONSTRAINT FUNCTION HESSIAN MATRIX
  $CHECK(MHC,100,INT,1)
  $ADD(SINID)
    $SUBST('UCSET8')
  $ENDADD
  $ADD(REAL,'\$GF($NF)\$HF($M)\$GC($NF)\$HC($MHC)\$G($NF)\$H($M)&
  \$CZ($NC)')
$REM  $ADD(REAL,'\FF\FC\F\CMAX')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)\$IH($NF+1)\$JH($M)')
$REM  $ADD(INTEGER,'\NF\NC\NCL\MC\MHC\KC\M')
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ---------------------------
*     PENALTY FUNCTION DEFINITION
*     ---------------------------
*
$OPTION(CHDIR=CHPOM)
 $00  CALL UP2FF3(NF,NC,NCL,MC,MHC,KC,M,$GF,$HF,$GC,$HC,$ICG,$JCG,$G,$H&
,$IH,$JH,$CZ,FF,FC,F,CMAX)
      GO TO ($90,$10,$20,$50,$15,$25,$55) ISB+1
 $10  CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      $IF(FMODF<>'F')
      $ENDIF
      GO TO $00
 $20  CONTINUE
      $IF(GMODF='G')
        $MTYPE='G'
        $SUBST('UZFMOD')
        GO TO $00
      $ELSEIF(FMODF='F')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GO TO ($40,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $20
 $40  CONTINUE
        GO TO $00
      $ELSEIF(.FALSE.)
        IF (LD.LT.0) GO TO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ELSE
        GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(HMODF='H')
        $MTYPE='H'
        $SUBST('UZFMOD')
        GO TO $00
      $ELSEIF(GMODF='G')
        $SUBST('UF1H$(CON)2')
        GO TO ($00,$60) ISB+1
  $60 CONTINUE
        $MTYPE=GMODF
        $SUBST('UZFMOD')
        GO TO $50
      $ELSEIF(FMODF='F')
        $SUBST('UF0H$(CON)2')
        GO TO ($00,$70) ISB+1
  $70 CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $50
      $ELSEIF(FMODF='FG')
        $SUBST('UF1H$(CON)2')
        GO TO ($00,$80) ISB+1
  $80 CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $50
      $ELSEIF(.FALSE.)
        IF (LD.LT.0) GO TO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ELSE
        GO TO $00
      $ENDIF
 $15  CONTINUE
      $IF(SAVC>-1)
        IF(LDC.GE.0) THEN
        FC=$CF(KC)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNF3')
        $IF(KBC>0) $SUBST('UCTRF1')
        $IF(ISNC>0)
          $SUBST('UCSVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<0)
        $IF(NCL<>NC)
          $MTYPE=FMODC
          $SUBST('UZCMOD')
          $IF(NORMC>0) $SUBST('UCNRF1')
          $IF(KBC>0) $SUBST('UCTRF1')
          $IF(ISNC>0)
            $SUBST('UCSVF1')
          $ENDIF
          $IF(FMODC<>'F')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
          $ENDIF
          $IF(FMODC='FGH')
            $IF(NORMC>0) $SUBST('UCNRH3')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $25  CONTINUE
      $IF(SAVC>0)
        IF(LDC.GE.1) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<1)
        $IF(NCL<>NC)
          $IF(GMODC='G')
            $MTYPE='G'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $26  CONTINUE
            $SUBST('UC0G$(CON)3')
            GO TO ($45,$35) ISB+1
 $35  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            GO TO $26
 $45  CONTINUE
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(.FALSE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $55  CONTINUE
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
$REM        $SUBST('UCLNH3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<2)
        $IF(NCL<>NC)
          $IF(HMODC='H')
            $MTYPE='H'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRH3')
            GO TO $00
          $ELSEIF(GMODC='G')
            $SUBST('UC1H$(CON)3')
            GO TO ($00,$65) ISB+1
 $65 CONTINUE
            $MTYPE=GMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            GO TO $55
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $66  CONTINUE
            $SUBST('UC0H$(CON)3')
            GO TO ($00,$75) ISB+1
 $75  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            GO TO $66
          $ELSEIF(FMODC='FG')
            $SUBST('UC1H$(CON)3')
            GO TO ($00,$85) ISB+1
 $85  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            GO TO $55
          $ELSEIF(.FALSE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(NORMC>0) $SUBST('UCNRH3')
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $90  CONTINUE
      LD=KD
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ----------------------------------
*     END OF PENALTY FUNCTION DEFINITION
*     ----------------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INIT)
  NPXX='UP2FF3'
$ENDADD
$ELSE
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     -------------------------
*     NUMERICAL DIFFERENTIATION
*     -------------------------
*
$OPTION(CHDIR=CHPOM)
      ISNCS=ISNC
 $00  CALL UP2PF3
      GO TO ($30,$10,$20) ISB+1
 $10  CONTINUE
      IF (TSS(NS).NE.'UPXX') THEN
      LD=MIN(LD,0)
      LDC=MIN(LDC,0)
      $IF(NCL<>NC)
        $IF(GMODC<>'G')
          $IF(FMODC='F')
            LD=-1
            LDC=-1
          $ENDIF
        $ENDIF
      $ENDIF
      ENDIF
      $SUBST('UP1FF3')
      IF (TSS(NS).EQ.'UPXX') GO TO $00
 $20  CONTINUE
      $GFS=GF
      $XSS=XS
      $XS=GS
      $GF=G
      $KHLP=1
      $IF(KDF<1)
        $IF(KDC<1) $KHLP=0
      $ENDIF
      ISNC=0
      $SUBST('UF$(KHLP)H$(CON)2')
      GO TO ($00,$10) ISB+1
 $30  CONTINUE
      ISNC=ISNCS
      $GF=GFS
      $XS=XSS
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     --------------------------------
*     END OF NUMERICAL DIFFERENTIATION
*     --------------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INIT)
  NPXX='UP1FF3'
  NFHX='UF$(KHLP)H$(CON)2'
$ENDADD
$ENDIF
$EXIT

* IMPLEMENTATION

* SUBROUTINE UP2FF3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION.
* COMPUTATION OF THE VALUES AND THE GRADIENTS OF THE CONSTRAINT
* FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  NCL  NUMBER OF LINEAR CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  II  MHC  NUMBER OF NONZERO ELEMENTS OF HC.
*  IU  KC  INDEX OF THE CONSTRAINT.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  II  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NF)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NF)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE MODEL FUNCTION.
*  II  HF(M)  SPARSE HESSIAN MATRIX OF THE MODEL FUNCTION.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  RI  GC(NF)  GRADIENT OF THE SELECTED CONSTRAINT FUNCTION.
*  II  HC(ME)  SPARSE HESSIAN MATRIX OF THE CONSTRAINT FUNCTION.
*  II  ICG(NC+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  H(M)  SPARSE HESSIAN MATRIX OF THE LAGRANGIAN FUNCTION.
*  II  IH(N+1) POINTERS OF DIAGONAL ELEMENTS OF THE SPARSE HESSIAN
*         MATRIX.
*  II  JH(M)  COLUMN INDICES OF NONZERO ELEMENTS OF THE SPARSE HESSIAN
*         MATRIX.
*  RO  FF  VALUE OF THE MODEL FUNCTION.
*  RO  FC  VALUE OF THE CONSTRAINT TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*  RO  CMAX  MAXIMUM CONSTRAINT VIOLATION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*  IU  NAG  NUMBER OF APPROXIMATED FUNCTION GRADIENTS COMPUTED.
*  IU  NAH  NUMBER OF APPROXIMATED FUNCTION HESSIAN MATRICES COMPUTED.
*  IU  NFV  NUMBER OF OBJECTIVE FUNCTION VALUES COMPUTED.
*  IU  NFG  NUMBER OF OBJECTIVE FUNCTION GRADIENTS COMPUTED.
*  IU  NFH  NUMBER OF OBJECTIVE FUNCTION HESSIAN MATRICES COMPUTED.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*  S   UASSH1  COMPUTATION OF THE SPARSE HESSIAN MATRIX FROM THE SPARSE
*         JACOBIAN MATRIX.
*  S   UASSH2  COMPUTATION OF THE SPARSE HESSIAN MATRIX FROM THE SPARSE
*         JACOBIAN MATRIX.
*
      SUBROUTINE UP2FF3(NF,NC,NCL,MC,MHC,KC,M,GF,HF,GC,HC,ICG,JCG,G,H,
     & IH,JH,CZ,FF,FC,F,CMAX)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NC,NCL,MC,MHC,KC,M,ICG(NC+1),JCG(MC),IH(NF+1),JH(M)
      $FLOAT GF(NF),HF(M),GC(NF),HC(MHC),G(NF),H(M),CZ(NC),FF,FC,
     & F,CMAX
      INTEGER J,K,L,JP
      IF (TSS(NS).NE.'UFXX') CALL UYPRO1('UFXX',-1)
      GO TO (1,2,4,6,14,16,18) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 20
      IF (LD.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (IEXT.LE.0) THEN
      F= FF
      ELSE
      F=-FF
      ENDIF
      CMAX=ZERO
    3 IF (KD.LT.1) GO TO 7
      IF (LD.GE.1) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      IF (IEXT.LE.0) THEN
      CALL UXVCOP(NF,GF,G)
      ELSE
      CALL UXVNEG(NF,GF,G)
      ENDIF
    5 IF (KD.LT.2) GO TO 7
      IF (LD.GE.2) GO TO 7
      CALL UYSET0(3,4)
      RETURN
    6 CONTINUE
      IDECF=0
      IF (IEXT.GT.0) THEN
      CALL UXVNEG(M,HF,H)
      ELSE IF (NEXT.GT.0) THEN
      CALL UXVCOP(M,HF,H)
      ENDIF
    7 IF (KD.GE.0.AND.LD.LT.0) FF=F
C      IF (KD.GE.1.AND.LD.LT.1) CALL UXVCOP(NF,G,GF)
      KC=1
   12 IF (KC.GT.NC) GO TO 20
      IF (LD.GE.0) GO TO 15
      CALL UYSET0(4,5)
      RETURN
   14 CONTINUE
      F=F+CZ(KC)*FC
      CMAX=MAX(CMAX,ABS(FC))
   15 IF (KD.LT.1) GO TO 19
      IF (LD.GE.1) GO TO 17
      CALL UYSET0(5,6)
      RETURN
   16 CONTINUE
      K=ICG(KC)
      L=ICG(KC+1)-K
      DO 13 J=1,L
      JP=ABS(JCG(K))
      G(JP)=G(JP)+CZ(KC)*GC(JP)
      K=K+1
   13 CONTINUE
   17 IF (KD.LT.2) GO TO 19
      IF (KC.LE.NCL) GO TO 19
      CALL UYSET0(6,7)
      RETURN
   18 CONTINUE
      IDECF=0
      CALL UASSH2(NF,NC,MC,MHC,M,H,IH,JH,HC,ICG,JCG,KC,CZ(KC))
   19 KC=KC+1
      GO TO 12
   20 CONTINUE
      CALL UYEPI1(-1)
      RETURN
      END
