* INTEGER FUNCTION UQINTI          ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  CONVERT A SUBSTRING TO AN INTEGER NUMBER
*
* PARAMETERS :
*  TI  STRARR(MLEN) - A STRING ARRAY WITH A SUBSTRING
*  II  MLEN - MAX. LENGTH OF STRARR
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF A SUBSTRING IN STRARR
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF A SUBSTRING IN STRARR
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  IF  UQICHR   RETURNS AN ORDINAL NUMBER OF CHARACTER
*
      INTEGER*4 FUNCTION UQINTI(STRARR,MLEN,IPOS1,IPOS2,IER)
      INTEGER MLEN,IPOS1,IPOS2,IER
      CHARACTER*1 STRARR(MLEN)
      INTEGER I,ISIGN,UQICHR
      INTEGER*4 J,K
      K=0
      UQINTI=0
      ISIGN=1
      I=IPOS2
    1 IF(IPOS1.LE.I) THEN
        IF(STRARR(I).EQ.' ') THEN
        ELSEIF(STRARR(I).EQ.'+') THEN
          GOTO 2
        ELSEIF(STRARR(I).EQ.'-') THEN
          ISIGN=-1
          GOTO 2
        ELSE
          J=UQICHR(STRARR(I))
          IF(J.LT.48.OR.J.GT.57) GOTO 4
          J=J-48
          UQINTI=UQINTI+J*10**K
          K=K+1
        ENDIF
        I=I-1
        GOTO 1
      ENDIF
    2 DO 3 J=IPOS1,I-1
        IF(STRARR(J).NE.' ') GOTO 4
    3 CONTINUE
      UQINTI=ISIGN*UQINTI
      RETURN
C
C ERROR: INTEGER CONSTANT EXPECTED
C
    4 IER=26
      RETURN
      END
