* FUNCTION UXDRDU                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE MAXIMUM DIAGONAL ELEMENT OF THE MATRIX R IN THE
* FACTORIZATION A=TRANS(R)*R.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A=TRANS(R)*R.
*  IO  INF  INDEX OF THE MAXIMUM DIAGONAL ELEMENT OF THE MATRIX R.
*  RR  UXDRDU SQUARE OF THE MAXIMUM DIAGONAL ELEMENT OF THE MATRIX A.
*
      FUNCTION UXDRDU(N,A,INF)
      INTEGER N,INF
      $FLOAT A(N*(N+1)/2),UXDRDU
      $FLOAT TEMP
      INTEGER I,J
      J=1
      INF=1
      TEMP=ABS(A(1))
      DO 1 I=2,N
      J=J+I
      IF (TEMP.LT.ABS(A(J))) THEN
      INF=J
      TEMP=ABS(A(J))
      ENDIF
    1 CONTINUE
      UXDRDU=TEMP*TEMP
      RETURN
      END
