* FUNCTION UXDSDU                  ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE MAXIMUM DIAGONAL ELEMENT OF A DENSE SYMMETRIC
* MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  IO  INF  INDEX OF THE MAXIMUM DIAGONAL ELEMENT OF THE MATRIX A.
*  RR  UXDSDU  MAXIMUM DIAGONAL ELEMENT OF THE MATRIX A.
*
      FUNCTION UXDSDU(N,A,INF)
      INTEGER N,INF
      $FLOAT A(N*(N+1)/2),UXDSDU
      $FLOAT TEMP
      INTEGER I,J
      J=1
      INF=1
      TEMP=A(1)
      DO 1 I=2,N
      J=J+I
      IF (TEMP.LT.A(J)) THEN
      INF=J
      TEMP=A(J)
      ENDIF
    1 CONTINUE
      UXDSDU=TEMP
      RETURN
      END
