* SUBROUTINE UXDSMI                ALL SYSTEMS                88/12/01
C PORTABILITY : ALL SYSTEMS
C 88/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DENSE SYMMETRIC MATRIX A IS SET TO THE UNIT MATRIX WITH THE SAME
* ORDER.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RO  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM
*         WHICH IS SET TO THE UNIT MATRIX (I.E. A:=I).
*
      SUBROUTINE UXDSMI( N, A)
      INTEGER N
      $FLOAT  A(N*(N+1)/2)
      INTEGER  I, M
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      M = N * (N+1) / 2
      DO 1  I = 1, M
      A(I) = ZERO
    1 CONTINUE
      M = 0
      DO 2  I = 1, N
      M = M + I
      A(M) = ONE
    2 CONTINUE
      RETURN
      END
