* SUBROUTINE UXSRB2                ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  GET THE REDUCED LENGTH OF THE BLOCK COLUMN.
*
*  PARAMETERS :
*  II  ISTRT BEGINNING OF THE COLUMN.
*  II  ISTOP END OF THE COLUMN.
*  II  MASK1(M) ARRAY MASKING ELIMINATED PARTS OF COLUMNS.
*  IO  LENK  REDUCED LENGTH OF THE COLUMN.
*
      SUBROUTINE UXSRB2(ISTRT,ISTOP,MASK1,LENK)
C
C FOR NEW ORDER
C
C * ZJISTENI REDUKOVANE DELKY BLOKU K,KDE K-TY BLOK JE ZADAN :
C *   BJA1(K)=ISTRT  - ZACATEK BLOKU
C *   BJA2(K)=ISTOP  - KONEC BLOKU
C
      INTEGER STRT,ISTOP,ISTRT,LENK,L,MASK1(*)
      LENK=0
      IF (ISTRT.GT.ISTOP) GOTO 20
      STRT=ISTRT
   10 L=MASK1(STRT)
      IF (L.LT.0) THEN
        IF (-L.GE.ISTOP) GOTO 20
        STRT=1-L
      ELSE IF (L.LT.ISTOP) THEN
             LENK=LENK+L-STRT+1
             STRT=L+1
           ELSEIF(L.EQ.ISTOP) THEN
                 LENK=LENK+L-STRT+1
                 GOTO 20
               ELSE
                 LENK=LENK+ISTOP-STRT+1
                 GOTO 20
      ENDIF
      GOTO 10
 20   CONTINUE
C
      RETURN
      END
