* SUBROUTINE UXSRO8                 ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* CHANGE OF THE TWIN LABELS FOR THE REACHSET OF THE NODE. THE ORIGINAL
* LABELS ARE STORED.
*
*  PARAMETERS :
*  II  NN NUMBER OF VERTICES.
*  IU  BJA1(NN) BEGINNINGS OF THE BLOCK COLUMNS IN A.
*  IU  BJA2(NN) ENDING INDICES OF THE BLOCK COLUMNS IN A.
*  II  RCHSZE SIZE OF THE REACHSET.
*  II  RCHSET(NN) NODES OF THE REACHSET OF NODE.
*
      SUBROUTINE UXSRO8(NN,NODE,BJA1,BJA2,RCHSZE,RCHSET)
C
      INTEGER NN,BJA1(NN),BJA2(NN),RCHSZE,RCHSET(NN)
      INTEGER I,J,ISTRT,ISTOP,NODE,JSTRT,JSTOP

C
C BEG AND END OF THE VERTEX NODE
C
      JSTRT=BJA1(NODE)
      JSTOP=BJA2(NODE)
C
C MAIN CYCLE OF LABEL CHANGE
C
      DO 1000 I=1,RCHSZE
        J=RCHSET(I)
        ISTRT=BJA1(J)
        ISTOP=BJA2(J)
C
C COMPUTE NEW BJA1,BJA2
C
        BJA1(J)=MIN(ISTRT,JSTRT)
        BJA2(J)=MAX(ISTOP,JSTOP)
 1000 CONTINUE
      RETURN
      END
