* SUBROUTINE UXVDIR                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR AUGMENTED BY THE SCALED VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:= Y + A*X.
*
      SUBROUTINE UXVDIR(N,A,X,Y,Z)
      INTEGER N
      $FLOAT  A, X(N), Y(N), Z(N)
      INTEGER I
      DO 1 I=1,N
      Z(I) = Y(I) + A*X(I)
    1 CONTINUE
      RETURN
      END
