* SUBROUTINE UXVSIM             ALL SYSTEMS                   95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR FOR AN INITIAL SIMPLEX CONSTRUCTION.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RU  X(N)  ON INPUT AN INITIAL VECTOR. ON OUTPUT THE SHIFTED VECTOR
*         WHERE X:=X+ALF*Z.
*  RO  Y(N)  STORED INITIAL VECTOR X.
*  RI  Z(N)  VECTOR CONTAINING SCALING PARAMETERS.
*  RI  DEL  SHIFT STEPSIZE.
*  II  JOB  SCALING INDICATOR. IF JOB.EQ.0 THEN SCALING IS SUPPRESSED.
*         IF JOB.GT.0 THEN SCALING IS CONSIDERED.
*

      SUBROUTINE UXVSIM(N,X,Y,D,DEL,JOB)
      INTEGER N,JOB
      $FLOAT X(N),Y(N),D(N),DEL
      INTEGER I
      DO 1 I=1,N
      IF (JOB.GT.0) THEN
      Y(I)=X(I)+DEL*D(I)
      ELSE
      Y(I)=X(I)+DEL
      ENDIF
    1 CONTINUE
      RETURN
      END
