$INTERFACE UYGSET                                             98/12/01

  $HELP
    RADIUS OF THE ACCEPTABLE DOMAIN
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  CALL UYGSET(NF,$X,$XL,$XU,XMAX)
  $ADD(REAL,'\$X($NF)\$XL($NF)\$XU($NF)')
$REM  $ADD(REAL,'\XMAX')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYGSET                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF SIMPLE BOUNDS FOR THE GLOBAL OPTIMIZATION.
*
* PARAMETERS:
*  II  NF DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RU  XL(NF)  VECTOR OF LOWER BOUNDS.
*  RU  XU(NF)  VECTOR OF UPPER BOUNDS.
*  II  XMAX  RADIUS OF THE ACCEPTABLE DOMAIN.
*
* SUBPROGRAMS USED :
*
      SUBROUTINE UYGSET(NF,X,XL,XU,XMAX)
      INTEGER NF
      $FLOAT X(NF),XL(NF),XU(NF),XMAX
      INTEGER I
      DO 1 I=1,NF
      IF (XU(I).LE.XL(I)) THEN
      XL(I)=X(I)-XMAX
      XU(I)=X(I)+XMAX
      ENDIF
    1 CONTINUE
      RETURN
      END

