* SUBROUTINE EIUD31                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES FOR DIFFERENTIAL EQUATIONS.
*
* PARAMETERS :
*  IU  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RO  YA(NE)  INITIAL VALUES.
*  RO  TA  INITIAL TIME.
*  RO  TAMAX  FINAL TIME.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD31(NE,YA,TA,TAMAX,NEXT,IERR)
      INTEGER NE,NEXT,IERR
      $FLOAT YA(NE),TA,TAMAX
      $FLOAT Y(6)
      COMMON /EMPR23/ Y
      YA(1)=0.01$P 0
      YA(2)=0.01$P 0
      YA(3)=0.01$P 0
      GOTO (10,20,30,40,50,60),NEXT
      IERR=0
   10 NE=3
      TA=0.0$P 0
      TAMAX=2.0$P 2
      Y(1)=0.19$P 0
      Y(2)=-1.9644$P 0
      Y(3)=6.31222$P 0
      Y(4)=-2.77$P 0
      Y(5)=-2.61$P 0
      Y(6)=-13.91$P 0
      RETURN
   20 NE=3
      TA=0.0$P 0
      TAMAX=2.0$P 2
      Y(1)=0.19$P 0
      Y(2)=-1.964$P 0
      Y(3)=6.312$P 0
      Y(4)=-2.69$P 0
      Y(5)=-2.383$P 0
      Y(6)=-14.049$P 0
      RETURN
   30 NE=3
      TA=0.0$P 0
      TAMAX=2.0$P 2
      Y(1)=0.604$P 0
      Y(2)=-6.3047$P 0
      Y(3)=3.1264$P 0
      Y(4)=-1.284$P 0
      Y(5)=5.2756$P 0
      Y(6)=7.1022$P 0
      RETURN
   40 NE=3
      TA=0.0$P 0
      TAMAX=2.0$P 2
      Y(1)=-1.164$P 0
      Y(2)=-0.827824$P 0
      Y(3)=-1.306011$P 0
      Y(4)=1.2482$P 0
      Y(5)=-8.532633$P 0
      Y(6)=16.98886$P 0
      RETURN
   50 NE=3
      TA=0.0$P 0
      TAMAX=2.0$P 2
      Y(1)=0.1$P 0
      Y(2)=-1.0$P 0
      Y(3)=0.2$P 0
      Y(4)=-0.17$P 0
      Y(5)=-0.01699$P 0
      Y(6)=-0.1717$P 0
      RETURN
   60 NE=3
      TA=0.0$P 0
      TAMAX=2.0$P 2
      Y(1)=-4.86$P 0
      Y(2)=4.158739$P 0
      Y(3)=5.995615$P 0
      Y(4)=4.8$P 0
      Y(5)=-29.518749$P 0
      Y(6)=156.227451$P 0
      RETURN
      END
