* SUBROUTINE EAFU36             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU36(N,KA,X,FA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),FA
      IF (NEXT.LE.32) THEN
      CALL EAFU16(N,KA,X,FA,NEXT)
      ELSE IF (NEXT.LE.62) THEN
      CALL EAFU17(N,KA,X,FA,NEXT-32)
      ELSE IF (NEXT.LE.94) THEN
      CALL EAFU18(N,KA,X,FA,NEXT-62)
      ENDIF
      RETURN
      END
