* SUBROUTINE ECFU08             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KC  INDEX OF THE CONSTRAINT.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FC VALUE OF THE CONSTRAINT AT THE SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECFU08(N,KC,X,FC,NEXT)
      INTEGER N,KC,NEXT
      INTEGER I
      REAL*8 X(N),FC
      REAL*8 Y(20)
      COMMON /EMPR08/ Y
      REAL*8 X1,X2,X3,X4,X5,ERFUN
      GOTO(10,10,30,40,50,60,70,80,70,100,110,120,130,140,150,160,170,
     * 180,190,190,210,220,230,240,250,240,250,250,290,300,310),NEXT
   10 FC=X(1)**2+X(2)**2
      RETURN
   30 FC=X(1)*(X(1)-4.0D 0)-2.0D 0*X(2)
      RETURN
   40 FC=10.0D 0*(X(2)-X(1)**2)
      RETURN
   50 FC=(1.0D 0+X(1)**2)**2+X(2)**2
      RETURN
   60 GO TO (61,62),KC
   61 FC=X(2)-X(1)**3
      RETURN
   62 FC=X(1)**2-X(2)
      RETURN
   70 FC=(1.0D 0+X(2)**2)*X(1)+X(3)**4
      RETURN
   80 FC=X(1)+X(3)**2
      RETURN
  100 GO TO (101,102),KC
  101 FC=X(1)**2+X(2)**2+X(3)**2
      RETURN
  102 FC=X(1)+X(2)+X(3)
      RETURN
  110 GO TO (111,112),KC
  111 FC=3.0D 0*X(1)-2.0D 0*X(2)**2
      RETURN
  112 FC=4.0D 0*X(1)-X(3)**2
      RETURN
  120 GO TO (121,101),KC
  121 FC=8.0D 0*X(1)+14.0D 0*X(2)+7.0D 0*X(3)
      RETURN
  130 GO TO (131,132),KC
  131 FC=100.0D 1*X(1)**2+100.0D 0*X(2)**2-X(3)
      RETURN
  132 FC=100.0D 0*X(1)**2+400.0D 0*X(2)**2+X(3)
      RETURN
  140 GO TO (141,142),KC
  141 FC=X(2)-X(1)**3-X(3)**2
      RETURN
  142 FC=X(1)**2-X(2)-X(4)**2
      RETURN
  150 GO TO (151,152),KC
  151 FC=X(1)
      RETURN
  152 FC=X(3)**2+X(4)**2
      RETURN
  160 GO TO (161,162),KC
  161 FC=X(3)-2.0D 0*ERFUN(-X(2))
      RETURN
  162 X1=SQRT(24.0D 0)
      FC=X(4)-ERFUN(-X(2)+X1)-ERFUN(-X(2)-X1)
      RETURN
  170 FC=X(1)**2+(X(1)-2.0D 0*X(2))**2+(X(2)-3.0D 0*X(3))**2+
     * (X(3)-4.0D 0*X(4))**2-X(5)**2
      RETURN
  180 GO TO (181,182),KC
  181 FC=X(1)-X(4)**2
      RETURN
  182 FC=X(1)**2+X(2)**2-X(5)**2
      RETURN
  190 GO TO (191,192),KC
  191 FC=X(1)**2*X(4)+SIN(X(4)-X(5))
      RETURN
  192 FC=X(2)+X(3)**4*X(4)**2
      RETURN
  210 GO TO (211,212,213),KC
  211 FC=X(1)**2+3.0D 0*X(2)
      RETURN
  212 FC=X(3)**2+X(4)-2.0D 0*X(5)
      RETURN
  213 FC=X(2)**2-X(5)
      RETURN
  220 GO TO (221,222,223),KC
  221 FC=X(1)*X(2)-X(3)**2
      RETURN
  222 FC=X(1)+X(2)**2-X(4)**2
      RETURN
  223 FC=X(1)+X(5)**2
      RETURN
  230 GO TO (231,232,233),KC
  231 FC=X(1)+X(2)-X(3)**2
      RETURN
  232 FC=X(1)**2+X(2)**2-X(4)**2
      RETURN
  233 FC=X(1)-X(5)**2
      RETURN
  240 GO TO (241,242,243),KC
  241 FC=X(1)+X(2)**2+X(3)**3
      RETURN
  242 FC=X(2)-X(3)**2+X(4)
      RETURN
  243 FC=X(1)*X(5)
      RETURN
  250 GO TO (251,252,253),KC
  251 FC=X(1)**2+X(2)**2+X(3)**2+X(4)**2+X(5)**2
      RETURN
  252 FC=X(2)*X(3)-5.0D 0*X(4)*X(5)
      RETURN
  253 FC=X(1)**3+X(2)**3
      RETURN
  290 X1=131.078D 0
      X2=1.48577D 0
      X3=0.90798D 0/X1
      X4=COS(1.47588D 0)
      X5=SIN(1.47588D 0)
      GO TO (291,292,293,294),KC
  291 FC=-X(1)-X(3)*X(4)*COS(X2-X(6))/X1+X3*X4*X(3)**2
      RETURN
  292 FC=-X(2)-X(3)*X(4)*COS(X2+X(6))/X1+X3*X4*X(4)**2
      RETURN
  293 FC=-X(5)-X(3)*X(4)*SIN(X2+X(6))/X1+X3*X5*X(4)**2
      RETURN
  294 FC=-X(3)*X(4)*SIN(X2-X(6))/X1+X3*X5*X(3)**2
      RETURN
  300 X1=0.0D 0
      X2=0.0D 0
      DO 301 I=1,7
      X1=(0.5D 0*Y(I+7)*(Y(I)*SIN(X(I))-32.0D 0)+X2)*Y(I+7)+X1
      X2=Y(I+7)*(Y(I)*SIN(X(I))-32.0D 0)+X2
  301 CONTINUE
      GO TO (302,303),KC
  302 FC=X1
      RETURN
  303 FC=X2
      RETURN
  310 GO TO (311,312,313),KC
  311 FC=EXP(X(1))+2.0D 0*EXP(X(2))+2.0D 0*EXP(X(3))+EXP(X(6))+
     * EXP(X(10))
      RETURN
  312 FC=EXP(X(4))+2.0D 0*EXP(X(5))+EXP(X(6))+EXP(X(7))
      RETURN
  313 FC=EXP(X(3))+EXP(X(7))+EXP(X(8))+2.0D 0*EXP(X(9))+
     * EXP(X(10))
      RETURN
      END
      FUNCTION ERFUN(X)
      REAL*8 X,ERFUN,P,A1,A2,A3,A4,A5,U,T,Y
      P=0.3275911D 0
      A1=0.254829592D 0
      A2=-0.284496736D 0
      A3=1.421413741D 0
      A4=-1.453152027D 0
      A5=1.061405429D 0
      Y=ABS(X)/SQRT(2.0D 0)
      U=Y**2
      T=1.0D 0/(1.0D 0+P*Y)
      ERFUN=1.0D 0-((((A5*T+A4)*T+A3)*T+A2)*T+A1)*T*EXP(-U)
      IF (ERFUN.NE.0.0D 0) ERFUN=SIGN(ERFUN,X)
      ERFUN=0.5D 0*(1.0D 0+ERFUN)
      RETURN
      END
