* SUBROUTINE EIUD31                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES FOR DIFFERENTIAL EQUATIONS.
*
* PARAMETERS :
*  IU  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RO  YA(NE)  INITIAL VALUES.
*  RO  TA  INITIAL TIME.
*  RO  TAMAX  FINAL TIME.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD31(NE,YA,TA,TAMAX,NEXT,IERR)
      INTEGER NE,NEXT,IERR
      REAL*8 YA(NE),TA,TAMAX
      REAL*8 Y(6)
      COMMON /EMPR23/ Y
      YA(1)=0.01D 0
      YA(2)=0.01D 0
      YA(3)=0.01D 0
      GOTO (10,20,30,40,50,60),NEXT
      IERR=0
   10 NE=3
      TA=0.0D 0
      TAMAX=2.0D 2
      Y(1)=0.19D 0
      Y(2)=-1.9644D 0
      Y(3)=6.31222D 0
      Y(4)=-2.77D 0
      Y(5)=-2.61D 0
      Y(6)=-13.91D 0
      RETURN
   20 NE=3
      TA=0.0D 0
      TAMAX=2.0D 2
      Y(1)=0.19D 0
      Y(2)=-1.964D 0
      Y(3)=6.312D 0
      Y(4)=-2.69D 0
      Y(5)=-2.383D 0
      Y(6)=-14.049D 0
      RETURN
   30 NE=3
      TA=0.0D 0
      TAMAX=2.0D 2
      Y(1)=0.604D 0
      Y(2)=-6.3047D 0
      Y(3)=3.1264D 0
      Y(4)=-1.284D 0
      Y(5)=5.2756D 0
      Y(6)=7.1022D 0
      RETURN
   40 NE=3
      TA=0.0D 0
      TAMAX=2.0D 2
      Y(1)=-1.164D 0
      Y(2)=-0.827824D 0
      Y(3)=-1.306011D 0
      Y(4)=1.2482D 0
      Y(5)=-8.532633D 0
      Y(6)=16.98886D 0
      RETURN
   50 NE=3
      TA=0.0D 0
      TAMAX=2.0D 2
      Y(1)=0.1D 0
      Y(2)=-1.0D 0
      Y(3)=0.2D 0
      Y(4)=-0.17D 0
      Y(5)=-0.01699D 0
      Y(6)=-0.1717D 0
      RETURN
   60 NE=3
      TA=0.0D 0
      TAMAX=2.0D 2
      Y(1)=-4.86D 0
      Y(2)=4.158739D 0
      Y(3)=5.995615D 0
      Y(4)=4.8D 0
      Y(5)=-29.518749D 0
      Y(6)=156.227451D 0
      RETURN
      END
