* SUBROUTINE UALNH1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE LINEAR FUNCTION HESSIAN MATRIX. THE DENSE CASE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RO  HA(NF*(NF+1)/2)  HESSIAN MATRIX OF THE LINEAR FUNCTION.
*
* SUBPROGRAMS USED :
*  S   UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UALNH1(NF,HA)
      INTEGER NF
      REAL*8 HA(NF*(NF+1)/2)
      CALL UXVSET(NF*(NF+1)/2,0.0D 0,HA)
      RETURN
      END
