* SUBROUTINE UASVF1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE LINEAR APPROXIMATED FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF FUNCTIONS.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RO  AF(NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE STORED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         STORED.
*  IU  LDA  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* COMMON DATA :
*
      SUBROUTINE UASVF1(NA,KA,AF,FA,ISNA,LDA)
      INTEGER NA,KA,ISNA,LDA
      REAL*8 AF(NA),FA
      IF (ISNA.GT.0) THEN
      AF(KA)=FA
      IF (KA.EQ.NA) LDA=MAX(LDA,0)
      ENDIF
      RETURN
      END
