* SUBROUTINE UNFUN3                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* THE CUBIC EQUATION FOR THE DETERMINATION OF THE SHIFT PARAMETER.
*
* PARAMETERS :
*  RI  X  CURRENT VALUE OF A VARIABLE.
*
      FUNCTION UNFUN3(X)
      REAL*8 B,AA,AH,CH
      COMMON /UMFUN3/ B,AA,AH,CH
      REAL*8 X,UNFUN3
      REAL*8 Y,D,DD
      REAL*8 ZERO,ONE,TWO,THREE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0,TWO=2.0D 0,THREE=3.0D 0)
      D=AH*CH-B*B
      Y=B*X
      DD=ABS(AA*B*D)
      IF (DD.EQ.ZERO) DD=ONE
      UNFUN3=((((B+AA)*Y+TWO*D)*Y+(THREE*AA-B)*D)*Y-TWO*AA*B*D)/DD
      END
