* SUBROUTINE UOGRD2                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
* GRAPHICAL OUTPUT - OPTIONS.
*
* COMMON DATA :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  IA  IVAR  AUXILIARY VARIABLE
*  IA  JVAR  AUXILIARY VARIABLE
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANS.
*
      SUBROUTINE UOGRD2(XDEL,XMAX,FMIN,FMAX,RPF1,RPF2,RPF3,RPF4,
     & RPF5,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,
     & ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,
     & ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KTERS,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,IRES2)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KTERS,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,IRES2
      REAL*8 XDEL,XMAX,FMIN,FMAX,RPF1,RPF2,RPF3,RPF4,RPF5,EPS0,EPS1,
     & EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,
     & ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,
     & GAM3,DEL1,DEL2,DEL3
C
C    integer options
C
      CALL UOGITX(-70,1,37,MET  ,'MET  ',3)
      CALL UOGITX( 15,1,37,MET1 ,'MET1 ',3)
      CALL UOGITX(100,1,37,MET2 ,'MET2 ',3)
      CALL UOGITX(185,1,37,MET3 ,'MET3 ',3)
      CALL UOGITX(270,1,37,MET4 ,'MET4 ',3)
      CALL UOGITX(355,1,37,MET5 ,'MET5 ',3)
      CALL UOGITX(-70,2,37,MOT  ,'MOT  ',3)
      CALL UOGITX( 15,2,37,MOT1 ,'MOT1 ',3)
      CALL UOGITX(100,2,37,MOT2 ,'MOT2 ',3)
      CALL UOGITX(185,2,37,MOT3 ,'MOT3 ',3)
      CALL UOGITX(270,2,37,MOT4 ,'MOT4 ',3)
      CALL UOGITX(355,2,37,MOT5 ,'MOT5 ',3)
      CALL UOGITX(-70,3,37,MES  ,'MES  ',3)
      CALL UOGITX( 15,3,37,MES1 ,'MES1 ',3)
      CALL UOGITX(100,3,37,MES2 ,'MES2 ',3)
      CALL UOGITX(185,3,37,MES3 ,'MES3 ',3)
      CALL UOGITX(270,3,37,MES4 ,'MES4 ',3)
      CALL UOGITX(355,3,37,MES5 ,'MES5 ',3)
      CALL UOGITX(-70,4,37,MOS  ,'MOS  ',3)
      CALL UOGITX( 15,4,37,MOS1 ,'MOS1 ',3)
      CALL UOGITX(100,4,37,MOS2 ,'MOS2 ',3)
      CALL UOGITX(185,4,37,MOS3 ,'MOS3 ',3)
      CALL UOGITX(270,4,37,MOS4 ,'MOS4 ',3)
      CALL UOGITX(355,4,37,MOS5 ,'MOS5 ',3)
      CALL UOGITX(-70,5,37,MEP  ,'MEP  ',3)
      CALL UOGITX( 15,5,37,MEP1 ,'MEP1 ',3)
      CALL UOGITX(100,5,37,MEP2 ,'MEP2 ',3)
      CALL UOGITX(185,5,37,MEP3 ,'MEP3 ',3)
      CALL UOGITX(270,5,37,MEP4 ,'MEP4 ',3)
      CALL UOGITX(355,5,37,MEP5 ,'MEP5 ',3)
      CALL UOGITX(-70,6,37,MOP  ,'MOP  ',3)
      CALL UOGITX( 15,6,37,MOP1 ,'MOP1 ',3)
      CALL UOGITX(100,6,37,MOP2 ,'MOP2 ',3)
      CALL UOGITX(185,6,37,MOP3 ,'MOP3 ',3)
      CALL UOGITX(270,6,37,MOP4 ,'MOP4 ',3)
      CALL UOGITX(355,6,37,MOP5 ,'MOP5 ',3)
      CALL UOGITX(-70,7,37,MED  ,'MED  ',3)
      CALL UOGITX( 15,7,37,MED1 ,'MED1 ',3)
      CALL UOGITX(100,7,37,MED2 ,'MED2 ',3)
      CALL UOGITX(185,7,37,MED3 ,'MED3 ',3)
      CALL UOGITX(270,7,37,MED4 ,'MED4 ',3)
      CALL UOGITX(355,7,37,MED5 ,'MED5 ',3)
      CALL UOGITX(-70,8,37,MEX  ,'MEX  ',3)
      CALL UOGITX( 15,8,37,MEX1 ,'MEX1 ',3)
      CALL UOGITX(100,8,37,MEX2 ,'MEX2 ',3)
      CALL UOGITX(185,8,37,MEX3 ,'MEX3 ',3)
      CALL UOGITX(270,8,37,MEX4 ,'MEX4 ',3)
      CALL UOGITX(355,8,37,MEX5 ,'MEX5 ',3)
      CALL UOGITX(-70,9,37,MFP  ,'MFP  ',3)
      CALL UOGITX( 15,9,37,MFP1 ,'MFP1 ',3)
      CALL UOGITX(100,9,37,MFP2 ,'MFP2 ',3)
      CALL UOGITX(185,9,37,MLC  ,'MLC  ',3)
      CALL UOGITX(270,9,37,MLC1 ,'MLC1 ',3)
      CALL UOGITX(355,9,37,MLC2 ,'MLC2 ',3)
      CALL UOGITX(-70,10,37,MLP  ,'MLP  ',3)
      CALL UOGITX( 15,10,37,MLP1 ,'MLP1 ',3)
      CALL UOGITX(100,10,37,MLP2 ,'MLP2 ',3)
      CALL UOGITX(185,10,37,MQP  ,'MQP  ',3)
      CALL UOGITX(270,10,37,MQP1 ,'MQP1 ',3)
      CALL UOGITX(355,10,37,MQP2 ,'MQP2 ',3)
      CALL UOGITX(-70,11,37,KTERS,'KTERS',3)
      CALL UOGITX( 15,11,37,INITD,'INITD',3)
      CALL UOGITX(100,11,37,INITS,'INITS',3)
      CALL UOGITX(185,11,37,INITH,'INITH',3)
      CALL UOGITX(270,11,37,IREM ,'IREM ',3)
      CALL UOGITX(355,11,37,IADD ,'IADD ',3)
      CALL UOGITX(-70,12,37,MIT  ,'MIT  ',8)
      CALL UOGITX(100,12,37,MIC  ,'MIC  ',8)
      CALL UOGITX(270,12,37,MRED ,'MRED ',8)
      CALL UOGITX(-70,13,37,MFV  ,'MFV  ',8)
      CALL UOGITX(100,13,37,MCGR ,'MCGR ',8)
      CALL UOGITX(270,13,37,IRES1,'IRES1',8)
      CALL UOGITX(-70,14,37,MFG  ,'MFG  ',8)
      CALL UOGITX(100,14,37,MSTP ,'MSTP ',8)
      CALL UOGITX(270,14,37,IRES2,'IRES2',8)
C
C     real options
C
      CALL UOGRTX(-70,15,37,TOLX ,'TOLX ')
      CALL UOGRTX( 60,15,37,EPS0 ,'EPS0 ')
      CALL UOGRTX(190,15,37,ETA0 ,'ETA0 ')
      CALL UOGRTX(320,15,37,ALF1 ,'ALF1 ')
      CALL UOGRTX(-70,16,37,TOLF ,'TOLF ')
      CALL UOGRTX( 60,16,37,EPS1 ,'EPS1 ')
      CALL UOGRTX(190,16,37,ETA1 ,'ETA1 ')
      CALL UOGRTX(320,16,37,ALF2 ,'ALF2 ')
      CALL UOGRTX(-70,17,37,TOLG ,'TOLG ')
      CALL UOGRTX( 60,17,37,EPS2 ,'EPS2 ')
      CALL UOGRTX(190,17,37,ETA2 ,'ETA2 ')
      CALL UOGRTX(320,17,37,ALF3 ,'ALF3 ')
      CALL UOGRTX(-70,18,37,TOLB ,'TOLB ')
      CALL UOGRTX( 60,18,37,EPS3 ,'EPS3 ')
      CALL UOGRTX(190,18,37,ETA3 ,'ETA3 ')
      CALL UOGRTX(320,18,37,BET1 ,'BET1 ')
      CALL UOGRTX(-70,19,37,TOLC ,'TOLC ')
      CALL UOGRTX( 60,19,37,EPS4 ,'EPS4 ')
      CALL UOGRTX(190,19,37,ETA4 ,'ETA4 ')
      CALL UOGRTX(320,19,37,BET2 ,'BET1 ')
      CALL UOGRTX(-70,20,37,TOLA ,'TOLA ')
      CALL UOGRTX( 60,20,37,EPS5 ,'EPS5 ')
      CALL UOGRTX(190,20,37,ETA5 ,'ETA5 ')
      CALL UOGRTX(320,20,37,BET3 ,'BET3 ')
      CALL UOGRTX(-70,21,37,TOLR ,'TOLR ')
      CALL UOGRTX( 60,21,37,EPS6 ,'EPS6 ')
      CALL UOGRTX(190,21,37,ETA6 ,'ETA6 ')
      CALL UOGRTX(320,21,37,GAM1 ,'GAM1 ')
      CALL UOGRTX(-70,22,37,RPF1 ,'RPF1 ')
      CALL UOGRTX( 60,22,37,EPS7 ,'EPS7 ')
      CALL UOGRTX(190,22,37,ETA7 ,'ETA7 ')
      CALL UOGRTX(320,22,37,GAM2 ,'GAM2 ')
      CALL UOGRTX(-70,23,37,RPF2 ,'RPF2 ')
      CALL UOGRTX( 60,23,37,EPS8 ,'EPS8 ')
      CALL UOGRTX(190,23,37,ETA8 ,'ETA8 ')
      CALL UOGRTX(320,23,37,GAM3 ,'GAM3 ')
      CALL UOGRTX(-70,24,37,RPF3, 'RPF3 ')
      CALL UOGRTX( 60,24,37,EPS9 ,'EPS9 ')
      CALL UOGRTX(190,24,37,ETA9 ,'ETA9 ')
      CALL UOGRTX(320,24,37,DEL1 ,'DEL1 ')
      CALL UOGRTX(-70,25,37,RPF4 ,'RPF4 ')
      CALL UOGRTX( 60,25,37,FMIN ,'FMIN ')
      CALL UOGRTX(190,25,37,FMAX ,'FMAX ')
      CALL UOGRTX(320,25,37,DEL2 ,'DEL2 ')
      CALL UOGRTX(-70,26,37,RPF5 ,'RPF5 ')
      CALL UOGRTX( 60,26,37,XDEL ,'XDEL ')
      CALL UOGRTX(190,26,37,XMAX ,'XMAX ')
      CALL UOGRTX(320,26,37,DEL3 ,'DEL3 ')
      RETURN
      END
