* SUBROUTINE UOJRF4                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRAPHICAL OUTPUT - EXTENDED PATH.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XPA(NPA,3)  VALUES OF SELECTED VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UOJRF4(NF,X,XPA,FL,F,FO,ETA9)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM(4),LLC(28)
      COMMON /UMGRFI/ IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM,LLC
      REAL*8 XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,RGCOM(2)
      COMMON /UMGRFR/ XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,
     & RGCOM
      INTEGER NF
      REAL*4 FL(NGR,NGR),XPA(NPA,3)
      REAL*8 X(NF),F,FO,ETA9
      REAL*8 DVYB(3),HVYB(3),XVYB(3),SVYB(3),XPAI(3)
      REAL*8 CON1,CON2
      PARAMETER(CON1=1.0D-60,CON2=1.0D 60)
      INTEGER IPOM,JPOM,INDEX(3),INMIN(3),IVAR,JVAR,I,IPAC,NPAC
      SAVE IPOM,JPOM,INDEX,INMIN,IVAR,JVAR,IPAC,NPAC,DVYB,HVYB,XVYB,SVYB
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,6) ISP(NS)
    1 CONTINUE
      INDEX(1)=IGR
      INDEX(2)=JGR
      INDEX(3)=KGR
      IPA=MIN(NPA,NIT)
C
C     COMPUTATION OF BOUNDS
C
      NPAC=MIN(NPA,NIT)
      IPAC=MAX(NPAC-IPA+1,1)
      DVYB(1)=X(INDEX(1))
      DVYB(2)=X(INDEX(2))
      DVYB(3)=X(INDEX(3))
      HVYB(1)=X(INDEX(1))
      HVYB(2)=X(INDEX(2))
      HVYB(3)=X(INDEX(3))
      DO 13 I=IPAC,NPAC
      XPAI(1)=XPA(I,1)
      XPAI(2)=XPA(I,2)
      XPAI(3)=XPA(I,3)
      DVYB(1)=MIN(DVYB(1),DBLE(XPAI(1)))
      DVYB(2)=MIN(DVYB(2),DBLE(XPAI(2)))
      DVYB(3)=MIN(DVYB(3),DBLE(XPAI(3)))
      HVYB(1)=MAX(HVYB(1),DBLE(XPAI(1)))
      HVYB(2)=MAX(HVYB(2),DBLE(XPAI(2)))
      HVYB(3)=MAX(HVYB(2),DBLE(XPAI(3)))
   13 CONTINUE
      SVYB(1)=MAX((HVYB(1)-DVYB(1))/TEN,(HVYB(1)+DVYB(1))*1D-6,1.0D-16)
      SVYB(2)=MAX((HVYB(2)-DVYB(2))/TEN,(HVYB(2)+DVYB(2))*1D-6,1.0D-16)
      SVYB(3)=MAX((HVYB(3)-DVYB(3))/TEN,(HVYB(3)+DVYB(3))*1D-6,1.0D-16)
      DVYB(1)=DVYB(1)-SVYB(1)
      DVYB(2)=DVYB(2)-SVYB(2)
      DVYB(3)=DVYB(3)-SVYB(3)
      HVYB(1)=HVYB(1)+SVYB(1)
      HVYB(2)=HVYB(2)+SVYB(2)
      HVYB(3)=HVYB(3)+SVYB(3)
      FO=F
      XVYB(1)=X(INDEX(1))
      XVYB(2)=X(INDEX(2))
      XVYB(3)=X(INDEX(3))
      SVYB(1)=(HVYB(1)-DVYB(1))/(NGR-1)
      SVYB(2)=(HVYB(2)-DVYB(2))/(NGR-1)
      SVYB(3)=(HVYB(3)-DVYB(3))/(NGR-1)
      IMIN=0
      IPOM=0
    2 IPOM=IPOM+1
      JPOM=IPOM
    3 JPOM=JPOM+1
      IMIN=IMIN+1
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    4 IVAR=IVAR+1
      X(INDEX(IPOM))=DVYB(IPOM)+(IVAR-1)*SVYB(IPOM)
      JVAR=0
    5 JVAR=JVAR+1
      X(INDEX(JPOM))=DVYB(JPOM)+(JVAR-1)*SVYB(JPOM)
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    6 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) THEN
      VALMIN=FL(IVAR,JVAR)
      INMIN(IPOM)=IVAR
      INMIN(JPOM)=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 5
      IF (IVAR.LT.NGR) GO TO 4
      X(INDEX(IPOM))=XVYB(IPOM)
      X(INDEX(JPOM))=XVYB(JPOM)
      WRITE(15,'(I5,I5,3D20.12)') IMIN,NGR,FO,VALMIN,VALMAX
      WRITE(15,'(I5,I5,3D20.12)') INDEX(IPOM),INMIN(IPOM),
     & XVYB(IPOM),DVYB(IPOM),HVYB(IPOM)
      WRITE(15,'(I5,I5,3D20.12)') INDEX(JPOM),INMIN(JPOM),
     & XVYB(JPOM),DVYB(JPOM),HVYB(JPOM)
      WRITE(15,'(4D20.12)') ((FL(IVAR,JVAR),IVAR=1,NGR),JVAR=1,NGR)
      IF (JPOM.LT.3) GO TO 3
      IF (IPOM.LT.2) GO TO 2
      F=FO
      IMIN=INMIN(1)
      JMIN=INMIN(2)
      KMIN=INMIN(3)
   20 CONTINUE
      CALL UYEPI1(0)
      RETURN
      END
