* SUBROUTINE UQEDIF                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'ENDIF'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  IU  NIF1 - NUMBER OF NESTED IF-ENDIF WITH CONDIF=.TRUE.
*  IU  NIF2 - NUMBER OF ALL NESTED IF-ENDIF
*  LU  CONDIF - CONDITION OF LAST IF-ENDIF
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQCEOL - CHECK END OF LINE
*
      SUBROUTINE UQEDIF(BUFFER,MLENB,IPOSD,NIF1,NIF2,CONDIF,IER)
      INTEGER MLENB,IPOSD,NIF1,NIF2,IER
      CHARACTER*1 BUFFER(MLENB)
      LOGICAL CONDIF
      CALL UQCEOL(BUFFER,MLENB,IPOSD,IER)
      IF(IER.NE.0) RETURN
      IF(NIF1.EQ.0) GOTO 1
      IF(NIF1.EQ.NIF2) THEN
        NIF1=NIF1-1
        NIF2=NIF1
        CONDIF=.TRUE.
      ELSE
        NIF2=NIF2-1
      ENDIF
      RETURN
C
C ERROR: UNEXPECTED 'ENDIF'
C
    1 IER=35
      RETURN
      END
