* SUBROUTINE UQSADR                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*   SYNTAX ANALYSIS OF DIRECTIVE LINE
*
* PARAMETERS :
*  TU  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF BUFFER
*  IU  IPOS1 - POSITION OF DIRECTIVE IN BUFFER
*  IU  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE IN BUFFER
*  II  MNPAR - MAX. NUMBER OF PARAMETERS
*  IO  NPAR - NUMBER OF PARAMETERS
*  IO  IPOSP(MNPAR) - POSITIONS OF PARAMETERS IN BUFFER
*  IO  ITYPE(MNPAR) - TYPES OF PARAMETERS
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQNEXT - GIVE NEXT WORD FROM BUFFER
*  S   UQCEOL - CHECK END OF LINE
*  S   UQUPCS - CONVERT A SUBSTRING TO UPPERCASE
*
      SUBROUTINE UQSADR(BUFFER,MLENB,IPOS1,IPOS2,IPOSP,MNPAR,NPAR,
     *                  ITYPE,IER)
      INTEGER MLENB,IPOS1,IPOS2,IER,MNPAR,NPAR,IPOSP(MNPAR,2),
     *        ITYPE(MNPAR)
      CHARACTER*1 BUFFER(MLENB)
      INTEGER I,J,K,ITYP
      CALL UQNEXT(BUFFER,MLENB,IPOS1,J,K,IPOS2,ITYP,IER)
      IF(IER.NE.0) RETURN
      IF(ITYP.NE.1) GOTO 3
      NPAR=0
    1 I=K+1
      CALL UQNEXT(BUFFER,MLENB,I,J,K,IPOS2,ITYP,IER)
      IF(IER.NE.0) RETURN
      IF(ITYP.EQ.2) THEN
        CALL UQCEOL(BUFFER,MLENB,K+1,IER)
C IT CAN BE SIMPLE 'IF', REMEMBER POSITION
        IF(IER.NE.0) IPOS1=K
        RETURN
      ELSEIF(ITYP.EQ.5) THEN
        CALL UQUPCS(BUFFER,MLENB,J,K)
      ENDIF
      IF(K.GE.IPOS2) GOTO 2
      NPAR=NPAR+1
      IF(NPAR.LE.MNPAR) THEN
        ITYPE(NPAR)=ITYP
        IPOSP(NPAR,1)=J
        IPOSP(NPAR,2)=K
        IF(ITYP.EQ.6) K=K+1
        GOTO 1
      ENDIF
C
C ERROR: SYNTAX ERROR
C
    2 IER=20
      RETURN
C
C ERROR: '(' EXPECTED
C
    3 IER=21
      RETURN
      END
