* SUBROUTINE UXECMM                ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF RECTANGULAR MATRIX BY A VECTOR.
*
* PARAMETERS :
*  II  N  NUMBER OF ELEMENTS OF VECTOR  V.
*  II  M  NUMBER OF ELEMENTS OF VECTOR  U.
*  II  MM  MAXIMUM NUMBER OF COLUMNS AND ROWS OF MATRIX  XM.
*  RI  A(MM,MM)  RECTANGULAR MATRIX.
*  RI  U(M)  INPUT VECTOR  U.
*  RO  V(N)  OUTPUT VECTOR  V.
*
* SUBPROGRAMS USED :
*
      SUBROUTINE UXECMM(N,M,MM,A,U,V)
      INTEGER M,MM,N,I,J
      REAL*8 U(M),V(N),A(MM,MM),Q
C   Nasobeni 2 rozmerne obdel.matice S (N->MM,M->MM)  vekt. U:  S*U --> V
      DO I=1,N
        Q=0.0D 0
        DO J=1,M
          Q=Q+A(I,J)*U(J)
        END DO
        V(I)=Q
      END DO
      RETURN
      END
