* SUBROUTINE UXELVS                ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* TEST OF SYMMETRY AND OTHER PROPERTIES OF MATRIX.
*
* PARAMETERS :
*  II  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  RI  XR(MM,MM)  MATRIX  XM^T . GM .
*  RI  DEL1  TOLERANCE FOR THE SYMMETRY.
*  RO  DIF  AUXILIARY TEST PARAMETER.
*  RO  SUM  AUXILIARY TEST PARAMETER.
*  IU  N  ORDER OF THE CURRENT BLOCK.
*
      SUBROUTINE UXELVS(M,MM,XR,DEL1,DIF,SUM,N)
      INTEGER M,MM, I,J,N
      REAL*8 XR(MM,MM),DEL1,DIF,Q,SUM,W
C   test symetrie+vlastnosti matice  S^T.Y
      N=M
      DO J=2,M
        DO I=1,J-1
          Q=(XR(I,J)-XR(J,I))**2/(XR(I,I)*XR(J,J))
          IF(Q.GT.DEL1)N=MIN(N,M-I)
        END DO
      END DO
      DIF=0.0D 0
      SUM=0.0D 0
      IF(M.GE.4)THEN
        DO J=M,M-N+2,-1
          DO I=M-N+1,J-1
            Q=(XR(I,J)-XR(J,I))**2/(XR(I,I)*XR(J,J))
            W=SQRT(ABS(XR(I,J))*ABS(XR(J,I)))/XR(J,J)
            DIF=MAX(DIF,Q)
            IF(I.NE.J-1.AND.J.EQ.M)SUM=SUM+W
          END DO
        END DO
      END IF
      RETURN
      END
