* SUBROUTINE UXSRMI               ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SPARSE RECTANGULAR MATRIX A IS SET TO THE UNIT MATRIX WITH THE SAME
* ORDER.
*
* PARAMETERS :
*  II  NA NUMBER OF COLUMNS OF THE MATRIX A.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD A.
*  RI  A(MA)  RECTANGULAR MATRIX STORED AS A TWO-DIMENSIONAL ARRAY.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD A.
*  II  JA(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD A.
*
      SUBROUTINE UXSRMI(NA,MA,A,IA,JA)
      INTEGER NA,MA,IA(NA+1),JA(MA)
      REAL*8 A(MA)
      INTEGER I,J,K,L,JP
      REAL*8 ZERO,ONE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      DO 2 I=1,NA
      K=IA(I)
      L=IA(I+1)-K
      DO 1 J=1,L
      JP=JA(K)
      IF (JP.EQ.I) THEN
      A(K)=ONE
      ELSE
      A(K)=ZERO
      ENDIF
      K=K+1
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
