* FUNCTION UXUDOT                  ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT OF VECTORS IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*  RR  UXUDOT  VALUE OF DOT PRODUCT UXUDOT=TRANS(X)*Y.
*
      FUNCTION UXUDOT(N,X,Y,IX,JOB)
      INTEGER N,IX(N),JOB
      REAL*8 X(N),Y(N),UXUDOT
      DOUBLE PRECISION TEMP
      INTEGER I
      REAL*8 ZERO
      PARAMETER (ZERO = 0.0D 0)
      TEMP = ZERO
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      TEMP=TEMP+X(I)*Y(I)
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) TEMP=TEMP+X(I)*Y(I)
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) TEMP=TEMP+X(I)*Y(I)
    3 CONTINUE
      ENDIF
      UXUDOT=TEMP
      RETURN
      END
