* SUBROUTINE UXUNEG                ALL SYSTEMS                00/12/01
C PORTABILITY : ALL SYSTEMS
C 00/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COPY OF THE VECTOR WITH INITIATION OF THE ACTIVE PART.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR WHERE Y:= X.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
      SUBROUTINE UXUNEG(N,X,Y,IX,JOB)
      INTEGER N,IX(N),JOB
      REAL*8 X(N),Y(N)
      INTEGER I
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      Y(I)=-X(I)
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) THEN
      Y(I)=-X(I)
      ELSE
      Y(I)=0.0D 0
      ENDIF
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) THEN
      Y(I)=-X(I)
      ELSE
      Y(I)=0.0D 0
      ENDIF
    3 CONTINUE
      ENDIF
      RETURN
      END
