* SUBROUTINE UXVCOR                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CORRECTION OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  CORRECTION FACTOR.
*  RU  X(N)  CORRECTED VECTOR. ZERO ELEMENTS OF X ARE SET TO BE EQUAL A.
*
      SUBROUTINE UXVCOR(N,A,X)
      INTEGER N
      REAL*8  A,X(N)
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      INTEGER I
      DO 1 I=1,N
      IF (X(I).EQ.ZERO) X(I)=A
    1 CONTINUE
      RETURN
      END
