* SUBROUTINE UXVDIS                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR AUGMENTED BY THE SCALED VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:= Y + A*X.
*
      SUBROUTINE UXVDIS(N,A,X,Y,Z)
      INTEGER N
      REAL*8  A, X(N), Y(N), Z(N)
      REAL*8  TEMP
      INTEGER I
      DO 1 I=1,N
      TEMP=Y(I)
      Z(I) = TEMP + A*X(I)
      X(I) = TEMP
    1 CONTINUE
      RETURN
      END
