* FUNCTION UXVDST                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT OF TWO PERMUTED VECTORS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  II  IA(N)  PERMUTATION FIELD.
*  RR  UXVDST  VALUE OF DOT PRODUCT UXVDST=TRANS(X)*Y.
*
      FUNCTION UXVDST(N,X,Y,IA)
      INTEGER N,IA(N)
      REAL*8  X(N), Y(N), UXVDST
      DOUBLE PRECISION TEMP
      INTEGER I,IP
      TEMP = 0.0D0
      DO 1 I=1,N
      IP=IA(I)
      TEMP = TEMP + X(IP)*Y(IP)
    1 CONTINUE
      UXVDST = TEMP
      RETURN
      END
