* SUBROUTINE UXVDUP                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  DIAGONAL BFGS UPDATE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RU  D(N)  UPDATED DIAGONAL MATRIX. THIS MATRIX IS UPDATED SO THAT
*         D(I):=D(I)+Y(I)**2/B-(D(I)*X(I))**2/C FOR ALL I.
*  RI  B  INPUT PARAMETER.
*  RI  C  INPUT PARAMETER.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*
      SUBROUTINE UXVDUP(N,D,B,C,X,Y)
      INTEGER N
      REAL*8 D(N),B,C,X(N),Y(N)
      INTEGER I
      DO 1 I=1,N
      D(I)=D(I)+Y(I)**2/B-(D(I)*X(I))**2/C
    1 CONTINUE
      RETURN
      END
