* SUBROUTINE  UXVETI               ALL SYSTEMS               24/03/92
C PORTABILITY : ALL SYSTEMS
C 24/03/92 TU : ORIGINAL VERSION
*
* PURPOSE : INORDER OF SEPARATION TREE AFTER CLIQUE-2 SEPARATION SCHEME
*
*  PARAMETERS :
*  IA  WN01(N) AUXILIARY VECTOR.
*  IA  WN02(N) AUXILIARY VECTOR.
*  II  N NUMBER OF COLUMN OF THE MATRIX.
*  II  LABEL  INPUT SCHEME OF LABELS
*  II  SON  POLE ZOBRAZUJICI NASLEDNOU STRUKTURU STROMU
*  IO  LABEL2  OUTPUT SCHEME OF LABELS
*
* SUBROUTINES :
*  UXVET3,UXVET4
*
      SUBROUTINE UXVETI(N,LABEL,SON,WN01,WN02,LABEL2)
      INTEGER I,J,IEND,INDEX,K,N,SON(N),WN01(N),LABEL2(N),LABEL(N)
      INTEGER WN02(N)
C  -----------------------
C  INICIALIZACE PROMENNYCH
C  -----------------------
      IEND = 0
      INDEX = 1
      K = 0
      DO 300 I=1, N
        WN01(I) = 0
        WN02(I) = 0
  300 CONTINUE
C  -------------------------------------------------------
C  NALEZENI NEJNIZSI UROVNE STROMU PO JEHO LICHYCH VETVICH
C  -------------------------------------------------------
  50  IF (SON(INDEX) .EQ. 1) THEN
        INDEX = 2 * INDEX + 1
        GO TO 50
      END IF
C  -------------------------------------------------------------
C  VYTVORENI POM. POLI WN01 A WN02 ( SEPARATORY A VEDL. UROVNE )
C  PODLE LABEL ( INTERPRETOVANO PROMENNOU INDEX )
C  -------------------------------------------------------------
  100 CALL UXVET3(N,K,INDEX,WN01,WN02,SON)
      CALL UXVET4(N,K,INDEX,WN01,WN02,IEND)
      IF (IEND .NE. 1) GO TO 100
C  -----------------------
C  VYTVORENI NOVEHO LABEL2
C  -----------------------
      DO 200 I=1, N
        J = LABEL(I)
        IF (J .GT. 0) THEN
          LABEL2(I) = WN01(J)
        ELSE
          IF (MOD(J,2).NE.0) THEN
            LABEL2(I) = WN02(-J)
          ELSE
            LABEL2(I) = -(WN02(-J))
          END IF
        END IF
  200 CONTINUE
      RETURN
      END
