* SUBROUTINE UXVPER                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR X IS PERMUTED USING ELEMENTARY INTERCHANGES STORED IN THE
* FIELD IX.
*
* PARAMETERS :
*  II  N  DIMENSION OF VECTORS X.
*  II  IX(N)  INPUT PERMUTATION VECTOR.
*  RU  X(N)  VECTOR THAT IS TO BE PERMUTED.
*  II  JOB  ORDER OF PERMUTATIONS. JOB>0-STANDARD ORDER. JOB<0-REVERSE
*         ORDER.
*
      SUBROUTINE UXVPER(N,IX,X,JOB)
      INTEGER N,IX(N),JOB
      REAL*8 X(N)
      INTEGER I,K
      REAL*8 T
C      IF (JOB.EQ.0) RETURN
      IF (JOB.GT.0) THEN
      DO 1 I=1,N
      K=IX(I)
      IF (K.NE.I) THEN
      T=X(I)
      X(I)=X(K)
      X(K)=T
      ENDIF
    1 CONTINUE
      ELSE
      DO 2 I=N,1,-1
      K=IX(I)
      IF (K.NE.I) THEN
      T=X(I)
      X(I)=X(K)
      X(K)=T
      ENDIF
    2 CONTINUE
      ENDIF
      RETURN
      END
