* SUBROUTINE UXVRAN                ALL SYSTEMS                99/09/20
* PORTABILITY : ALL SYSTEMS
* 99/09/20 LU : ORIGINAL VERSION
*
* PURPOSE :
* A RANDOM SCALAR IS SET TO ALL ELEMENTS OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  RAN  RANDOM VALUE.
*  RI  X(N)  INPUT AND OUTPUT VECTOR SUCH THAT X(I)=UNRAN1 FOR ALL I
*
      SUBROUTINE UXVRAN(N,RAN,X)
      INTEGER N
      REAL*8  RAN, X(N), UNRAN1, UXVNOR, POM
      INTEGER I
      DO 1 I=1,N
      X(I) = UNRAN1(RAN)
    1 CONTINUE
      POM = UXVNOR(N,X)
      DO 2 I=1,N
      X(I) = X(I)/POM
    2 CONTINUE
      RETURN
      END
