* SUBROUTINE UXVSR5                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SHELLSORT.
*
* PARAMETERS :
*  II  K  NUMBER OF INTEGER VALUES OF THE SORTED ARRAY.
*  II  L  CORRECTION FOR THE ABSOLUTE INDEX IN THE SORTED ARRAY
*  IU  ARRAY(K)  INTEGER SORTED ARRAY.
*  RO  ARRAYC(K)  REAL OUTPUT ARRAY.
*  RU  ARRAYD(K)  REAL ARRAY WHICH IS PERMUTED IN THE SAME WAY
*         AS THE INTEGER SORTED ARRAY.
*
      SUBROUTINE UXVSR5(K,L,ARRAY,ARRAYC,ARRAYD)
      INTEGER K,L
      INTEGER ARRAY(K)
      REAL*8 ARRAYC(*),ARRAYD(K)
      INTEGER IS,LA,LT,LS,LLS,I,J,JS,KHALF
      REAL*8 LD
C
C NOTHING TO BE SORTED
C
      IF(K.LE.1) GO TO 400
C
C SHELLSORT
C
C L - CORRECTION FOR THE ABSOLUTE INDEX IN THE SORTED ARRAY
C
      LS=131071
      KHALF=K/2
      DO 300 LT=1,17
        IF(LS.GT.KHALF) THEN
          LS=LS/2
          GO TO 300
        END IF
        LLS=K-LS
        DO 200 I=1,LLS
          IS=I+LS
          LA=ARRAY(IS)
          LD=ARRAYD(IS)
          J=I
          JS=IS
 100      IF(LA.GE.ARRAY(J)) THEN
            ARRAY(JS)=LA
            ARRAYD(JS)=LD
            ARRAYC(INT(LD))=JS+L
            GO TO 200
          ELSE
            ARRAY(JS)=ARRAY(J)
            ARRAYD(JS)=ARRAYD(J)
            ARRAYC(INT(ARRAYD(J)))=JS+L
            JS=J
            J=J-LS
          END IF
          IF(J.GE.1) GO TO 100
          ARRAY(JS)=LA
          ARRAYD(JS)=LD
          ARRAYC(INT(LD))=JS+L
 200    CONTINUE
        LS=LS/2
 300  CONTINUE
 400  CONTINUE
      RETURN
      END
