* SUBROUTINE  UXVSR6             ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :  ALGORITHM QUICKSORT (SORTED ARRAY B ABOUT ARRAY A WITH
*            ABSOLUTE VALUE OF INTEGER)
*
*  PARAMETERS :
*   II  N NUMBER OF MEMBERS IN A
*   IU  A(N) SORTED ARRAY
*   IU  B(N) SORTED ARRAY
*   IA  LEFT(N) AUXILIARY ARRAY
*   IA  RIGHT(N) AUXILIARY ARRAY
*   II  PAR  METHOD OF SORTED (INCREASELY OR DESCENTLY)
*
      SUBROUTINE UXVSR6(N,A,B,PAR,LEFT,RIGHT)
      INTEGER I,J,K,L,M,N,R,LEFT(N),RIGHT(N),PAR
      INTEGER MID,AB,A(N),B(N),MIDB,BB
      M = 1
      K = 1
      LEFT(K) = 1
      RIGHT(K) = N
C
C  METHOD OF SORTED
C
      IF (PAR.LT.0) GO TO 1000
C
C  INCREASELY
C ------------------
C  FIND OF MEDIAN
C
  100 IF (K.LE.0) GO TO 700
      L = LEFT(K)
      R = RIGHT(K)
      K = K - 1
      IF (R-L.LT.M) GO TO 200
      I = L
      J = R
      MID = A(I)
      MIDB = B(I)
  300 IF (ABS(MID).LT.ABS(A(J))) THEN
        J = J - 1
        GO TO 300
      END IF
      IF (J.LE.I) THEN
        A(I) = MID
        B(I) = MIDB
        GO TO 500
      END IF
      A(I) = A(J)
      B(I) = B(J)
      A(J) = MID
      B(J) = MIDB
      I = I + 1
  400 IF (ABS(A(I)).LT.ABS(MID)) THEN
        I = I + 1
        GO TO 400
      END IF
      IF (J.LE.1) THEN
        I = J
        GO TO 500
      END IF
      A(J) = A(I)
      B(J) = B(I)
      J = J - 1
      GO TO 300
C
C  ALGORITHM QUICKSORT
C
  500 K = K + 1
      IF (R-I.LE.I-L) THEN
        LEFT(K) = I + 1
        RIGHT(K) = R
        R = I - 1
      ELSE
        LEFT(K) = L
        RIGHT(K) = I - 1
        L = I + 1
      END IF
  200 DO 650 J=L+1, R
        AB = A(J)
        BB = B(J)
        I = J - 1
  600   IF (ABS(AB).LT.ABS(A(I)).AND.I.GE.L) THEN
          A(I+1) = A(I)
          B(I+1) = B(I)
          I = I - 1
          GO TO 600
        END IF
        A(I+1) = AB
        B(I+1) = BB
  650 CONTINUE
      GO TO 100
C
C  DESCENTLY
C ------------------
C  FIND OF MEDIAN
C
 1000 IF (K.LE.0) GO TO 700
      L = LEFT(K)
      R = RIGHT(K)
      K = K - 1
      IF (R-L.LT.M) GO TO 1200
      I = L
      J = R
      MID = A(I)
      MIDB = B(I)
 1300 IF (ABS(MID).GT.ABS(A(J))) THEN
        J = J - 1
        GO TO 1300
      END IF
      IF (J.LE.I) THEN
        A(I) = MID
        B(I) = MIDB
        GO TO 1500
      END IF
      A(I) = A(J)
      B(I) = B(J)
      A(J) = MID
      B(J) = MIDB
      I = I + 1
 1400 IF (ABS(A(I)).GT.ABS(MID)) THEN
        I = I + 1
        GO TO 1400
      END IF
      IF (J.LE.1) THEN
        I = J
        GO TO 1500
      END IF
      A(J) = A(I)
      B(J) = B(I)
      J = J - 1
      GO TO 1300
C
C  ALGORITHM QUICKSORT
C
 1500 K = K + 1
      IF (R-I.LE.I-L) THEN
        LEFT(K) = I + 1
        RIGHT(K) = R
        R = I - 1
      ELSE
        LEFT(K) = L
        RIGHT(K) = I - 1
        L = I + 1
      END IF
 1200 DO 1650 J=L+1, R
        AB = A(J)
        BB = B(J)
        I = J - 1
 1600   IF (ABS(AB).GT.ABS(A(I)).AND.I.GE.L) THEN
          A(I+1) = A(I)
          B(I+1) = B(I)
          I = I - 1
          GO TO 1600
        END IF
        A(I+1) = AB
        B(I+1) = BB
 1650 CONTINUE
      GO TO 1000
  700 RETURN
      END
