* SUBROUTINE UXVSWI                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SWAP OF TWO VECTORS WITH INCREMENTS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  FIRST  VECTOR.
*  RO  Y(N)  SECOND VECTOR.
*  II  K  INCREMENT.
*
      SUBROUTINE UXVSWI(N,X,Y,K)
      INTEGER N,K
      REAL*8  X(*),Y(*)
      REAL*8 TEMP
      INTEGER I,J
      I=1
      DO 1 J=1,N
      TEMP=Y(I)
      Y(I)=X(I)
      X(I)=TEMP
      I=I+K
    1 CONTINUE
      RETURN
      END
