* SUBROUTINE UYGSET                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF SIMPLE BOUNDS FOR THE GLOBAL OPTIMIZATION.
*
* PARAMETERS:
*  II  NF DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RU  XL(NF)  VECTOR OF LOWER BOUNDS.
*  RU  XU(NF)  VECTOR OF UPPER BOUNDS.
*  II  XMAX  RADIUS OF THE ACCEPTABLE DOMAIN.
*
* SUBPROGRAMS USED :
*
      SUBROUTINE UYGSET(NF,X,XL,XU,XMAX)
      INTEGER NF
      REAL*8 X(NF),XL(NF),XU(NF),XMAX
      INTEGER I
      DO 1 I=1,NF
      IF (XU(I).LE.XL(I)) THEN
      XL(I)=X(I)-XMAX
      XU(I)=X(I)+XMAX
      ENDIF
    1 CONTINUE
      RETURN
      END
