$INTERFACE U1FDU4                                             97/12/01
$REM VL

  $AX='AX'
  $AY='AG'
  $AZ='AF'
  $N='N'
  $HERF='D'
  $ADD(REAL,'\GAM\DF')
  $ADD(REAL,'\UXVDOT\UXVSAB')
  $ADD(INTEGER,'\NNEW\NFVC\LQ')
  $ADD(INTEGER,'\IMD')
  $HELP
    NUMBER OF BUNDLE POINTS:
  $CHECK(MB,0,INT,2,NO)
  $IF(MB<=0)  $MB='$NF+3'
  $ADD(INIT)
    MB=$MB
  $ENDADD
  $TYPE='L'
  $DECOMP='I'
  $NUMBER=1
  $KDS=1
  $IF(TYPE='L')
    $LCS=0
    $STEP=6
    $MES3=0
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $UPDATE='V'
  $HELP
    TYPE OF PROBLEM:
      0 - CONVEX PROBLEM
      1 - NONCONVEX PROBLEM
  $CHECK(MEX,1,'0\1',3)
  $IF(MEX=0)
    $ETA5='0.0$P 0'
  $ENDIF
  $HELP
    MEASURE OF NONCONVEXITY
  $CHECK(ETA5,'0.25$P 0',REAL,3)
  $IRES1=111
  $IRES2=999
  $MTESX=20
  $MTESF=7
  $ADD(INIT)
    ISNA=$ISNA
  $ENDADD
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
   N=NF
  $IF(NAL>0)
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
    $IF(NORMF>0) $SUBST('UATRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR<>'U') $SUBST('UYFP$(CONSTR)1')
  $DEC='G'
*
*     -----------------------------
*     BUNDLE VARIABLE METRIC METHOD
*     TEMPLATE : U1FDU4
*     -----------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  NB=0
  MB=$MB
  IF (MB.GT.NF) MB=NF+3
  NNEW=0
  NFVC=0
  GAM=ONE
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $SUBST('UZMODN')
  GO TO IMD
$L=$ 20 ; $LABEL
  DF=ABS(F)+ONE
  $SUBST('UYBUN1')
$L=$ 30 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT5')
  IF (ITERM.NE.0) GO TO $90
  $IF(CONSTR<>'U')
    $IF(MLC=1)
      $SUBST('UYRM$(CONSTR)0')
    $ELSE
      $SUBST('UYRM$(CONSTR)1')
    $ENDIF
  $ENDIF
$L=$ 40 ; $LABEL
  $GN=G
  $SUBST('UUDSD1')
  IF (ITERM.NE.0) GO TO $90
  $MAT='G'
  $DEC='I'
  $DECOMG='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$NUMBER
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$NUMBER')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(TYPE='L')
    $SUBST('UD1TL2')
  $ENDIF
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $40
$L=$ 50 ; $LABEL
  $SUBST('UYTRUS')
  $IF(TYPE='L')
    RMAX=XMAX/SNORM
    RMIN=1.0$P-8
  $ENDIF
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 64 ; $LABEL
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  P=UXVDOT(NF,$G,$S)
  IF (P.NE.PO) THEN
  $SUBST('UYBUN1')
  ENDIF
  IF(ITERS.EQ.0) CALL UXVCOP(N,$XO,$X)
  CALL UXVDIF(N,$G,$GO,$XO)
  IF(ITERS.EQ.0) CALL UXVCOP(N,$GO,$G)
  IF(SNORM.NE.ZERO.AND.P.GT.PO) GAM=((P-PO)/(R*SNORM**2)*TWO+GAM)&
  /THREE
  IF(ITERS.EQ.0) F=FO
  MET=1
  IF(NFVC.GT.MB+6.AND.NNEW.GT.NFVC*4/5.AND.LQ.LT.0.AND.UXVSAB(N,XO).NE.&
  ZERO) THEN
  NNEW=0
  NFVC=0
  PAR=MIN(FIVE,MAX(1.0D-1,GAM))
  ELSE
  IF(P.EQ.PO.AND.ITERS.GT.0) MET=0
  IF(P.LE.PO) THEN
  CALL UYRES1('UPDATE  ')
  MET=0
  ENDIF
  PAR=PO-P
  ENDIF
  $SUBST('UUD$(UPDATE)I1')
  $KHLP=4
  $IF(MLC=1) $KHLP=0
  $IF(CONSTR<>'U')
    IF (IDIR.EQ.0) THEN
    $SUBST('UYAD$(CONSTR)$(KHLP)')
    ENDIF
  $ENDIF
  GOTO $30
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UATRL1')
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FDU4'
  $ENDADD
  $EXIT
