$INTERFACE U1LDL1                                             97/12/01
$REM LU

  $TYPE='L'
  $HELP
    METHOD
      1 - PRIMAL NULL SPACE  LINEAR PROGRAMMING METHOD
      2 - PRIMAL RANGE SPACE LINEAR PROGRAMMING METHOD
  $CHECK(NUMBER,1,'1\2',2,NO)
  $HELP
    PRECISION FOR EITHER LINEAR OR QUADRATIC PROGRAMMING SUBROUTINE
  $CHECK(EPS7,'1.0$P-10',REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-8',REAL,4)
  $KD=1
  $ADD(INIT)
    MFP=2
    NXFU='U1LDL1'
  $ENDADD
  KD=1
  JOUT=1
  IF(ABS(KOUT).EQ.2) KOUT=SIGN(4,KOUT)
$REM  IF(ABS(MOUT).EQ.1) MOUT=SIGN(3,MOUT)
  IF(ABS(MOUT).EQ.2) MOUT=SIGN(4,MOUT)
  $SUBST('UO0FU1')
  $SUBST('UZMODL')
  $IF(NORMF>0) $SUBST('UYTRUG')
  $IF(NCL>0)
    $MCL='$NCL'
     MCL=NCL
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $SUBST('UCLNF2')
    $IF(NORMF>0) $SUBST('UCTRL1')
  $ENDIF
*
*     -------------------
*     SIMPLEX-TYPE METHOD
*     TEMPLATE : U1LDL1
*     -------------------
*
   LCS=0
  $IXA='IX'
  $JOB=0
  $IF(NUMBER=1)
    $SUBST('ULLPB1')
  $ELSE
    $SUBST('ULLPB2')
  $ENDIF
  $ADD(INIT)
    NDXX=NLPX
  $ENDADD
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  ITERM=ITERL
  NIT=NRED
  NFV=2
  CALL UYSET2
  $SUBST('UZMODL')
  GMAX=0.0$P 0
  KDC=0
  ISNC=1
  $SUBST('UO1FN2')
$EXIT

