$INTERFACE UA0SP2                                             14/12/01

  $KD=1
  $SUBST('UZASET')
  $KD=0
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $HELP
    EXPONENT IN SUM OF POWERS
  $CHECK(REXP,'2.0$P 0',REAL,2)
$REM  $ADD(REAL,'\FA\F')
$REM  $ADD(INTEGER,'\NF\NA\NAL\KA')
        $IF($DEF(NUMDER))
          $IF(NUMDER<>3)
 $00        CALL UA1SP1(NF,NA,NAL,KA,$GA,$G,FA,F,$REXP)
            $ADD(REAL,'\$GA($NF)\$G($NF)')
          $ELSE
 $00        CALL UA0SP2(NF,NA,NAL,KA,FA,F,$REXP)
          $ENDIF
        $ELSE
 $00      CALL UA1SP1(NF,NA,NAL,KA,$GA,$G,FA,F,$REXP)
          $ADD(REAL,'\$GA($NF)\$G($NF)')
        $ENDIF
      GO TO ($50,$10,$20) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF1')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<$NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF1')
          $ENDIF
          $IF(FMODA<>'F')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              IF (IREST.NE.0) THEN
              $SUBST('UASVG1')
              ENDIF
            $ENDIF
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $IF(SAVA>0)
        IF(LDA.GE.1) THEN
        $IF($DEF(NUMDER))
          $IF(NUMDER<>3) $SUBST('UALNG1')
        $ELSE
          $SUBST('UALNG1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $IF($DEF(NUMDER))
          $IF(NUMDER<>3) $SUBST('UALNG1')
        $ELSE
          $SUBST('UALNG1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<1)
        $IF(NAL<$NA)
          $IF(GMODA='G')
            $MTYPE='G'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF($DEF(NUMDER))
            $ELSE
              $IF(ISNA>1)
                IF (IREST.NE.0) THEN
                $SUBST('UASVG1')
                ENDIF
              $ENDIF
            $ENDIF
            GO TO $00
          $ELSEIF(FMODA='F')
            $IF($DEF(NUMDER))
              $IF(NUMDER=3)
                $SUBST('UA0G$(CON)5')
              $ELSE
                $SUBST('UA0G$(CON)1')
              $ENDIF
            $ELSE
              $SUBST('UA0G$(CON)1')
            $ENDIF
            GO TO ($40,$30) ISB+1
 $30  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $20
 $40  CONTINUE
            $IF($DEF(NUMDER))
            $ELSE
              $IF(ISNA>1)
                IF (IREST.NE.0) THEN
                $SUBST('UASVG1')
                ENDIF
              $ENDIF
            $ENDIF
            GO TO $00
          $ELSE
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF($DEF(NUMDER))
            $ELSE
              $IF(ISNA>1)
                IF (IREST.NE.0) THEN
                $SUBST('UASVG1')
                ENDIF
              $ENDIF
            $ENDIF
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $ADD(INIT)
        NAXX='UA0SP2'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0SP2             ALL SYSTEMS                 07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  REXP  EXPONENT IN A SUM OF POWERS.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  IO  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  IU  NAV  NUMBER OF APPROXIMATED FUNCTION VALUES COMPUTED.
*  IU  NAG  NUMBER OF APPROXIMATED FUNCTION GRADIENTS COMPUTED.
*  IU  NFV  NUMBER OF OBJECTIVE FUNCTION VALUES COMPUTED.
*  IU  NFG  NUMBER OF OBJECTIVE FUNCTION GRADIENTS COMPUTED.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXVSET  INITIATION OF A VECTOR.
*  S  UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*
      SUBROUTINE UA0SP2(NF,NA,NAL,KA,FA,F,REXP)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,NAL,KA
      $FLOAT FA,F,REXP
      $FLOAT FTEMP
      SAVE FTEMP
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,4,6) ISP(NS)
    1 CONTINUE
      IF (REXP.LE.ONE) REXP=TWO
      IF (KD.LE.LD) GO TO 10
      IF (KD.GE.0.AND.LD.LT.0) F=ZERO
C      IF (KD.GE.1.AND.LD.LT.1) CALL UXVSET(NF,ZERO,G)
      KA=1
    2 IF (KA.GT.NA) GO TO 9
      IF (KD.LT.0) GO TO 7
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (LD.GE.0) GO TO 5
      FTEMP=ABS(FA)**REXP
      F=F+FTEMP
    5 IF (KD.LT.1) GO TO 7
      CALL UYSET0(2,3)
      RETURN
    6 CONTINUE
    7 KA=KA+1
      GO TO 2
    9 IF (KD.GE.0.AND.LD.LT.0) F=F/REXP
      NFV=NAV/(NA-NAL)
      NFG=NAG/(NA-NAL)
      LD=KD
   10 CALL UYEPI1(-1)
      RETURN
      END
