$INTERFACE UA1F02                                             97/12/01

 $00  CONTINUE
      $ADD(INTEGER,'\LDPOM')
$REM      $LDPOM=LDA
      LDPOM=LDA
      $IF(JACA='D')
        CALL UXVSET((NA-NAL)*NF,ZERO,$AG(NAL*NF+1))
      $ENDIF
      CALL UA1F02
      GOTO ($40,$10,$20) ISB+1
 $10  CONTINUE
      $MTYPE=FMODA
      $SUBST('UZAMOD')
      $IF(KBA>0)
        CALL UXVDIF(NA,$AF,$AM,$AF)
      $ENDIF
      $GO TO $00
 $20  CONTINUE
      IDECA=0
      $IF(GMODA='G')
        $MTYPE='G'
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        GOTO $00
      $ELSEIF(FMODA='F')
        $IF(JACA='S')
          $SUBST('UA0G$(CON)4')
        $ELSEIF($DEF(NUMDER))
          $IF(NUMDER=3)
            $SUBST('UA0G$(CON)6')
          $ELSE
            $SUBST('UA0G$(CON)2')
          $ENDIF
        $ELSE
          $SUBST('UA0G$(CON)2')
        $ENDIF
        GOTO ($00,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODA
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        GO TO $20
      $ELSE
        $ADD(REAL,'\$AF($NA)\$AFO($NA)')
        IF (LDA.GE.LDPOM) GOTO $00
        CALL UXVCOP(NA,$AF,$AFO)
        $MTYPE=FMODA
        $SUBST('UZAMOD')
        $IF(KBA>0)
          CALL UXVDIF(NA,$AF,$AM,$AF)
        $ENDIF
        CALL UXVCOP(NA,$AFO,$AF)
        GO TO $00
      $ENDIF
 $40  CONTINUE
      $ADD(INIT)
        NAXX='UA1F02'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA1F02                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SIMULTANEOUS COMPUTATION OF THE APPROXIMATED FUNCTION VALUES AND
* GRADIENTS.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LDA  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UA1F02
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,2,4) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 5
      IF (LDA.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      LDA=0
    3 IF (KD.LT.1) GO TO 5
      IF (LDA.GE.1) GO TO 5
      CALL UYSET0(2,3)
      RETURN
    4 CONTINUE
      LDA=1
    5 CALL UYEPI1(-1)
      RETURN
      END
