$INTERFACE UASTH1                                             97/12/01

  CALL UASTH1(NF,NA,KA,$AH,$HA)
  $ADD(REAL,'\$AH($NF*$NA*($NF+1)/2)\$HA($NF*($NF+1)/2)')
$REM  $ADD(INTEGER,'\NF\NA\KA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UASTH1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE LINEAR FUNCTION HESSIAN MATRIX. THE DENSE CASE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  AH(NF*NA*(NF+1)/2) SIMULTANEOUSLY COMPUTED DENSE HESSIAN
*         MATRICES.
*  RO  HA(NF*(NF+1)/2)  SELECTED DENSE HESSSIAN MATRIX.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UASTH1(NF,NA,KA,AH,HA)
      INTEGER NF,NA,KA
      $FLOAT AH(NF*NA*(NF+1)/2),HA(NF*(NF+1)/2)
      CALL UXVCOP(NF*(NF+1)/2,AH(NF*(KA-1)*(NF+1)/2+1),HA)
      RETURN
      END
