$INTERFACE UC1F01                                             97/12/01

      $SUBST('UZCSET')
      $ADD(REAL,'\$CF($NC)\$CL($NC)\$CU($NC)')
$REM      $ADD(REAL,'\FC\CMAX')
      $ADD(INTEGER,'\$IC($NC)')
$REM      $ADD(INTEGER,'\NC\KC')
 $00  CALL UC1F01(NC,KC,$CF,$IC,$CL,$CU,FC,CMAX)
      GOTO ($50,$10,$20) ISB+1
 $10  CONTINUE
      $IF(SAVC>-1)
        IF(LDC.GE.0) THEN
        FC=$CF(KC)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNF1')
        $IF(ISNC>0)
          $SUBST('UCSVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<0)
        $IF(NCL=NC)
        $ELSE
$REM        $IF(NCL<NC)
          $MTYPE=FMODC
          $SUBST('UZCMOD')
          $IF(NORMC>0) $SUBST('UCNRF1')
          $IF(ISNC>0)
            $SUBST('UCSVF1')
          $ENDIF
          $IF(FMODC<>'F')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $IF(ISNC>2)
                $IF(NORMF>0) CALL UXVMUL($NF,$XN,$GC,$GC,1)
              $ENDIF
              $SUBST('UCSVG1')
            $ENDIF
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $IF(SAVC>0)
        IF(LDC.GE.1) THEN
        $SUBST('UCLNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<1)
        $IF(NCL=NC)
        $ELSE
$REM        $IF(NCL<NC)
          $IF(GMODC='G')
            $MTYPE='G'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $IF(ISNC>2)
                $IF(NORMF>0) CALL UXVMUL($NF,$XN,$GC,$GC,1)
              $ENDIF
              $SUBST('UCSVG1')
            $ENDIF
            GOTO $00
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $25  CONTINUE
            $SUBST('UC0G$(CON)1')
            GOTO ($40,$30) ISB+1
 $30  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            GO TO $25
 $40  CONTINUE
            $IF(ISNC>1)
              $IF(ISNC>2)
                $IF(NORMF>0) CALL UXVMUL($NF,$XN,$GC,$GC,1)
              $ENDIF
              $SUBST('UCSVG1')
            $ENDIF
            GO TO $00
          $ELSE
            IF (LD.LT.0) GOTO $00
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $IF(ISNC>2)
                $IF(NORMF>0) CALL UXVMUL($NF,$XN,$GC,$GC,1)
              $ENDIF
              $SUBST('UCSVG1')
            $ENDIF
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $ADD(INIT)
        NCXX='UC1F01'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UC1F01             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE CONSTRAINT FUNCTION.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  IA  KC  INDEX OF THE CONSTRAINT.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  FC  VALUE OF THE SELECTED CONSTRAINT FUNCTION.
*  RO  CMAX  MAXIMUM CONSTRAINT VIOLATION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UC1F01(NC,KC,CF,IC,CL,CU,FC,CMAX)
      $INCLUDE ('UMCOMM')
      INTEGER NC,KC,IC(NC)
      $FLOAT CF(NC),CL(NC),CU(NC),FC,CMAX
      $FLOAT POM,TEMP
      IF (TSS(NS).NE.'UCXX') CALL UYPRO1('UCXX',-1)
      GO TO (1,3,5) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 7
      IF (LD.LT.0) CMAX=ZERO
      KC=1
    2 IF (KC.GT.NC) GOTO 6
      IF (LD.GE.0) GOTO 4
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      IF (IC(KC).GT.0) THEN
      POM=ZERO
      TEMP=CF(KC)
      IF (IC(KC).EQ.1.OR.IC(KC).GE.3) POM=MIN(POM,TEMP-CL(KC))
      IF (IC(KC).EQ.2.OR.IC(KC).GE.3) POM=MIN(POM,CU(KC)-TEMP)
      IF (POM.LT.ZERO) THEN
      CMAX=MAX(CMAX,-POM)
      ENDIF
      ENDIF
    4 IF (KD.LT.1) GO TO 5
      IF (LD.GE.1) GO TO 5
      IF (LD.GE.0) FC=CF(KC)
      CALL UYSET0(2,3)
      RETURN
    5 CONTINUE
      KC=KC+1
      GO TO 2
    6 CONTINUE
    7 CALL UYEPI1(-1)
      LD=KD
      RETURN
      END
