$INTERFACE UCSET4                                             97/12/01

    CALL UCSET4(NC,NCE,$IC,$CL,$CU)
    $ADD(INTEGER,'\$IC($NC)')
$REM    $ADD(INTEGER,'\NC\NCE')
    $ADD(REAL,'\$CL($NC)\$CU($NC)')

    $EXIT

* IMPLEMENTATION

* SUBROUTINE UCSET4             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF THE VECTOR CONTAINING TYPES OF CONSTRAINTS.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  NCE  NUMBER OF EQUALITY CONSTRAINTS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*
      SUBROUTINE UCSET4(NC,NCE,IC,CL,CU)
      INTEGER NC,NCE,IC(NC)
      $FLOAT CL(NC),CU(NC)
      INTEGER KC
      NCE=0
      DO 2 KC=1,NC
      IF ((IC(KC).EQ.3.OR.IC(KC).EQ.4).AND.CU(KC).LE.CL(KC)) THEN
      NCE=NCE+1
      IC(KC)=5
      ELSE IF (IC(KC).EQ.5.OR.IC(KC).EQ.6) THEN
      CU(KC)=CL(KC)
      NCE=NCE+1
      IC(KC)=5
      ENDIF
    2 CONTINUE
      RETURN
      END




