$INTERFACE UCSET9                                             00/12/01

    $KBF=2
    $XL='XL'
    $XU='XU'
    CALL UCSET9(NF,$X,$IX,$XL,$XU,KBF)
    $ADD(INTEGER,'\$IX($NX)')
$REM    $ADD(INTEGER,'\NF')
    $ADD(REAL,'\$X($NF)\$XL($NF)\$XU($NF)')
    $EXIT

* IMPLEMENTATION

* SUBROUTINE UCSET9             ALL SYSTEMS                   00/12/01
C PORTABILITY : ALL SYSTEMS
C 00/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF THE VECTOR CONTAINING TYPES OF CONSTRAINTS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  II  KBF  VARIABLE WHICH SPECIFIES SIMPLE BOUNDS.
*
      SUBROUTINE UCSET9(NF,X,IX,XL,XU,KBF)
      INTEGER NF,IX(NF),KBF
      $FLOAT X(NF),XL(NF),XU(NF)
      INTEGER I
      KBF=2
      DO 1 I=1,NF
      X(I)=0.0$P 0
      IF(IX(I).EQ.0) THEN
      XL(I)=-1.0$P 6
      XU(I)= 1.0$P 6
      ELSE IF (IX(I).EQ.1) THEN
      XU(I)= 1.0$P 6
      ELSE IF (IX(I).EQ.2) THEN
      XL(I)=-1.0$P 6
      ENDIF
      IX(I)=3
    1 CONTINUE
      RETURN
      END




