* SUBROUTINE UKSGLL                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* FILL THE VECTOR LAM WITH THE COST FUNCTION COEFFICIENTS
* OF THE BASIC COLUMNS.
*
* PARAMETERS :
*  II  M NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  BCOL(MCOLS) NUMBERS OF THE BASIC COLUMNS.
*  RO  LAM(MCOLS) FILLED VECTOR
*  RI  C(MCOLS) COST FUNCTION
*  II  PHASE LP PHASE.
*
      SUBROUTINE UKSGLL(M,MCOLS,BCOL,LAM,C,PHASE,IEXT)
      INTEGER M,MCOLS,BCOL(MCOLS),PHASE,IEXT
      $FLOAT LAM(MCOLS),C(MCOLS)
      INTEGER I,J,IEXT1
      IF(IEXT.EQ.0) THEN
        IEXT1=1
      ELSE
        IEXT1=-1
      ENDIF
      IF(PHASE.EQ.1) IEXT1=1
C
C     FILL VECTOR WITH COST FUNCTION
C
      DO 100 I=1,M
      J=BCOL(I)
      LAM(I)=IEXT1*C(J)
100   CONTINUE
      RETURN
      END
