* SUBROUTINE UNFUN2                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* THE CUBIC EQUATION FOR THE DETERMINATION OF THE SHIFT PARAMETER.
*
* PARAMETERS :
*  RI  X  CURRENT VALUE OS A VARIABLE.
*
      FUNCTION UNFUN2(X)
      $FLOAT A,B,C,AA,BB,CC,AH,BH,CH,PAR
      COMMON /UMFUN2/ A,B,C,AA,BB,CC,AH,BH,CH,PAR
      $FLOAT X,UNFUN2
      $FLOAT D,BT,CT,DT
      $FLOAT ONE,TWO
      PARAMETER (ONE=1.0$P 0,TWO=2.0$P 0)
      D=C/B
      BT=B-X*AH/PAR
      CT=C-X*BH/PAR
      DT=CT/BT
      UNFUN2=(X*CH+CC+PAR*CT*DT+AA*DT*DT-TWO*BB*DT)/
     & (PAR*C*D+A*D*D-C)-ONE
      END
