$INTERFACE UO2FJ4                                             10/12/01

  $IF(GRAPH='EXTERNAL')
    $IF(PATH='YES')
      $JOB=1
      $DIM=2
    $ELSE
      $JOB=2
      $DIM=3
    $ENDIF  
    CALL UO2FJ4(NF,$X,$XPA,$FPA,F,$JOB)
    $ADD(REAL,'\$X($NF)\$FPA($NPA)')
    $ADD(REAL4,'\$XPA($NPA,$DIM)')
  $ELSEIF(GRAPH='INTERNAL')
    $IF(PATH='YES')
      $JOB=1
      $DIM=2
    $ELSE
      $JOB=2
      $DIM=NF
    $ENDIF
    CALL UO2FG4(NF,$X,$XPA,$FPA,F,$JOB)
    $ADD(REAL,'\$X($NF)\$FPA($NPA)')
    $ADD(REAL4,'\$XPA($NPA,$DIM)')
  $ENDIF
$REM  $ADD(REAL,'\F')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UO2FJ4                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRAPHICAL VISUALIZATION OF THE OPTIMIZATION PATH.
*
* COMMON DATA :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  IA  IVAR  AUXILIARY VARIABLE
*  IA  JVAR  AUXILIARY VARIABLE
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANS.
*
      SUBROUTINE UO2FJ4(NF,X,XPA,FPA,F,JOB)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      INTEGER NF,JOB,K,NITG
      DATA NITG /0/
      $FLOAT X(NF),FPA(NPA),F
      REAL*4 XPA(NPA,*)
      IF (NITG.LT.NPA) THEN
      FPA(NITG+1)=F
      IF (JOB.EQ.1) THEN
      XPA(NITG+1,1)=X(IGR)
      XPA(NITG+1,2)=X(JGR)
      ELSE
      XPA(NITG+1,1)=X(IGR)
      XPA(NITG+1,2)=X(JGR)
      XPA(NITG+1,3)=X(KGR)
      ENDIF
      NITG=NITG+1
      ELSE
      DO 9 K=1,NPA-1
      FPA(K)=FPA(K+1)
    9 CONTINUE
      FPA(NPA)=F
      IF (JOB.EQ.1) THEN
      DO 2 K=1,NPA-1
      XPA(K,1)=XPA(K+1,1)
      XPA(K,2)=XPA(K+1,2)
    2 CONTINUE
      XPA(NPA,1)=X(IGR)
      XPA(NPA,2)=X(JGR)
      ELSE
      DO 4 K=1,NPA-1
      XPA(K,1)=XPA(K+1,1)
      XPA(K,2)=XPA(K+1,2)
      XPA(K,3)=XPA(K+1,3)
    4 CONTINUE
      XPA(NPA,1)=X(IGR)
      XPA(NPA,2)=X(JGR)
      XPA(NPA,3)=X(KGR)
      ENDIF
      ENDIF
      RETURN
      END
