* SUBROUTINE UOD0S1                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF ENTRY TO LOCAL SEARCH.
*
* PARAMETERS :
*  RI  XDEL  STEPSIZE PARAMETER.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  TI  NDXX  PRINTED TEXT.
*
      SUBROUTINE UOD0S1(XDEL)
      $INCLUDE('UMCOMM')
      $FLOAT XDEL
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      WRITE(IWR,1) NDXX
    1 FORMAT(' ','LOCAL SEARCH USING',1X,A6)
      WRITE(IWR,2) XDEL
    2 FORMAT(' ',29X,'XDEL  =',$P 10.3)
      RETURN
      END
