* SUBROUTINE UODSD3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ENTRY TO UNCONSTRAINED MINIMIZATION.
*
* COMMON DATA :
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMIZATION. IEXT=1-MAXIMIZATION.
*  II  IOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INITIAL VALUES
*         AND FINAL RESULTS. IOUT=0-NO PRINT. IOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*
* OUTPUT VARIABLES :
*  NIT,NFV,NFG,NFH,NAV,NAG,NAH,NCV,NCG,NCH,NRES,NREM,NADD,F,GMAX,DMAX
*
      SUBROUTINE UODSD3(F,DMAX,GMAX)
      $INCLUDE ('UMCOMM')
      $FLOAT F,DMAX,GMAX
      WRITE ( ITR, 4) NIT,NDECF,
     *                NFV,NAV,NCV,NRES,
     *                NFG,NAG,NCG,NREM,
     *                NFH,NAH,NCH,NADD
    4 FORMAT (/
     *  ' ','NIT =',I5,35X,                           'NDECF=',I5/
     *  ' ','NFV =',I5,5X,'NAV =',I5,5X,'NCV =',I5,5X,'NRES =',I5/
     *  ' ','NFG =',I5,5X,'NAG =',I5,5X,'NCG =',I5,5X,'NREM =',I5/
     *  ' ','NFH =',I5,5X,'NAH =',I5,5X,'NCH =',I5,5X,'NADD =',I5)
      WRITE ( ITR, 8) F,GMAX,DMAX
    8 FORMAT (/ ' ','F =',D13.6,4X,'G =',D13.6,4X,'D =',D13.6)
      RETURN
      END
