$INTERFACE UOJRF4                                             10/12/01

  $FTH='FTH'
  $ADD(INTEGER,'\NFV1\NAV1') 
  $ADD(REAL4,'\$FL($NGR,$NGR)\$FTH($NGR,2)\$XPA($NPA,3)')
  $ADD(REAL,'\$X($NF)')
      $IF(NA>0)
        CALL UXVCOP(NA,$AF,$AFO)
        $ADD(REAL,'\$AFO($NA)')
      $ENDIF
      IF (NF.LE.1) THEN
      WRITE(15,'(2I5)') 0,0
      GO TO $LGR
      ELSE IF (NF.LE.2) THEN
      WRITE(15,'(2I5)') 1,NGR
      ELSE
      WRITE(15,'(2I5)') 3,NGR
      ENDIF
  $50 CONTINUE
      IF (NF.LE.2) THEN
      CALL UOJRF3(NF,$X,$XPA,$FL,F,FO,$ETA9)
      ELSE
      CALL UOJRF4(NF,$X,$XPA,$FL,F,FO,$ETA9)
      ENDIF
      GOTO ($60,$70) ISB+1
  $60 CONTINUE
      $IF(NA>0)
        CALL UXVCOP(NA,$AFO,$AF)
      $ENDIF
      GOTO $LGR
  $70 CONTINUE
      NFV1=NFV
      NAV1=NAV
      $SUBST('UZMODL')
      NFV=NFV1
      NAV=NAV1
      GOTO $50
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOJRF4                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRAPHICAL OUTPUT - EXTENDED PATH.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XPA(NPA,3)  VALUES OF SELECTED VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UOJRF4(NF,X,XPA,FL,F,FO,ETA9)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      INTEGER NF
      REAL*4 FL(NGR,NGR),XPA(NPA,3)
      $FLOAT X(NF),F,FO,ETA9
      $FLOAT DVYB(3),HVYB(3),XVYB(3),SVYB(3),XPAI(3)
      $FLOAT CON1,CON2
      PARAMETER(CON1=1.0$P-60,CON2=1.0$P 60)
      INTEGER IPOM,JPOM,INDEX(3),INMIN(3),IVAR,JVAR,I,IPAC,NPAC
      SAVE IPOM,JPOM,INDEX,INMIN,IVAR,JVAR,IPAC,NPAC,DVYB,HVYB,XVYB,SVYB
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,6) ISP(NS)
    1 CONTINUE
      INDEX(1)=IGR
      INDEX(2)=JGR
      INDEX(3)=KGR
      IPA=MIN(NPA,NIT)
C
C     COMPUTATION OF BOUNDS
C
      NPAC=MIN(NPA,NIT)
      IPAC=MAX(NPAC-IPA+1,1)
      DVYB(1)=X(INDEX(1))
      DVYB(2)=X(INDEX(2))
      DVYB(3)=X(INDEX(3))
      HVYB(1)=X(INDEX(1))
      HVYB(2)=X(INDEX(2))
      HVYB(3)=X(INDEX(3))
      DO 13 I=IPAC,NPAC
      XPAI(1)=XPA(I,1)
      XPAI(2)=XPA(I,2)
      XPAI(3)=XPA(I,3)
      DVYB(1)=MIN(DVYB(1),DBLE(XPAI(1)))
      DVYB(2)=MIN(DVYB(2),DBLE(XPAI(2)))
      DVYB(3)=MIN(DVYB(3),DBLE(XPAI(3)))
      HVYB(1)=MAX(HVYB(1),DBLE(XPAI(1)))
      HVYB(2)=MAX(HVYB(2),DBLE(XPAI(2)))
      HVYB(3)=MAX(HVYB(2),DBLE(XPAI(3)))
   13 CONTINUE
      SVYB(1)=MAX((HVYB(1)-DVYB(1))/TEN,(HVYB(1)+DVYB(1))*1D-6,1.0D-16)
      SVYB(2)=MAX((HVYB(2)-DVYB(2))/TEN,(HVYB(2)+DVYB(2))*1D-6,1.0D-16)
      SVYB(3)=MAX((HVYB(3)-DVYB(3))/TEN,(HVYB(3)+DVYB(3))*1D-6,1.0D-16)
      DVYB(1)=DVYB(1)-SVYB(1)
      DVYB(2)=DVYB(2)-SVYB(2)
      DVYB(3)=DVYB(3)-SVYB(3)
      HVYB(1)=HVYB(1)+SVYB(1)
      HVYB(2)=HVYB(2)+SVYB(2)
      HVYB(3)=HVYB(3)+SVYB(3)
      FO=F
      XVYB(1)=X(INDEX(1))
      XVYB(2)=X(INDEX(2))
      XVYB(3)=X(INDEX(3))
      SVYB(1)=(HVYB(1)-DVYB(1))/(NGR-1)
      SVYB(2)=(HVYB(2)-DVYB(2))/(NGR-1)
      SVYB(3)=(HVYB(3)-DVYB(3))/(NGR-1)
      IMIN=0
      IPOM=0
    2 IPOM=IPOM+1
      JPOM=IPOM
    3 JPOM=JPOM+1
      IMIN=IMIN+1
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    4 IVAR=IVAR+1
      X(INDEX(IPOM))=DVYB(IPOM)+(IVAR-1)*SVYB(IPOM)
      JVAR=0
    5 JVAR=JVAR+1
      X(INDEX(JPOM))=DVYB(JPOM)+(JVAR-1)*SVYB(JPOM)
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    6 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) THEN
      VALMIN=FL(IVAR,JVAR)
      INMIN(IPOM)=IVAR
      INMIN(JPOM)=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 5
      IF (IVAR.LT.NGR) GO TO 4
      X(INDEX(IPOM))=XVYB(IPOM)
      X(INDEX(JPOM))=XVYB(JPOM)
      WRITE(15,'(I5,I5,3D20.12)') IMIN,NGR,FO,VALMIN,VALMAX
      WRITE(15,'(I5,I5,3D20.12)') INDEX(IPOM),INMIN(IPOM),
     & XVYB(IPOM),DVYB(IPOM),HVYB(IPOM)
      WRITE(15,'(I5,I5,3D20.12)') INDEX(JPOM),INMIN(JPOM),
     & XVYB(JPOM),DVYB(JPOM),HVYB(JPOM)
      WRITE(15,'(4D20.12)') ((FL(IVAR,JVAR),IVAR=1,NGR),JVAR=1,NGR)
      IF (JPOM.LT.3) GO TO 3
      IF (IPOM.LT.2) GO TO 2
      F=FO
      IMIN=INMIN(1)
      JMIN=INMIN(2)
      KMIN=INMIN(3)
   20 CONTINUE
      CALL UYEPI1(0)
      RETURN
      END

