* SUBROUTINE UOKLP4                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF LINEAR DEPENDANCE POSTPROCESSOR WORK PROFILE.
*
* PARAMETERS :
*  II  N NUMBER OF VARIABLES.
*  II  M NUMBER OF CONSTRAINTS.
*
* COMMON DATA :
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UOKLP4(N,M)
      INTEGER N,M
      $INCLUDE('UMCOMM')
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      WRITE(IWR,1)
    1 FORMAT(' ','LINEAR DEPENDENCE POSTPROCESSOR STATISTICS')
      WRITE(IWR,2) N,M,ITERL,TLPX
    2 FORMAT(' ','NEW COLUMNS =',I4,2X,'NEW ROWS =',
     *       I4,2X,'ITERL =',I4,2X,A8)
      RETURN
      END
