* SUBROUTINE UOKLP5                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF LINEAR DEPENDANCE POSTPROCESSOR WORK PROFILE.
*
* PARAMETERS:
*  II  MCOLS DIMENSION OF AUXILIARY ARRAY.
*  II  WN01(MCOLS) ARRAY WITH THE INDICES OF ROWS TO BE EXCLUDED.
*  II  IND  NUMBER OF ROWS TO BE EXCLUDED.
*
* COMMON DATA :
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UOKLP5(MCOLS,WN01,IND)
      $INCLUDE('UMCOMM')
      INTEGER MCOLS,WN01(MCOLS),IND
      INTEGER I
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      WRITE(IWR,1)
    1 FORMAT(' ','LINEAR DEPENDENT ROWS EXCLUDED')
      WRITE(IWR,2) (WN01(I),I=1,MIN(IND,50))
    2 FORMAT(' ',2X,10I7:/(2X,11I7))
      RETURN
      END
