$INTERFACE UOT0F1                                             98/12/01

  CALL UOT0F1(NF,NA,NAL,MAL,NC,NCL,MCL,$X,KSF,KCF,KSA,KCA,KSC,KCC)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT0F1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ENTRY TO TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  RI  X(NF)  VECTOR OF VARIABLES.
*
* COMMON DATA :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*
* OUTPUT VARIABLES:
* NEXT,NF,KDF,KSF,KCF,NORMF,NA,NAL,NAP,KDA,KSA,KCA,NORMA,
* NC,NCL,NCP,KDC,KSC,KCC,NORMC,X(NF)
*
      SUBROUTINE UOT0F1(NF,NA,NAL,MAL,NC,NCL,MCL,X,KSF,KCF,KSA,KCA,KSC,
     & KCC)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,NAL,MAL,NC,NCL,MCL,KSF,KCF,KSA,KCA,KSC,KCC
      $FLOAT X(NF)
      INTEGER I
      WRITE ( IWR, 1)  NEXT
    1 FORMAT (/1X,'STANDARD TEST OF EXTERNAL SUBROUTINES'/1X,
     *        37('-')/1X,'PROBLEM NO',I5)
      WRITE ( IWR, 2)  NF,KDF,        KSF,KCF,KBF,ISNF,NORMF,
     &                 NA,NAL,MAL,KDA,KSA,KCA,KBA,ISNA,NORMA,
     &                 NC,NCL,MCL,KDC,KSC,KCC,KBC,ISNC,NORMC
    2 FORMAT ( /' ', 'PROBLEM' / ' ', 7('-') /
     &          ' ','NF=',I5,17X,
     &          'KDF=',I3,1X,'KSF=',I3,1X,'KCF=',I3,1X,
     &          'KBF=',I3,1X,'ISNF=',I3,1X,'NORMF=',I3/
     &          ' ','NA=',I5,1X,'NAL=',I3,1X,'MAL=',I3,1X,
     &          'KDA=',I3,1X,'KSA=',I3,1X,'KCA=',I3,1X,
     &          'KBA=',I3,1X,'ISNA=',I3,1X,'NORMA=',I3/
     &          ' ','NC=',I5,1X,'NCL=',I3,1X,'MCL=',I3,1X,
     &          'KDC=',I3,1X,'KSC=',I3,1X,'KCC=',I3,1X,
     &          'KBC=',I3,1X,'ISNC=',I3,1X,'NORMC=',I3)
      IF (NF.GT.0) THEN
      WRITE(IWR,3)
    3 FORMAT(/1X,'PARAMETERS'/1X,10('-'))
      WRITE(IWR,4) 'X    =',(X(I),I=1,NF)
    4 FORMAT(/1X,A6,4$P 18.10:/(7X,4$P 18.10))
      ENDIF
      WRITE(IWR,5)
    5 FORMAT(/1X,'DERIVATIVES'/1X,11('-'))
      RETURN
      END
