$INTERFACE UOT1F1                                             98/12/01

  $ADD(REAL,'\$GF($NF)')
  $IF(DDEF=0)
  CALL UOT1F1(NF,NE,$GF,$GF,FF,0)
  $ELSE
  $ADD(REAL,'\$DF($NE)')
  CALL UOT1F1(NF,NE,$GF,$DF,FF,1)
  $ENDIF
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT1F1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NE  DECLARED NUMBER OF DIFERENTIAL EQUATIONS.
*  RI  GF(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  DF(NE)  ADDITIONAL DERIVATIVES OF THE OBJECTIVE FUNCTION.
*  RI  FF  VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES:
* FF,GF((NF)
*
      SUBROUTINE UOT1F1(NF,NE,GF,DF,FF,JOB)
      $INCLUDE('UMCOMM')
      INTEGER NF,NE,JOB
      $FLOAT GF(NF),DF(NE),FF
      INTEGER I
      GOTO(1,4) KD+1
    1 WRITE(IWR,2) 'FF A =',FF
    2 FORMAT(/1X,A6,$P 18.10)
      WRITE(IWR,3) 'GF N =',(GF(I),I=1,NF)
      IF (JOB.GT.0) WRITE(IWR,3) 'DF N =',(DF(I),I=1,NE)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 WRITE(IWR,3) 'GF A =', (GF(I),I=1,NF)
      IF (JOB.GT.0) WRITE(IWR,3) 'DF A =',(DF(I),I=1,NE)
      RETURN
      END
