* SUBROUTINE UOTES3                ALL SYSTEMS                05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PARAMETERS:
*  JOB  FORM OF THE PERFORMANCE DATA. JOB=1-ABSOLUTE DATA (TOTAL   
*         NUMBERS). JOB=1-RELATIVE DATA (NUMBERS PER ITERATION).
*
* PURPOSE :
* PRINT OF DATA FOR PERFORMANCE PROFILES.  
*
* COMMON DATA :
*  II  NIT  NUMBER OF ITERATIONS.
*  II  NFV  NUMBER OF FUNCTION VALUE EVALUATIONS.
*  II  NFG  NUMBER OF FUNCTION GRADIENT EVALUATIONS.
*  II  NCGR  NUMBER OF CG ITERATIONS.
*  II  NTIME  CPU TIME.
*
      SUBROUTINE UOTES3(JOB)
      $INCLUDE('UMCOMM')
      INTEGER JOB,INF
      PARAMETER(INF=1111111111)
      IF (ITERM.GE.0.AND.ITERM.LE.10.OR.ITERM.EQ.-6) THEN
      IF (JOB.EQ.1) THEN 
      WRITE(7,'(22X,5I10)')NIT,NFV,NFG,NCGR,NTIME+8
      ELSE IF (JOB.EQ.2) THEN
      WRITE(7,'(22X,5I10)')NIT,1000*MAX(1,NFV)/MAX(1,NIT),
     & 1000*MAX(1,NFG)/MAX(1,NIT),1000*MAX(1,NCGR)/MAX(1,NIT),NTIME+8
      ENDIF
      ELSE
      WRITE(7,'(22X,5I10)')INF,INF,INF,INF,INF
      ENDIF
      RETURN
      END

