$INTERFACE UP0MX1                                             97/12/01

  CALL UP0MX1(NC,$CF,$CP,FC,F)
  $ADD(REAL,'\$CF($NC+1)\$CP($NC)')
$REM  $ADD(REAL,'\FC\F')
$REM  $ADD(INTEGER,'\NC')
  $ADD(INIT)
    NPFX='UP0MX1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0MX1             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE  OF THE L-INFINITY EXACT PENALTY FUNCTION.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  RI  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
      SUBROUTINE UP0MX1(NC,CF,CP,FC,F)
      INTEGER NC
      $FLOAT CF(NC+1),CP(NC),FC,F
      INTEGER KC
      FC=0.0$P 0
      DO 1 KC=1,NC
      FC=MAX(FC,CP(KC)*ABS(CF(KC)))
    1 CONTINUE
      F=CF(NC+1)+FC
      RETURN
      END
