* SUBROUTINE UQDELV                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  DELETE A MACRO VARIABLE FROM THE SYMBOL TABLE
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF A MACRO NAME
*              IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF A MACRO NAME
*              IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  LENST - ACTUAL LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IU  LP - LAST POINTER TO THE SYMBOL TABLE
*  IO  IER - ERROR INDICATOR
*
      SUBROUTINE UQDELV(BUFFER,MLENB,IPOS1,IPOS2,SYMTAB,
     *                  MLENST,LENST,IPOINT,MNP,LP,IER)
      INTEGER MLENB,IPOS1,IPOS2,MLENST,LENST,MNP,LP,IPOINT(MNP,6),IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      INTEGER I,LEN,IP,IPPRED
C
C     FIND MACRO
C
      LEN=IPOS2-IPOS1+1
      IP=LP
    1 IF(LEN.EQ.IPOINT(IP,3)) THEN
        DO 2 I=0,LEN-1
          IF(BUFFER(IPOS1+I).NE.SYMTAB(IPOINT(IP,2)+I)) GOTO 3
    2   CONTINUE
C
C     DELETE MACRO
C
        IF(IPOINT(IP,6).GT.1) GOTO 4
        IF(IP.EQ.LP) THEN
          LP=IPOINT(IP,1)
          LENST=IPOINT(LP,4)
        ELSE
          IPOINT(IPPRED,1)=IPOINT(IP,1)
        ENDIF
        IPOINT(IP,1)=-1
        RETURN
      ENDIF
    3 IPPRED=IP
      IP=IPOINT(IP,1)
      IF(IP.GT.0) GOTO 1
C
C ERROR: ATTEMPT TO OVERWRITE OR DELETE UNDEFINED VARIABLE
C
      IER=7
      RETURN
C
C ERROR: ATTEMPT TO OVERWRITE OR DELETE RO/RA VARIABLE
C
    4 IER=8
      RETURN
      END

