* SUBROUTINE UQEADD                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'ENDADD'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF LINE
*               IN THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IU  NADD - NUMBER OF NESTED ADD-ENDADD
*  II  NMSET1 - POSITION OF THE FIRST CHARACTER OF A MACRO NAME
*  II  NMSET2 - POSITION OF THE LAST CHARACTER OF A MACRO NAME
*  IO  IPOSS0 - STARTING POSITION OF ADD-ENDADD
*  IO  IPOSS1 - STARTING POSITION OF TEXT OF ADD-ENDADD
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQCEOL - CHECK END OF LINE
*  S   UQADDV - APPEND VALUE TO A MACRO
*
      SUBROUTINE UQEADD(BUFFER,MLENB,IPOS1,IPOSD,SYMTAB,MLENST,
     *                  IPOINT,MNP,NADD,NMSET1,NMSET2,IPOSS0,
     *                  IPOSS1,IER)
      INTEGER MLENB,IPOS1,IPOSD,MLENST,MNP,IPOINT(MNP,6),NADD,
     *        NMSET1,NMSET2,IPOSS0,IPOSS1,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      CALL UQCEOL(BUFFER,MLENB,IPOSD,IER)
      IF(IER.NE.0) RETURN
      IF(NADD.EQ.0) GOTO 1
      NADD=NADD-1
      IF(NADD.GT.0) RETURN
      CALL UQADDV(BUFFER,MLENB,NMSET1,NMSET2,IPOSS1,IPOS1-2,SYMTAB,
     *            MLENST,IPOINT,MNP,1,IER)
      IPOS1=IPOSS0
      RETURN
C
C ERROR: UNEXPECTED 'ENDADD'
C
    1 IER=34
      RETURN
      END


