* SUBROUTINE UQESET                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'ENDSET'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF LINE
*               IN THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IU  NSET - NUMBER OF NESTED SET-ENDSET
*  II  NMSET1 - POSITION OF THE FIRST CHARACTER OF A MACRO NAME
*  II  NMSET2 - POSITION OF THE LAST CHARACTER OF A MACRO NAME
*  IO  IPOSS0 - STARTING POSITION OF SET-ENDSET
*  IO  IPOSS1 - STARTING POSITION OF TEXT OF SET-ENDSET
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQCEOL - CHECK END OF LINE
*  S   UQSETV - SET A MACRO TO THE SYMBOL TABLE
*
      SUBROUTINE UQESET(BUFFER,MLENB,IPOS1,IPOSD,SYMTAB,MLENST,IPOINT,
     *                  MNP,NSET,NMSET1,NMSET2,IPOSS0,IPOSS1,IER)
      INTEGER MLENB,IPOS1,IPOSD,MLENST,MNP,IPOINT(MNP,6),NSET,NMSET1,
     *        NMSET2,IPOSS0,IPOSS1,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      CALL UQCEOL(BUFFER,MLENB,IPOSD,IER)
      IF(IER.NE.0) RETURN
      IF(NSET.LE.0) GOTO 1
      NSET=NSET-1
      IF(NSET.GT.0) RETURN
      CALL UQSETV(BUFFER,MLENB,NMSET1,NMSET2,IPOSS1,IPOS1-2,SYMTAB,
     *            MLENST,IPOINT,MNP,1,IER)
      IPOS1=IPOSS0
      RETURN
C
C ERROR: UNEXPECTED 'ENDSET'
C
    1 IER=33
      RETURN
      END


