* SUBROUTINE UQSETS                ALL SYSTEMS               89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE  MACRO=VALUE
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  IPOSM1 - POSITION OF THE FIRST CHARACTER OF MACRO NAME
*  II  IPOSM2 - POSITION OF THE LAST CHARACTER OF MACRO NAME
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQGVAL - GIVE VALUE OF A MACRO
*  S   UQSETV - SET A MACRO TO THE SYMBOL TABLE
*
      SUBROUTINE UQSETS(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,IPOSM1,IPOSM2,IER)
      INTEGER MLENB,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),IPOSM1,
     *        IPOSM2,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      INTEGER IP1,IP2,I,ITYP
      CALL UQNEXT(BUFFER,MLENB,IPOSD,IP1,IP2,IPOS2,ITYP,IER)
      IF(IER.NE.0) RETURN
      IF(ITYP.LT.5.OR.ITYP.GT.9) GOTO 1
      I=1
      IF(ITYP.EQ.5) THEN
        I=2
        CALL UQGVAL(BUFFER,MLENB,IP1,IP2,SYMTAB,MLENST,IP1,IP2,IPOINT,
     *              MNP,IER)
        IF(IER.NE.0) RETURN
      ENDIF
      CALL UQSETV(BUFFER,MLENB,IPOSM1,IPOSM2,IP1,IP2,SYMTAB,MLENST,
     *            IPOINT,MNP,I,IER)
      RETURN
C
C ERROR: IDENTIFIER,STRING,INTEGER CONSTANT,.TRUE. OR .FALSE. EXPECTED
C
    1 IER=30
      RETURN
      END


