* SUBROUTINE UXELVT                 ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* SAVING OF UPPER TRIANGULAR PART OF MATRIX.
*
* PARAMETERS :
*  II  M  NUMBER OF COLUMNS OF MATRICES SS, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES SS, GM.
*  RI  XM(MM,MM)  INPUT MATRIX.
*  RO  HR(M*(M+1)/2)  UPPER TRIANGULAR MATRIX  R  STORED COLUMNWISE.
*
      SUBROUTINE UXELVT(M,MM,XM,HR)
      INTEGER I,J,L,M,MM
      $FLOAT XM(MM,MM),HR(M*(M+1)/2)
C  Ulozeni horni trojuhelnikove casti matice:  hor.trojuh.(XM) -> HR
      L=1
      DO J=1,M
        DO I=1,J
          HR(L)=XM(I,J)
          L=L+1
        END DO
      END DO
      RETURN
      END
