* SUBROUTINE UXSRB5                ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* THIS SUBROUTINE GIVES SIZE OF THE UNMASKED PARTS OF THE INTERSECTION
* OF TWO COLUMNS.
*
*  PARAMETERS :
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  ISTRT BEGINNING OF THE VECTOR FOR THE FIRST NODE.
*  II  ISTOP END OF THE VECTOR FOR THE FIRST NODE.
*  II  JSTRT BEGINNING OF THE VECTOR FOR THE SECOND NODE.
*  II  JSTOP END OF THE VECTOR FOR THE SECOND NODE.
*  II  MASK1(M) MASK VECTOR.
*  II  LEN DESIRED LENGTH OF THE UNMASKED PART OF THE INTERSECTION.
*
      SUBROUTINE UXSRB5(M,ISTRT,ISTOP,JSTRT,JSTOP,MASK1,LEN)
C
      INTEGER M,ISTRT,ISTOP,JSTRT,JSTOP,MASK1(*),LEN
      INTEGER ISUM,KSTRT,KSTOP
C
C COMPUTE INTERSECTION
C
      KSTRT=MAX(ISTRT,JSTRT)
      KSTOP=MIN(ISTOP,JSTOP)
C
C REDUCED LENGTH OF THE ADDITIONAL PART
C IT IS COMPUTED IN THIS WAY FOR THE FIRST PARAMETER OF UXSRB2 MUST
C BE IN BEG
C
      CALL UXSRB2(KSTRT,KSTOP,MASK1,LEN)
      CALL UXSRB2(KSTRT,ISTOP,MASK1,ISUM)
      LEN=ISUM-LEN
      CALL UXSRB2(ISTRT,KSTRT-1,MASK1,ISUM)
      LEN=LEN+ISUM
      RETURN
      END
