* SUBROUTINE UXSSMC                ALL SYSTEMS                88/12/01
C PORTABILITY : ALL SYSTEMS
C 88/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COPYING OF A SPARSE SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRICES A AND B.
*  II  M  NUMBER OF NONZERO ELEMENTS IN THE MATRICES A AND B.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RO  B(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM WHERE B:=A.
*  IO  IB(N)  POINTERS OF THE DIAGONAL ELEMENTS OF B.
*  IO  JB(M)  INDICES OF THE NONZERO ELEMENTS OF B.
*
      SUBROUTINE UXSSMC(N,M,A,IA,JA,B,IB,JB)
      INTEGER N,M,IA(N),JA(M),IB(N),JB(M)
      $FLOAT  A(M),B(M)
      INTEGER I
      DO 100 I=1,M
      B(I)=A(I)
      JB(I)=JA(I)
100   CONTINUE
      DO 200 I=1,N
      IB(I)=IA(I)
200   CONTINUE
      RETURN
      END
