* FUNCTION UXTPDL                  ALL SYSTEMS                03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE MINIMUM DIAGONAL ELEMENT OF A TRIDIAGONAL
* SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RU  D(N)  DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*  IO  INF  INDEX OF THE MINIMUM DIAGONAL ELEMENT OF THE MATRIX T.
*  RR  UXTPDL  MINIMUM DIAGONAL ELEMENT OF THE MATRIX T.
*
      FUNCTION UXTPDL(N,D,INF)
      INTEGER N,INF
      $FLOAT D(N),UXTPDL
      $FLOAT TEMP
      INTEGER I,J
      J=1
      INF=1
      TEMP=D(1)
      DO 1 I=2,N
      IF (TEMP.GT.D(J)) THEN
      INF=J
      TEMP=D(J)
      ENDIF
    1 CONTINUE
      UXTPDL=TEMP
      RETURN
      END
