* FUNCTION UXULAM                  ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT OF VECTORS IN A BOUND CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LT.0.
*  RR  UXULAM  VALUE OF DOT PRODUCT UXULAM=TRANS(X)*Y.
*
      FUNCTION UXULAM(N,X,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT X(N),UXULAM
      INTEGER I
      $FLOAT ZERO
      PARAMETER (ZERO = 0.0$P 0)
      UXULAM = ZERO
      IF (JOB.GT.0) THEN
      DO 1 I=1,N
      IF (IX(I).GE.0) THEN
      ELSE IF (IX(I).EQ.-1.OR.IX(I).EQ.-3) THEN
      UXULAM=MAX(UXULAM, X(I))
      ELSE IF (IX(I).EQ.-2.OR.IX(I).EQ.-4) THEN
      UXULAM=MAX(UXULAM,-X(I))
      ENDIF
    1 CONTINUE
      ENDIF
      RETURN
      END
