* FUNCTION UXVDDT                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT WITH VECTOR DIFFERENCE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RI  Z(N)  INPUT VECTOR.
*  RR  UXVDDT  VALUE OF DOT PRODUCT UXVDDT=TRANS(X)*(Y-Z).
*
      FUNCTION UXVDDT(N,X,Y,Z)
      INTEGER N
      $FLOAT X(N),Y(N),Z(N),UXVDDT
      DOUBLE PRECISION TEMP
      INTEGER I
      TEMP=0.0$P 0
      DO 1 I=1,N
      TEMP=TEMP+X(I)*(Y(I)-Z(I))
    1 CONTINUE
      UXVDDT=TEMP
      RETURN
      END
