* SUBROUTINE UXVEXT                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* EXTREMAL ELEMENTS OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RO  XL  MINIMUM ELEMENT OF THE VECTOR X.
*  RO  XU  MAXIMUM ELEMENT OF THE VECTOR X.
*  IO  IL  INDEX OF MINIMUM ELEMENT.
*  IO  IU  INDEX OF MAXIMUM ELEMENT.
*
      SUBROUTINE UXVEXT(N,X,XL,XU,IL,IU)
      INTEGER N, IL, IU
      $FLOAT  X(N), XL, XU
      INTEGER I
      XL=X(1)
      XU=X(1)
      IL=1
      IU=1
      DO 1 I=2,N
      IF (X(I).LT.XL) THEN
      XL=X(I)
      IL=I
      ENDIF
      IF (X(I).GT.XU) THEN
      XU=X(I)
      IU=I
      ENDIF
    1 CONTINUE
      RETURN
      END
