* SUBROUTINE UXVIPR                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR IY IS PERMUTED USING ELEMENTARY INTERCHANGES STORED IN THE                  
* FIELD IX.
*
* PARAMETERS :
*  II  N  DIMENSION OF VECTORS X.
*  II  IX(N)  INPUT PERMUTATION VECTOR.
*  IO  IY(N)  OUTPUT PERMUTAQTION VECTOR.
*  II  JOB  ORDER OF PERMUTATIONS. JOB>0-STANDARD ORDER. JOB<0-REVERSE
*         ORDER.
*
      SUBROUTINE UXVIPR(N,IX,IY,JOB)
      INTEGER N,IX(N),IY(N),JOB
      INTEGER I,J,K
      IF (JOB.EQ.0) RETURN
      CALL UXVINP(N,IY)
      IF (JOB.GT.0) THEN
      DO 1 I=1,N
      J=IX(I)
      IF (J.NE.I) THEN
      K=IY(I)
      IY(I)=IY(J)
      IY(J)=K
      ENDIF
    1 CONTINUE
      ELSE
      DO 4 I=1,N
      DO 2 J=I,N
      IF (IX(I).EQ.IY(J)) GO TO 3
    2 CONTINUE
    3 IY(J)=IY(I)
      IY(I)=J
    4 CONTINUE
      ENDIF
      RETURN
      END
