* SUBROUTINE UXVSAB             ALL SYSTEMS                   91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* L-1 NORM OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXVSAB  L-1 NORM OF THE VECTOR X.
*

      FUNCTION UXVSAB(N,X)
      INTEGER N
      $FLOAT X(N),UXVSAB
      INTEGER I
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      UXVSAB=ZERO
      DO 1 I=1,N
      UXVSAB=UXVSAB+ABS(X(I))
    1 CONTINUE
      RETURN
      END
