* FUNCTION UYDMIN                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 SI : ORIGINAL VERSION
*
* PURPOSE:
*  WE FOUND TWO MINIMA X1,X2 WITH FUNCTION VALUES F1,F2.
*  IS IT THE SAME LOCAL EXTREM OR NOT ?
*
* PARAMETERS:
*  II  N  DIM. OF PROBLEM
*  RI  F1  FUNCTION VALUE IN X1
*  RI  X1(N)  FIRST POINT
*  RI  F2  FUNCTION VALUE IN X2
*  RI  X2(N)  SECOND POINT
*
      LOGICAL FUNCTION UYDMIN(N,F1,X1,F2,X2)
      INTEGER N
      $FLOAT F1,X1(N),F2,X2(N)
      INTEGER I
C
C  MAX. FUNCTION VALUE DIF., MAX. DISTANCE DIF.
C
      $FLOAT FDIF,DDIF
      PARAMETER (FDIF=1.0$P-4,DDIF=1.0$P-3)
      UYDMIN = .TRUE.
C
C  DIF OF FUNCTION VALUES
C
      IF (ABS(F1-F2).GT.FDIF*MAX(ABS(F1),ABS(F2),1.0$P 0))
     &  RETURN
C
C  DIF OF DISTANCE
C
      DO 10 I=1,N
        IF (ABS(X1(I)-X2(I)).GT.
     &      DDIF*MAX(ABS(X1(I)),ABS(X2(I)), 1.0$P 0)) RETURN
   10 CONTINUE
      UYDMIN = .FALSE.
      END
